; -------------	Divers pour activation LINEDEFS

	; Bits des conditions d'activation

	RsReset
COND_WALK	rs.b	1	; Traverse droite/gauche
COND_SWITCH	rs.b	1	; Interrupteur
;COND_GUN	rs.b	1	; Projectile
COND_GUN	=	COND_SWITCH
COND_BLUEKEY	rs.b	1	; Avoir cl bleue
COND_YELLOWKEY	rs.b	1	; Avoir cl jaune
COND_REDKEY	rs.b	1	; Avoir cl rouge/verte
;COND_MONSTER	rs.b	1	; Monstre seulement

	; Pas de cl

COND_W	=	1<<COND_WALK
COND_S	=	1<<COND_SWITCH
COND_G	=	1<<COND_GUN

	; Cl bleue

COND_BW	=	COND_W+1<<COND_BLUEKEY
COND_BS	=	COND_S+1<<COND_BLUEKEY
COND_BG	=	COND_G+1<<COND_BLUEKEY

	; Cl jaune

COND_YW	=	COND_W+1<<COND_YELLOWKEY
COND_YS	=	COND_S+1<<COND_YELLOWKEY
COND_YG	=	COND_G+1<<COND_YELLOWKEY

	; Cl rouge/verte

COND_RW	=	COND_W+1<<COND_REDKEY
COND_RS	=	COND_S+1<<COND_REDKEY
COND_RG	=	COND_G+1<<COND_REDKEY

; -------------	Vitesses de dplacement

SPD_SLOW	=	1<<7
SPD_MED	=	1<<8
SPD_FAST	=	1<<9
SPD_TURBO	=	1<<10

; -------------	Type du mouvement

	RsReset
SCT_STOP	rs.b	1	; Mouvement gnral  effectuer
SCT_OPENCLOSE	rs.b	1	; Ceilup,Pause,Ceildn
SCT_CLOSEOPEN	rs.b	1	; Ceildn,Pause,Ceilup
SCT_LIFT	rs.b	1	; Floordn,Pause,Floorup
SCT_CEILING	rs.b	1	; Ceil(up or dn)
SCT_FLOOR	rs.b	1	; Floor(up or dn)
SCT_CEILMV	rs.b	1	; Ceil(up then dn then up)
SCT_FLOORMV	rs.b	1	; Floor(up then dn then up)

; -------------	Mouvement en cours

	RsReset
SCM_NONE	rs.b	1
SCM_PAUSE	rs.b	1
SCM_CEILUP	rs.b	1
SCM_FLOORUP	rs.b	1
SCM_CEILDN	rs.b	1
SCM_FLOORDN	rs.b	1

; -------------	Etendue (1 ou tous secteurs taggs ?)

	RsReset
ETENDUE_ONE	rs.b	1
ETENDUE_ALL	rs.b	1

; -------------	Rptition ?
	
	RsReset
REPEAT_NO	rs.b	1
REPEAT_YES	rs.b	1

; -------------	Limites

	RsReset
LIMIT_FLOOR	rs.b	1	; Floor
LIMIT_CEILING	rs.b	1	; Ceiling

LIMIT_LIF	rs.b	1	; Lowest including floor
LIMIT_LIC	rs.b	1	; Lowest including ceiling

LIMIT_HIF	rs.b	1	; Highest including floor
LIMIT_HIC	rs.b	1	; Highest including ceiling

LIMIT_LEF	rs.b	1	; Lowest excluding floor
LIMIT_LEC	rs.b	1	; Lowest excluding ceiling
LIMIT_LECM4	rs.b	1	; Lowest excluding ceiling -4 (portes)

LIMIT_HEF	rs.b	1	; Highest excluding floor
LIMIT_HEC	rs.b	1	; Highest excluding ceiling

LIMIT_HEFP8	rs.b	1	; LIMIT_HEF + 8
LIMIT_NHEF	rs.b	1	; Next higher excluding floor
LIMIT_LICM8	rs.b	1	; LIMIT_LIC - 8

LIMIT_FLOORP8	rs.b	1	; Floor + 8
LIMIT_FLOORP24	rs.b	1	; Floor + 24
LIMIT_FLOORP32	rs.b	1	; Floor + 32
LIMIT_FLOORP512	rs.b	1	; Floor + 512
LIMIT_FLOORPSLT	rs.b	1	; Floor + Shortest Lower Texture

; -------------	Lumire

	RsReset
LIMIT_0	rs.b	1
LIMIT_255	rs.b	1
LIMIT_LE	rs.b	1
LIMIT_HE	rs.b	1
LIMIT_BLINK	rs.b	1

; -------------	Donnes ncessaires pour activation

	RsReset
ACT_ROUTINE	rs.l	1	; Routine de lancement
ACT_REPETE	rs.w	1	; Action avec rptition ?
ACT_CONDITION	rs.b	1	; Condition d'activation
ACT_ETENDUE	rs.b	1	; Etendue (1-Tous secteurs?)
ACT_VITESSE	rs.w	1	; Vitesse
ACT_MVT	rs.b	1	; Mouvement de dpart
ACT_TYPE	rs.b	1	; Type du mouvement
ACT_LIMIT1	rs.b	1	; Limite basse du mvt
ACT_LIMIT2	rs.b	1	; Limite haute du mvt
;ACT_TIME	rs.l	1	; Temps de pause du mouvement
;ACT_SOUND	rs.l	1	; Adresse du son  jouer
;ACT_SOUND_REP	rs.w	1	; Jouer le son en boucle ?
SIZEOF_ACTION	rs.w	1

	; Macro pour activation

DEF_ACTION	MACRO	routine,condition,etendue,vitesse,mvt,type,limit1,limit2,repeat
	dc.l	\1
	dc.w	\2
	dc.b	\3
	dc.b	\4
	dc.w	\5
	dc.b	\6
	dc.b	\7
	dc.b	\8
	dc.b	\9	
	ENDM

; -------------	Activations diverses

DEF_NOACTION	MACRO
	DEF_ACTION	0,0,0,0,0,0,0,0,0
	ENDM

DEF_MANUALDOOR	MACRO	condition,vitesse,type,repeat
	DEF_ACTION	ActInitManualDoor,\4,\1,ETENDUE_ONE,\2,SCM_CEILUP,\3,LIMIT_CEILING,LIMIT_LECM4
	ENDM

DEF_REMOTEDOOR	MACRO	condition,vitesse,mvt,type,repeat
	DEF_ACTION	ActInitRemoteDoor,\5,\1,ETENDUE_ALL,\2,\3,\4,LIMIT_CEILING,LIMIT_LECM4
	ENDM

DEF_MOVINGCEIL	MACRO	condition,mvt,limit1,limit2,repeat
	DEF_ACTION	ActInitMovingCeiling,\5,\1,ETENDUE_ALL,SPD_SLOW,\2,SCT_CEILING,\3,\4
	ENDM

DEF_LIFT	MACRO	condition,vitesse,repeat
	DEF_ACTION	ActInitLift,\3,\1,ETENDUE_ALL,\2,SCM_FLOORDN,SCT_LIFT,LIMIT_LIF,LIMIT_FLOOR
	ENDM

DEF_FLOOR	MACRO	condition,vitesse,mvt,type,limit1,limit2,repeat
	DEF_ACTION	ActInitFloor,\7,\1,ETENDUE_ALL,\2,\3,\4,\5,\6
	ENDM

DEF_DONUT	MACRO	condition,repeat
	DEF_ACTION	ActInitDonut,\2,\1,ETENDUE_ALL,SPD_SLOW,SCM_FLOORDN,SCT_FLOOR,LIMIT_LIF,LIMIT_FLOOR
	ENDM

DEF_STAIR	MACRO	condition,vitesse,repeat
	DEF_ACTION	ActInitStairs,\3,\1,ETENDUE_ALL,\2,SCM_FLOORUP,SCT_FLOOR,LIMIT_FLOOR,LIMIT_FLOOR
	ENDM

DEF_MOVINGFLOOR	MACRO	condition,repeat
	DEF_ACTION	ActInitMovingFloor,\2,\1,ETENDUE_ALL,SPD_SLOW,SCM_FLOORUP,SCT_FLOORMV,LIMIT_LIF,LIMIT_HIF
	ENDM

DEF_STOPMOVINGF	MACRO	condition,repeat
	DEF_ACTION	ActStopMovingFloor,\2,\1,ETENDUE_ALL,0,0,0,0,0
	ENDM

DEF_CRUSHCEIL	MACRO	condition,vitesse,repeat
	DEF_ACTION	ActInitCrushCeil,\3,\1,ETENDUE_ALL,\2,SCM_CEILDN,SCT_CEILMV,LIMIT_FLOORP8,LIMIT_LECM4
	ENDM

DEF_STOPCRUSHC	MACRO	condition,repeat
	DEF_ACTION	ActStopCrushCeil,\2,\1,ETENDUE_ALL,0,0,0,0,0
	ENDM

DEF_EXIT	MACRO	condition
	DEF_ACTION	ActInitExit,REPEAT_YES,\1,ETENDUE_ONE,0,0,0,0,0
	ENDM

DEF_TELEPORT	MACRO	condition,repeat
	DEF_ACTION	ActInitTeleport,\2,\1,ETENDUE_ONE,0,0,0,0,0
	ENDM

DEF_LIGHT	MACRO	condition,limit,repeat
	DEF_ACTION	ActInitLight,\3,\1,ETENDUE_ONE,0,0,0,\2,0
	ENDM
