; ------------------------------
;	Boucle principale du jeu
; ------------------------------

	TEXT
BoucleJeu
	; Recalcule resx et resy

	move	ScreenSize,d0

	moveq	#8,d1
	sub	d0,d1
	move	d1,reszoom

	lea	(Resolutions,d0.w*4),a0
	move	(a0),resx
	clr.l	d1
	move	2(a0),d1
	divu	ScreenRatioY,d1
	move	d1,resy

	DATA
Resolutions	dc.w	96,48
	dc.w	128,64
	dc.w	160,80
	dc.w	192,96
	dc.w	224,112
	dc.w	256,128
	dc.w	288,144
ResolutionStat	dc.w	320,200 ; 200-StbarHeight
ResolutionMax	dc.w	320,200

; -------------	Prpare affichage

	TEXT

	move.l	affiche1,a1

	move	#screenx,d0
	sub	(a0),d0
	lsr	#1,d0
	lea	(a1,d0.w*2),a1

	move	#screeny,d0
	tst	reszoom
	beq.s	screeny200
	sub	StbarHeight,d0
screeny200
	sub	2(a0),d0
	moveq	#1,d1
	cmp	#1,ScreenRatioY
	beq.s	.disp_RatioY
	moveq	#2,d1
	cmp	#3,game_type
	bne.s	.WinHeretic
	addq	#2,d0
.WinHeretic
.disp_RatioY
	lsr	d1,d0
	
	mulu	ScreenLineLen,d0
	add.l	d0,a1
	move.l	a1,affiche

; -------------	Ligne de vise

	move	resy,d1
	lsr	#1,d1

	move	ecr_ligne1,d0
	muls	d1,d0
	asr.l	#7,d0
	add	d1,d0
	
	move	d0,ecr_ligne

; -------------	Routines d'affichage
	
	; murs
	
	lea	RenderTexturedWall1x1,a0
	lea	RenderTexturedWall2x1,a1
	lea	RenderTexturedWallT1x1,a2
	lea	RenderTexturedWallT2x1,a3
	tst	textured_walls
	beq.s	yes_textured_walls
	lea	RenderFlatWall1x1,a0
	lea	RenderFlatWall2x1,a1
	lea	RenderFlatWallT1x1,a2
	lea	RenderFlatWallT2x1,a3
yes_textured_walls
	cmp	#1,ScreenRatioX
	beq.s	.RatioXOk1
	exg.l	a0,a1
	exg.l	a2,a3
.RatioXOk1	move.l	a0,RenderWallRout
	move.l	a2,RenderWallTRout

	; sol et plafond

	lea	RenderTexturedFloor1x1,a2
	lea	RenderTexturedFloor2x1,a3
	lea	RenderTexturedCeiling1x1,a4
	lea	RenderTexturedCeiling2x1,a5
	tst	textured_floors
	beq.s	yes_textured_floors
	lea	RenderFlatFloor1x1,a2
	lea	RenderFlatFloor2x1,a3
	lea	RenderFlatCeiling1x1,a4
	lea	RenderFlatCeiling2x1,a5
yes_textured_floors

	cmp	#1,ScreenRatioX
	beq.s	.RatioXOk
	exg.l	a2,a3
	exg.l	a4,a5
.RatioXOk
	move.l	a2,RenderFloorRout
	move.l	a4,RenderCeilingRout

	; sprite et ciel

	lea	RenderSprite1x1,a0
	lea	RenderSky1x1,a1
	cmp	#1,ScreenRatioX
	beq.s	.RatioXOk1
	lea	RenderSprite2x1,a0
	lea	RenderSky2x1,a1
.RatioXOk1	move.l	a0,RenderSpriteRout
	move.l	a1,RenderSkyRout

; -------------	Choix de l'observateur
;
;	move	num_obj_obs,d0
;	move.l	object_malloc,a0
;	mulu	#SIZEOF_OBJET,d0
;	add.l	d0,a0
;	move.l	a0,obj_observateur
	
; -------------	Vide la carte avant le test de collision

;	move.l	adr_linedefs,a0
;	move.l	num_linedefs,d0
;	subq	#1,d0
;vide_carte	bset	#ALREADY_ON_MAP-8,LINEDEF_ATTRIB(a0)
;	bclr	#WALL_COLLISION-8,LINEDEF_ATTRIB(a0)
;	lea	SIZEOF_LINEDEF(a0),a0
;	dbra	d0,vide_carte

; -------------	C'est parti

	bsr	animation_textures	; Animation des textures
	bsr	ActivateSectors

; -------------	Dplacement de tous les objets

	IFNE	PLAYER_ONLY

	tst.b	K_CONTROL+clavier
	beq.s	.Not_Control
	clr.b	K_CONTROL+clavier
	move.l	obj_observateur,a2
	lea	ProjMissile,a0
	move	OBJET_X(a2),THING_X(a0)
	move	OBJET_Y(a2),THING_Y(a0)
	move	OBJET_A(a2),d0
	mulu	#360/4,d0
	divu	#nb_angles,d0
	move	d0,THING_ANGLE(a0)
	move	#4000,d0
	add	current_weapon,d0
	move	d0,THING_TYPE(a0)
	bsr	CreateObject
.Not_Control
	move.l	obj_observateur,a0	; Test de collision pour objet courant
	tst	noclippingmode
	bne.s	key_help
	bsr	TestCollision
key_help
	move.l	OBJET_X1(a0),OBJET_X(a0)
	move.l	OBJET_Y1(a0),OBJET_Y(a0)
	move.l	OBJET_Z1(a0),OBJET_Z(a0)
	move	OBJET_A1(a0),OBJET_A(a0)
	bsr	MoveObject	; Changement de SSECTOR ?

	tst.b	K_SPACE+clavier
	beq.s	not_espace
	clr.b	K_SPACE+clavier
	bsr	TestActivation
not_espace

	ELSE

	lea	object_malloc,a1
MoveObjects
	tst.l	(a1)
	beq	MoveObjects_done
	move.l	(a1),a1
	lea	4(a1),a0
	move	#MAXOBJPERBLOC-1,d0
MO_bcl	tst	OBJET_PRESENT(a0)
	bne.s	MO_bcl_next
	tst.l	OBJET_LIFE(a0)
	beq.s	MO_bcl_next
	tst	OBJET_FIXE(a0)
	beq.s	MO_bcl_next

	; appeler la routine de controle de l'objet

	; Objet se dplace ?

	tst	noclippingmode
	bne.s	key_help
	movem.l	d0/a0-a1,-(sp)
	bsr	TestCollision
	movem.l	(sp)+,d0/a0-a1
key_help
	move.l	OBJET_X1(a0),OBJET_X(a0)
	move.l	OBJET_Y1(a0),OBJET_Y(a0)
	move.l	OBJET_Z1(a0),OBJET_Z(a0)
	move	OBJET_A1(a0),OBJET_A(a0)
	movem.l	d0/a0-a1,-(sp)
	bsr	MoveObject	; Changement de SSECTOR ?
	movem.l	(sp)+,d0/a0-a1

	; Objet fait activer ?

	tst.b	K_SPACE+clavier
	beq.s	not_espace
	clr.b	K_SPACE+clavier
	movem.l	d0/a0-a1,-(sp)
	bsr	TestActivation
	movem.l	(sp)+,d0/a0-a1
not_espace
	; Objet fait feu ?

	tst.b	K_CONTROL+clavier
	beq.s	not_control
	clr.b	K_CONTROL+clavier
	movem.l	d0/a0-a1,-(sp)

	movem.l	(sp)+,d0/a0-a1
not_control

	; Objet suivant

MO_bcl_next	lea	SIZEOF_OBJET(a0),a0
	dbra	d0,MO_bcl
	bra	MoveObjects
MoveObjects_done
	ENDC

; ------------------------------
;	Affichage 3D ou carte ?
; ------------------------------

	tst	maponscreen
	beq.s	no_maponscreen

; -------------	Afficher la carte

	bsr	AfficheCarte	; Affichage de la carte
	bra.s	fin_affichage
no_maponscreen

; -------------	Afficher la scne

	bsr	AfficheCadre	; Cadre si pas plein ecran
	bsr	BuildScene	; Construction de la scene
	bsr	RenderScene	; Affichage de la scene
fin_affichage

; -------------	Afficher la barre de status

	jsr	([StatusBarRout])
	rts
