; ------------------------------
;	Chargement d'un niveau
; ------------------------------

	TEXT
BoucleChargerNiveau0
	tst.l	demo_malloc
	beq.s	BCN_NoDemo
	SupXazMfree	demo_malloc
	clr.l	demo_malloc
BCN_NoDemo

; -------------	Faire le mnage et les annonces

	TEXT
BoucleChargerNiveau1
	move.l	#AfficheMessages,DisplayMessages
	clr	PrintY

	tst.l	level_malloc
	beq.s	.NoOldLevel
	bsr	DechargerNiveau
.NoOldLevel
	lea	loading_level,a0
	bsr	AjoutMessage
	move.l	#BoucleChargerNiveau11,BouclePrincipale
	IFEQ	DEBUG
	rts
	ENDC

; -------------	Charger le niveau

BoucleChargerNiveau11
	bsr	charger_niveau	; Charger le niveau (game_level)
	tst	d0
	bne	CN_erreur
	move.l	#BoucleChargerNiveau15,BouclePrincipale
	IFEQ	DEBUG
	rts
	ENDC

; -------------	Annoncer construction du cache

BoucleChargerNiveau15
	clr	skill_char
	move	game_skill,d0
	add	#"0",d0
	move.b	d0,skill_char

	lea	loading_skill,a0
	bsr	AjoutMessage
	move.l	#BoucleChargerNiveau16,BouclePrincipale
	IFEQ	DEBUG
	rts
	ENDC

; -------------	Charger le niveau

BoucleChargerNiveau16
	bsr	Niveau_initobjets ; Charger les objets (game_level)
	tst	d0
	bne	CN_erreur
	move.l	#BoucleChargerNiveau2,BouclePrincipale
	IFEQ	DEBUG
	rts
	ENDC

; -------------	Annoncer construction du cache

BoucleChargerNiveau2
	clr	CacheForBrowser
	lea	building_cache,a0
	bsr	AjoutMessage
	move.l	#BoucleChargerNiveau21,BouclePrincipale
	IFEQ	DEBUG
	rts
	ENDC

; -------------	Contruire le cache

BoucleChargerNiveau21
	bsr	TexturesBuildCache ; Charger ses textures
	tst	d0
	bne	CN_erreur
	move.l	#BoucleChargerNiveau3,BouclePrincipale
	IFEQ	DEBUG
	rts
	ENDC

; -------------	Constructions finales

BoucleChargerNiveau3
	bsr	Niveau_initciel	; Initialiser le ciel
	bsr	Niveau_initsidedefs ; Et les textures
	move.l	#BoucleChargerNiveau4,BouclePrincipale
	IFEQ	DEBUG
	rts
	ENDC

; ------------- Annoncer preload murs

BoucleChargerNiveau4
	lea	loading_walls,a0
	bsr	AjoutMessage
	move.l	#BoucleChargerNiveau41,BouclePrincipale
	IFEQ	DEBUG
	rts
	ENDC

; -------------	Faire le preload des murs

BoucleChargerNiveau41
	bsr	Niveau_preloadwalls
	move.l	#BoucleChargerNiveau5,BouclePrincipale
	IFEQ	DEBUG
	rts
	ENDC
	
; ------------- Annoncer preload sol/plafond

BoucleChargerNiveau5
	lea	loading_floors,a0
	bsr	AjoutMessage
	move.l	#BoucleChargerNiveau51,BouclePrincipale
	IFEQ	DEBUG
	rts
	ENDC

; -------------	Faire le preload des murs

BoucleChargerNiveau51
	bsr	Niveau_preloadfloors
	move.l	#BoucleChargerNiveau6,BouclePrincipale
	IFEQ	DEBUG
	rts
	ENDC

; -------------	Init pour le joueur

BoucleChargerNiveau6
	move	#1,d0
	bsr	SearchObjet
	cmp.l	#0,a0
	beq	CN_erreur

;	move	#$140,OBJET_X(a0)
;	move	#$112e,OBJET_Y(a0)
;	move	#$140,OBJET_X1(a0)
;	move	#$112e,OBJET_Y1(a0)
;	clr	OBJET_Z(a0)
;	clr	OBJET_Z1(a0)
;	move	#$4000,OBJET_A(a0)
;	move	#$4000,OBJET_A1(a0)

	move.l	a0,obj_joueur1
	move.l	a0,obj_observateur	; Obs=joueur1
;	move	d1,num_obj_obs

	clr	MenuActif
	clr	display_menu
	
	move.l	#BoucleJeu,BouclePrincipale
	lea	ControleDemo,a0
	tst.l	demo_malloc
	bne.s	.GameNotDemo
	lea	ControleObjet,a0
.GameNotDemo	move.l	a0,ControleVbl

	move.l	#AfficheMessagesLimit,DisplayMessages
	move.l	game_timer,MessagesTime

; -------------	Musique !

	lea	0,a0
	cmp	#1,game_type
	bne	nivmus_doom2?
	lea	DOOM_mus_e1,a0
	moveq	#0,d0
	move.b	game_level+1,d0	; episode
	sub.b	#"1",d0
	mulu	#9,d0
	moveq	#0,d1
	move.b	game_level+3,d1	; map
	sub.b	#"1",d1
	add	d1,d0
	lea	(a0,d0.w*8),a0

nivmus_doom2?	cmp	#2,game_type
	bne	nivmus_heretic?
	lea	DOOM2_mus_map01,a0
	moveq	#0,d0
	move.b	game_level+3,d0	; dizaine
	sub.b	#"0",d0
	moveq	#0,d1
	move.b	game_level+4,d1 ; unite
	sub.b	#"0",d1
	mulu	#10,d0
	add	d1,d0
	subq	#1,d0
	lea	(a0,d0.w*8),a0

nivmus_heretic?
	cmp	#3,game_type
	bne	nivmus_fin
	lea	HERETIC_mus_e1,a0
	moveq	#0,d0
	move.b	game_level+1,d0	; episode
	sub.b	#"1",d0
	mulu	#9,d0
	moveq	#0,d1
	move.b	game_level+3,d1	; map
	sub.b	#"1",d1
	add	d1,d0
	lea	(a0,d0.w*8),a0
nivmus_fin
	cmp.l	#0,a0
	beq	no_nivmus
	bsr	Musique_Play
no_nivmus

	IFEQ	DEBUG
	rts
	ELSE
	bra	BoucleJeu
	ENDC

	BSS

obj_joueur1	ds.l	1	; Adresse de l'objet utilis pour voir
obj_observateur	ds.l	1
num_obj_obs	ds.w	1

; -------------	Suppression du niveau de la mmoire
	
	TEXT
DechargerNiveau
	bsr	free_level
	bsr	free_cachetextures
	rts

; -------------	Erreur

CN_erreur	clr	MenuActif
	clr	TitleNum
	move.l	#ControleTitlePic,ControleVbl
	move.l	#BoucleTitlePic,BouclePrincipale
	rts
	