; ------------------------------
;	Clipping d'un segment
; ------------------------------
; Entre :	seg_orig_x1,seg_orig_y1,seg_orig_x2,seg_orig_y2
; Sortie :	a<0 si seg pas  l'cran sinon
;	seg_x1,seg_y1,seg_x2,seg_y2
;	xe1,xe2,local_longueur

PV_SEG	MACRO
	mpy	y0,x1,a
	mac	-x0,y1,a	; a = y1*x2-x1*y2
	ENDM
	
PV_SUM1	MACRO
	move	x1,b
	add	y1,b
	sub	y0,b
	sub	x0,b	; b= x2+y2-y1-x1
	ENDM

PV_SUM2	MACRO
	move	x1,b
	sub	y1,b
	add	y0,b
	sub	x0,b	; b= x2-y2+y1-x1
	ENDM

PV_DIVISION	MACRO
	move	x,l:sauvegarde
	move	b1,x1
	jsr	<division_signee ; a1=a/b
	move	l:sauvegarde,x
	ENDM

	ORG	p:
ClippingSegment

; -------------	Clipping du segment

	move	x:seg_orig_x1,x0
	move	x:seg_orig_y1,y0
	move	x:seg_orig_x2,x1
	move	x:seg_orig_y2,y1

; -------------	Teste si les deux Y ngatifs

ClippingSegmentRead
	move	y0,a
	tst	a	y1,b
	jpl	<ok_clip
	tst	b
	jmi	<segment_horsecran
ok_clip

; -------------	Clipping du point 1 , droite y=-x

;	move	y0,a
	neg	a	x0,b
	cmp	a,b	y1,a
	jpl	<clip_1		; si x1>-y1 continue
	neg	a	x1,b
	cmp	b,a
	jpl	<segment_horsecran	; si -y2>x2 stop

	PV_SEG
	PV_SUM1
	PV_DIVISION
	
;	move	a1,y0
	tst	a	a1,y0
	jmi	<segment_horsecran
	neg	a
	move	a1,x0
	jmp	<clip_2
clip_1

; -------------	Clipping du point 2 , droite y=-x

;	move	y1,a
	neg	a	x1,b
	cmp	a,b
	jpl	<clip_2		; si x2<-y2 au suivant

	PV_SEG
	PV_SUM1
	PV_DIVISION

;	move	a1,y1
	tst	a	a1,y1
	jpl	<segment_horsecran
	neg	a
	move	a1,x1
clip_2

; -------------	Clipping du point 1 , droite y=x

	move	x0,a
	move	y0,b
	cmp	a,b	x1,a
	jpl	<clip_3		; si x1<y1 alors clip_3
	move	y1,b
	cmp	b,a		; si x2>y2 alors fin
	jpl	<segment_horsecran

	PV_SEG
	PV_SUM2
	PV_DIVISION

;	move	a1,y0
	tst	a	a1,y0
	jpl	<segment_horsecran
	move	a1,x0
	jmp	<clip_4
clip_3

; -------------	Clipping du point 2 , droite y=x

;	move	x1,a
	move	y1,b
	cmp	a,b
	jpl	<clip_4	; si x2<y2 alors fin

	PV_SEG
	PV_SUM2
	PV_DIVISION

;	move	a1,y1
	tst	a	a1,y1
	jmi	<segment_horsecran
	move	a1,x1
clip_4

; -------------	Pas visible si trop prs

	move	#>1*256,b
	move	y0,a
	cmp	b,a	y1,a
	jmi	<segment_horsecran
	cmp	b,a	x0,x:seg_x1
	jmi	<segment_horsecran

; -------------	On sauve le segment clipp

;	move	x0,x:seg_x1
	move	y0,x:seg_y1
	move	x1,x:seg_x2
	move	y1,x:seg_y2

; -------------	Calcul de la projection  l'ecran

	move	#>1,x0
	move	x:resx,b
	sub	x0,b	x:seg_x1,x1
	move	b,x0		; x0 = resx-1

; -------------	Calcul de xe1

	mpy	x0,x1,a	x:seg_y1,x1
	jsr	<division_entiere
	add	x0,a	x:seg_y2,x1
	asr	a	x:seg_x2,y1

; -------------	Calcul de xe2

	mpy	x0,y1,a	a,x:xe1
	jsr	<division_entiere
	add	x0,a
	asr	a	x:xe1,b

; -------------	Dernier test

	sub	b,a	a,x:xe2
	jmi	<segment_horsecran
	clr	a
	rts

; -------------	Segment hors de l'ecran

segment_horsecran
	move	#>-1,a
	rts
