; ---------------------------------------------------------
;	Reception du secteur (plafond,sol,lumiere)
; ---------------------------------------------------------

	ORG	x:

local_ceiling2	ds	1
local_floor2	ds	1
linedef_attrib	ds	1

ye1	ds	1	; y minimal pour le mur
ye2	ds	1	; y maximal pour le mur

upper_texture	ds	1
lower_texture	ds	1

	; Linedef_attrib flags

IMPASSABLE	equ	0
MONSTER_BLOCK	equ	1
TWO_SIDED	equ	2
UPPER_UNPEGGED	equ	3
LOWER_UNPEGGED	equ	4
SECRET	equ	5
SOUND_BLOCK	equ	6
NOT_ON_MAP	equ	7

ALREADY_ON_MAP	equ	8	; Flags  usage interne
BETWEEN_UPSKY	equ	9
BETWEEN_DNSKY	equ	10
TEXTLSCROLL	equ	11
TEXTRSCROLL	equ	12
;WALL_COLLISION	equ	13

	ORG	p:
EmpileLinedef
	READHOST	x:sidedef_offsetx
	READHOST	x:sidedef_offsety
	READHOST	x1
	READHOST	y1
	READHOST	x:linedef_attrib
	READHOST	x:upper_texture	; Nb texture suprieure
	READHOST	x:lower_texture	; Nb texture infrieure
	READHOST	x:local_sinus
	READHOST	x:local_cosinus

; -------------	Calcul sol/plafond

	move	#>128,x0
	mpy	x1,x0,a	x:player_h,y0
	mpy	y1,x0,b	a0,a
	sub	y0,a	b0,b
	sub	y0,b	a,x:local_ceiling2
	move	b,x:local_floor2

	; Si pas de texture superieure 
	; et que plafond2<plafond1
	; alors plafond2=plafond1

	move	x:upper_texture,x0
	jclr	#23,x0,YesUpperTexture
	move	x:local_ceiling1,x1
	cmp	x1,a
	jgt	YesUpperTexture
	move	x1,x:local_ceiling2
YesUpperTexture
	
	; Si pas de texture inferieure 
	; et sol2>sol1
	; alors sol2=sol1

	move	x:lower_texture,x0
	jclr	#23,x0,YesLowerTexture
	move	x:local_floor1,y1
	cmp	y1,b
	jlt	YesLowerTexture
	move	y1,x:local_floor2
YesLowerTexture

; -------------	Calcul offset x texture

	move	x:sidedef_offsetx,a
	move	x:linedef_attrib,x0
	move	x:time,b
	move	#>255,y0
	jclr	#TEXTLSCROLL,x0,_NoScrolLText
	add	b,a
_NoScrolLText	
	jclr	#TEXTRSCROLL,x0,_NoScrolRText
	sub	b,a
_NoScrolRText	
	and	y0,a
	move	a1,x:sidedef_offsetx

; -------------	Calcule le plafond le plus bas et le sol le plus haut du mur

	move	x:local_ceiling2,x0
	move	x:local_ceiling1,a
	cmp	x0,a	x:local_floor2,y0
	tgt	x0,a
	
	move	x:local_floor1,b
	cmp	y0,b	#>256,x0
	tlt	y0,b

	move	a,x1
	mpy	-x0,x1,a	b,x1
	mpy	-x0,x1,b	a,l:colonne_start
	move	b,l:colonne_end

; -------------	Calculer ye1 (premiere ligne pour plafond) ymin le plus faible
;	Calculer ye2 (derniere ligne pour sol) ymax le plus eleve
;	et pour chaque colonne le nouveau ymin et ymax

	move	#>trace_flag,r0
	move	#>trace_ymin,r1
	move	#>trace_ymax,r2
	move	#>linedef_attrib,r3
	move	#>trace_K,r4
	move	x:xe1,n0
	move	n0,n1
	move	n1,n2
	move	n2,n4
	lua	(r0)+n0,r0
	lua	(r1)+n1,r1
	lua	(r2)+n2,r2
	lua	(r4)+n4,r4

	clr	b	x:resy,a
	move	b,x:ye2
	move	#>1,x0
	sub	x0,a	#>-1,n0
	move	a,x:ye1
	move	x:local_longueur,b

	do	b,fin_empile_linedef
	move	x:(r0)+,b		; Si colonne deja trace : out
	move	x:(r1),y0
	move	x:(r2),y1

	tst	b	#>-1,x0
	jne	<fin_empile_colonne_linedef
	
	; si ymin(colonne)<ye1
	;   ye1=ymin(colonne)

	move	x:ye1,a
	cmp	y0,a	x:ye2,b
	tgt	y0,a
;	move	a,x:ye1

	; si ymax(colonne)>ye2
	;   ye2=ymax(colonne)

	cmp	y1,b	a,x:ye1
	tlt	y1,b
	move	b,x:ye2

	; si pas two_sided alors pas de calcul bete

	jclr	#TWO_SIDED,x:(r3),linedef_not_two_sided

	; Calcul du dnominateur

	move	x:seg_orig_x2,b
	move	x:seg_orig_x1,y0
	move	x:seg_orig_y2,a
	move	x:seg_orig_y1,x0
	sub	x0,a	x:(r4),x1
	sub	y0,b	a,y1
	mpy	-x1,y1,a		; (8:16)*(16:8)=(24:24)
	rep	#8-4
	asl	a		; a=(16:32)
	asl	a	x:seg_orig_x1,x0
	asl	a	x:seg_orig_y1,y0
	asl	a	x:seg_orig_x2,x1
	add	a,b	x:seg_orig_y2,y1

	; Calcul du numrateur
	
	mpy	y0,x1,a	b,x1	; y1*x2
	mac	-x0,y1,a	x:(r4),x0	; y1*x2-x1*y2 (32:16)
	
	; Calcul de Y
	
	jsr	<division_signee
	
	; Calcul de X

	move	a,x1
	mpy	x0,x1,a	a,x:mur_ymapping
	rep	#7-1
	asl	a
	asl	a	x:local_cosinus,b
	move	a,x:mur_xmapping	; (16:8)

	; X=x0(16:8) Y=y0(16:8)
	; **** Pb quand cos=0

;	move	x:local_cosinus,b
	abs	b	x:local_sinus,a
	abs	a
	
	cmp	a,b
	jmi	<_Xmapping_calcY

	move	x:mur_xmapping,a
	move	x:seg_orig_x1,b
	move	x:local_cosinus,x1
	jmp	<_Xmapping_ok
_Xmapping_calcY
	move	x:mur_ymapping,a
	move	x:seg_orig_y1,b
	move	x:local_sinus,x1
_Xmapping_ok
	sub	b,a	x:lumiere_const,x0
	rep	#15-1
	asr	a
	asr	a	x:mur_ymapping,y0
	jsr	<division_signee
;	move	a,x:to030_x

;	move	x:mur_ymapping,y0
;	move	x:lumiere_const,x0
	mpy	x0,y0,b	a,x:to030_x
	rep	#9-2
	asr	b
	asr	b	l:colonne_start,a
	asr	b	x:ecr_ligne,x0
	move	b0,x:to030_ycoef
	move	b0,x1

	; ecran=ecr_ligne+(player_h-hauteur_mur)/ycoef

	; Point de depart ecran

	jsr	<division_entiere
	tst	a	#>1,y0
	jle	<_mur_debme1
	add	y0,a
_mur_debme1
	add	x0,a
	move	a,x:to030_colstart

	; Point d'arrivee ecran

	move	l:colonne_end,a
	jsr	<division_entiere
	tst	a
	jge	<_mur_finp1
	sub	y0,a
_mur_finp1
	add	x0,a	x:ye2,y1
	move	a,x:to030_colend

	; si ymin(colonne)<colonne_start
	;   ymin(colonne)=colonne_start+1

	move	x:(r1),y0
	jset	#BETWEEN_UPSKY,x:(r3),linedef_calc_ymin
	move	x:to030_colstart,a
	cmp	y0,a
	jle	<linedef_calc_ymin
	move	a,y0
linedef_calc_ymin
	
	; si ymax(colonne)>colonne_end
	;   ymax(colonne)=colonne_end-1
	
	move	x:(r2),y1
	jset	#BETWEEN_DNSKY,x:(r3),linedef_calc_ymax
	move	x:to030_colend,b
	cmp	y1,b
	jge	<linedef_calc_ymax
	move	b,y1
linedef_calc_ymax
	
	; si ymin(colonne)>=ymax(colonne)
	;   flag(colonne)=-1

	move	y0,a
	cmp	y1,a
	jlt	<linedef_calc_flag
linedef_not_two_sided
	move	x:trace_deja,a
	sub	x0,a	x0,x:(r0+n0)
	move	a,x:trace_deja
linedef_calc_flag

fin_empile_colonne_linedef
	move	y0,x:(r1)+
	move	y1,x:(r2)+

	lua	(r4)+,r4	; Colonne suivante
fin_empile_linedef	

	; MAJ pile

	clr	a
	move	a,x:pile_type
	jsr	<AjouterDansPile

	; Mettre a jour tfe1,tfe2 par xe1,xe2 si pas transparent

	jset	#TWO_SIDED,x:(r3),Linedef_no_maj_limit
	move	#>1,x0
	move	x:xe1,a
	sub	x0,a	x:xe2,b
	add	x0,b	a,y0
	move	b,y1

	move	x:xe1,x0
;	move	x:xe2,x1
	move	x:trace_free1,a
	move	x:trace_free2,b

	; si xe1<=tfe1<=xe2 alors tfe1=xe2+1

	cmp	x0,a	x:xe2,x1	; si tfe1<xe1 stop
	jlt	<Linedef_tfe1_stop
	cmp	x1,a		; si tfe1<=xe2 alors transfert
	tle	y1,a
Linedef_tfe1_stop

	; si xe1<=tfe2<=xe2 alors tfe2=xe1-1

	cmp	x0,b	a,x:trace_free1	; si tfe2<xe1 stop
	jlt	<Linedef_tfe2_stop
	cmp	x1,b		; si tfe2<=xe2 alors transfert
	tle	y0,b
Linedef_tfe2_stop

;	move	a,x:trace_free1
	move	b,x:trace_free2
Linedef_no_maj_limit
	jmp	<attente
