; -----------------------------------------------------
;	Empile le LINEDEF
; -----------------------------------------------------
;	d0	Boucle du SSector
;	d6	player_x
;	d7	player_y
;	a1	adr_nodes
;	a2	Observateur
;	a4	adresse du SEG
;	a5	adresse element de la pile
;	a6	$ffffa202.w

	TEXT
EmpileLinedef

; -------------	Inits du SEG , du LINEDEF

	move	SEG_LINEDEF(a4),d5
	mulu	#SIZEOF_LINEDEF,d5		
	move.l	adr_linedefs,a3
	add.l	d5,a3

	bset	#ALREADY_ON_MAP-8,LINEDEF_ATTRIB(a3)

	move	LINEDEF_ANGLE(a3),a0
	move	LINEDEF_ATTRIB(a3),DRAW_LDF_ATTRIB(a5)
	move	LINEDEF_RSIDE(a3),d1
	move	LINEDEF_LSIDE(a3),d2

	move.l	current_sector,a3
	movem.l	SECTOR_CNAME(a3),d3-d4	; Texture plafond
	movem.l	d3-d4,DRAW_TXT_CEIL(a5)
	movem.l	SECTOR_FNAME(a3),d3-d4	; Texture sol
	movem.l	d3-d4,DRAW_TXT_FLOOR(a5)

	move	SECTOR_CEILING(a3),d3	; Hauteur plafond
	move	d3,DRAW_CEILING1(a5)
	move	d3,DRAW_CEILING2(a5)

	move	SECTOR_FLOOR(a3),d4	; Hauteur sol
	move	d4,DRAW_FLOOR1(a5)
	move	d4,DRAW_FLOOR2(a5)

	tst	SEG_SIDE(a4)
	beq.s	not_left_side
	exg	d1,d2
not_left_side	
	; Cote du joueur

	tst	d1
	bmi.s	not_sidedef1

	move.l	adr_sidedefs,a3
	mulu	#SIZEOF_SIDEDEF,d1
	add.l	d1,a3
	
	move	SIDEDEF_XOFFSET(a3),d3
	add	SEG_OFFSET(a4),d3
	move	SIDEDEF_YOFFSET(a3),d4
	lsl	#8,d4
	move	SIDEDEF_NAME(a3),DRAW_TXT_MAIN(a5)
	move	SIDEDEF_UPNAME(a3),DRAW_TXT_UPPER(a5)
	move	SIDEDEF_LONAME(a3),DRAW_TXT_LOWER(a5)
not_sidedef1
	; Cote oppose

	tst	d2
	bmi.s	not_sidedef2

	move.l	adr_sidedefs,a3
	mulu	#SIZEOF_SIDEDEF,d2
	add.l	d2,a3

	move	SIDEDEF_SECTOR(a3),d5
	mulu	#SIZEOF_SECTOR,d5
	move.l	adr_sectors,a3
	add.l	d5,a3

	move	SECTOR_CEILING(a3),DRAW_CEILING2(a5)
	move	SECTOR_FLOOR(a3),DRAW_FLOOR2(a5)
not_sidedef2

; -------------	Envoie les donnes du LINEDEF au DSP

	DSPWAITINPUT	(a6)
	move.l	#"LDF",2(a6)

	ext.l	d3
	DSPWAITINPUT	(a6)
	move.l	d3,2(a6)	; Offset X

	ext.l	d4
	DSPWAITINPUT	(a6)
	move.l	d4,2(a6)	; Offset Y

	move	DRAW_CEILING2(a5),d3
	ext.l	d3
	DSPWAITINPUT	(a6)
	move.l	d3,2(a6)	; plafond 2

	move	DRAW_FLOOR2(a5),d4
	ext.l	d4
	DSPWAITINPUT	(a6)
	move.l	d4,2(a6)	; sol 2

	DSPWAITINPUT	(a6)
	move	DRAW_LDF_ATTRIB(a5),4(a6)	; linedef attrib

	DSPWAITINPUT	(a6)
	move	DRAW_TXT_UPPER(a5),d1
	ext.l	d1
	move.l	d1,2(a6)	; Nb texture sup
	DSPWAITINPUT	(a6)
	move	DRAW_TXT_LOWER(a5),d1
	ext.l	d1
	move.l	d1,2(a6)	; Nb texture inf

	move.l	a0,d1
	tst	SEG_SIDE(a4)
	beq.s	.seg_rightside
	add	#$8000,d1
.seg_rightside	sub	OBJET_A(a2),d1
	add	#(nb_angles/4)*4,d1
	and	#-4,d1
	DSPWAITINPUT	(a6)
	move.l	([sinus],d1.w),2(a6)	; Local sinus
	DSPWAITINPUT	(a6)
	move.l	([cosinus],d1.w),2(a6)	; local cosinus

; -------------	Element suivant de la pile

	lea	SIZEOF_DRAW(a5),a5
	addq.w	#1,draw_walls
	cmp	#MAX_WALLS,draw_walls
	bmi.s	fin_empile_linedef1
	move	#-1,walls_flag
	bra.s	cont_empile_linedef
fin_empile_linedef1

; -------------	Teste si on doit arreter le calcul maintenant

	DSPWAITINPUT	(a6)
	move.l	#"DEJ",2(a6)
	DSPWAITOUTPUT	(a6)
	move	4(a6),d5
	beq.s	cont_empile_linedef
	move	d5,walls_flag
cont_empile_linedef
	;rts
