; ---------------------------------------------
;	Calcule la visibilit d'un node
; ---------------------------------------------

CALCUL_NODE	MACRO	src_x,src_y

	move	src_x,x1

	mpy	y0,x1,a	src_y,y1	; x*cos a
	mac	x0,y1,a		; x*cos a+y*sin a
	rep	#8+1
	asr	a

	mpy	-x0,x1,b	a0,x:(r0)+	; -x*sin a	
	mac	y0,y1,b		; -x*sin a+y*cos a
	rep	#8+1
	asr	b
	move	b0,x:(r1)+

	ENDM

; -------------	Routine de gestion d'un NODE
	
	ORG	p:
EmpileNode
	move	x:player_y,y1

	READHOST	a
	sub	y1,a	x:player_x,x1
	READHOST	b
	sub	y1,b	a,x:node_y2
	READHOST	a
	sub	x1,a	b,x:node_y1
	READHOST	b
	sub	x1,b	a,x:node_x1
	move	b,x:node_x2

; -------------	Rotation dans le repere de l'observateur

	move	x:node_sin,x0
	move	x:node_cos,y0
	move	#>noeud_x0,r0
	move	#>noeud_y0,r1

	CALCUL_NODE	x:node_x1,x:node_y1
	CALCUL_NODE	x:node_x2,x:node_y1
	CALCUL_NODE	x:node_x2,x:node_y2
	CALCUL_NODE	x:node_x1,x:node_y2

	move	#>noeud_x0,r0
	move	#>noeud_y0,r1

	; Test de visibilit x
	
	jclr	#23,x:(r0)+,fin_calc_visi_node_x
	jclr	#23,x:(r0)+,fin_calc_visi_node_x
	jclr	#23,x:(r0)+,fin_calc_visi_node_x
	jclr	#23,x:(r0)+,fin_calc_visi_node_x
	WRITEHOST	#>-1
	jmp	<attente
fin_calc_visi_node_x

	; Test de visibilit y

	jclr	#23,x:(r1)+,fin_calc_visi_node_y
	jclr	#23,x:(r1)+,fin_calc_visi_node_y
	jclr	#23,x:(r1)+,fin_calc_visi_node_y
	jclr	#23,x:(r1)+,fin_calc_visi_node_y
	WRITEHOST	#>-1
	jmp	<attente
fin_calc_visi_node_y
;	WRITEHOST	#>0
;	jmp	<attente

; -------------	Projeter le NODE dans le cone de vision

	move	x:noeud_x0,a
	move	a,x:noeud_x0_2
	move	x:noeud_y0,a
	move	a,x:noeud_y0_2
	move	#>noeud_x0,r0
	move	#>noeud_y0,r1

	clr	a	#>1,x0
	move	x:resx,b
	sub	x0,b	a,x:noeud_xe2
	move	b,x0
	move	x0,x:noeud_xe1
	
	do	#4,projection_noeud

	move	x:(r0)+,x0
	move	x:(r1)+,y0
	move	x:(r0),x1
	move	x:(r1),y1

	jsr	<ClippingNodeSeg
	tst	a	x1,x:seg_x2
	jmi	<projection_noeud_next
	
	; Rotation pour champ de vision de 45 dans sens trigo
	
	or	#4,omr

;	move	x1,x:seg_x2
	
	move	y:$0120,x1		; sinus 45 = cosinus 45

	mpy	x0,x1,a
	mac	-y0,x1,a		; x*cos a-y*sin a
	mpy	x0,x1,b	a,x:seg_x1
	mac	y0,x1,b	x:seg_x2,x0	; x*sin a+y*cos a
	
	mpy	x0,x1,a	y1,y0
	mac	-y0,x1,a	b,x:seg_y1	; x*sin a-y*cos a
	mpy	x0,x1,b	a,x:seg_x2
	mac	y0,x1,b	#>1,x0	; x*cos a+y*sin a
	move	b,x:seg_y2

	and	#255-4,omr

	; Projection

;	move	#>1,x0
	move	x:resx,b
	sub	x0,b	x:seg_x1,x1
	move	b,x0		; x0 = resx-1

	mpy	x0,x1,a	x:seg_y1,x1
	jsr	<division_entiere
	add	x0,a	x:seg_y2,x1
	asr	a	x:seg_x2,y1

	mpy	x0,y1,a	a,x:xe1
	jsr	<division_entiere
	add	x0,a
	asr	a	x:xe1,b

	; xe1 le plus petit xe2 le plus grand
	
	cmp	b,a
	jpl	<NodeSegProj
	tfr	b,a	a,b
NodeSegProj	
	move	a,x:xe2
	move	b,x:xe1

	; Comparaison avec precedent

	move	x:noeud_xe2,b
	cmp	b,a
	tpl	a,b
	move	b,x:noeud_xe2

	move	x:xe1,a
	jpl	<NodeSegNeg
	clr	a
NodeSegNeg
	move	x:noeud_xe1,b
	cmp	b,a
	tmi	a,b
	move	b,x:noeud_xe1
	
projection_noeud_next
	nop	
projection_noeud

; -------------	Tester si segment NODE visible

	move	x:trace_free1,x0
	move	x:trace_free2,x1
	move	x:noeud_xe1,b
	move	x:noeud_xe2,a

	cmp	x0,a	#>trace_flag,r0	; si noeud_xe2<prem col libre alors stop
	jmi	<Node_horsecran
	cmp	x1,b	#>1,x0	; si noeud_xe1>dern col libre alors stop
	jgt	<Node_horsecran

;	move	#>1,x0
;	move	x:noeud_xe2,a
;	move	x:noeud_xe1,b
;	move	#>trace_flag,r0

	sub	b,a	b,n0
	jmi	<Node_horsecran
	add	x0,a
	lua	(r0)+n0,r0
	clr	b	a,x0
	
	move	x:(r0)+,a
	do	x0,fin_empile_node
	tst	a
	jne	<node_nextcol
	enddo
	WRITEHOST	#>0
	jmp	<attente
node_nextcol
	move	x:(r0)+,a
fin_empile_node
Node_horsecran
	WRITEHOST	#>-1
	jmp	<attente

; -------------	Routine de clipping d'un SEG dans cone de vision

ClippingNodeSeg
	; Clipping de x1

	move	x0,a
	tst	a	x1,a
	jpl	<ClipNode_x1ok		; Si x1>=0 alors x1 ok
	tst	a	x1,b
	jmi	<ClipNode_stop		; Si x1<0 et x2<0 alors stop

	sub	x0,b	y1,a	; b=x2-x1
	sub	y0,a	x1,x:sauvegarde	; a=y2-y1
	move	a,x1
	mpy	-x0,x1,a	b,x1	; a=(0-x1)*(y2-y1)
	jsr	<division_signee
	move	x:sauvegarde,x1
	add	y0,a	#>0,x0	; a=y1+(0-x1)*(y2-y1)/(x2-x1)
	move	a,y0
ClipNode_x1ok
	; Clipping de y1

	move	y0,a
	tst	a	y1,a
	jpl	<ClipNode_y1ok		; Si y1>=0 alors x1 ok
	tst	a	y1,b
	jmi	<ClipNode_stop		; Si y1<0 et y2<0 alors stop

	sub	y0,b	x1,a	; b=y2-y1
	sub	x0,a	x1,x:sauvegarde	; a=x2-x1
	move	a,x1
	mpy	-y0,x1,a	b,x1	; a=(0-y1)*(x2-x1)
	jsr	<division_signee
	move	x:sauvegarde,x1
	add	x0,a	#>0,y0	; a=x1+(0-y1)*(x2-x1)/(y2-y1)
	move	a,x0
ClipNode_y1ok
	; Clipping de x2

	move	x1,a
	tst	a	x0,a
	jpl	<ClipNode_x2ok		; Si x2>=0 alors x1 ok
	tst	a	y1,a
	jmi	<ClipNode_stop		; Si x2<0 et x1<0 alors stop

	sub	y0,a	x1,b	; a=y2-y1
	sub	x0,b	a,x1	; b=x2-x1
	mpy	-x0,x1,a	b,x1	; a=(0-x1)*(y2-y1)
	jsr	<division_signee
	add	y0,a	#>0,x1	; a=y1+(0-x1)*(y2-y1)/(x2-x1)
	move	a,y1
ClipNode_x2ok
	; Clipping de y2

	move	y1,a
	tst	a	y0,a
	jpl	<ClipNode_y2ok		; Si y2>=0 alors x1 ok
	tst	a	x1,a
	jmi	<ClipNode_stop		; Si y2<0 et y1<0 alors stop

	sub	x0,a	y1,b	; a=x2-x1
	sub	y0,b	a,x1	; b=y2-y1
	mpy	-y0,x1,a	b,x1	; a=(0-y1)*(x2-x1)
	jsr	<division_signee
	add	x0,a	#>0,y1	; a=x1+(0-y1)*(x2-x1)/(y2-y1)
	move	a,x1
ClipNode_y2ok

ClipNode_ok	clr	a
	rts

; -------------	Pas de segment visible

ClipNode_stop	move	#>-1,a
	rts

; -------------	Variables

	ORG	X:

node_sin	ds	1	; (8:16)
node_cos	ds	1

noeud_xe1	ds	1
noeud_xe2	ds	1

	; Position du noeud dans espace objet

node_x1	ds	1	; (24:0)
node_y1	ds	1
node_x2	ds	1
node_y2	ds	1

	; Noeud = rectangle dans espace observateur

noeud_x0	ds	1	; (16:8)
noeud_x1	ds	1
noeud_x2	ds	1
noeud_x3	ds	1
noeud_x0_2	ds	1

noeud_y0	ds	1
noeud_y1	ds	1
noeud_y2	ds	1
noeud_y3	ds	1
noeud_y0_2	ds	1
