; -----------------------------------------------------------
;	Doom structures
; -----------------------------------------------------------

; ------------------------------
;	THING
; ------------------------------

PLAYER1_START	=	1
PLAYER2_START	=	2
PLAYER3_START	=	3
PLAYER4_START	=	4

	RsReset

THING_X	rs.w	1	; coordonne X
THING_Y	rs.w	1	; coordonne Y
THING_ANGLE	rs.w	1	; angle
THING_TYPE	rs.w	1	; type
THING_ATTRIB	rs.w	1	; attributs

SIZEOF_THING	rs.w	1

; ------------------------------
;	LINEDEF
; ------------------------------

	RsReset
IMPASSABLE	rs.b	1
MONSTER_BLOCK	rs.b	1
TWO_SIDED	rs.b	1
UPPER_UNPEGGED	rs.b	1
LOWER_UNPEGGED	rs.b	1
SECRET	rs.b	1
SOUND_BLOCK	rs.b	1
NOT_ON_MAP	rs.b	1

ALREADY_ON_MAP	rs.b	1
BETWEEN_UPSKY	rs.b	1
BETWEEN_DNSKY	rs.b	1
TEXTLSCROLL	rs.b	1	; Type 48 : texture scrolle sens 1
TEXTRSCROLL	rs.b	1	; Type 99 (Heretic) scrolle sens 2
;WALL_COLLISION	rs.b	1

	RsReset

LINEDEF_VERTEX1	rs.w	1	; VERTEX de dpart
LINEDEF_VERTEX2	rs.w	1	; VERTEX d'arrive
LINEDEF_ATTRIB	rs.w	1	; Attributs
LINEDEF_TYPE	rs.w	1	; Type
LINEDEF_TAG	rs.w	1	; Tag number
LINEDEF_RSIDE	rs.w	1	; SIDEDEF droite
LINEDEF_LSIDE	rs.w	1	; SIDEDEF gauche
LINEDEF_LENGTH	rs.w	1	; Longueur du LINEDEF (pour collision)
LINEDEF_ANGLE	rs.w	1	; Angle du LINEDEF (pour collision)

SIZEOF_LINEDEF	rs.w	1
SIZEOF_LINEDEF1	=	LINEDEF_LENGTH

; ------------------------------
;	SIDEDEF
; ------------------------------

	RsReset

SIDEDEF_XOFFSET	rs.w	1	; Offset X dans la texture
SIDEDEF_YOFFSET	rs.w	1	; Offset Y dans la texture
SIDEDEF_UPNAME	rs.b	8	; Nom de la texture suprieure
SIDEDEF_LONAME	rs.b	8	; Nom de la texture infrieure
SIDEDEF_NAME	rs.b	8	; Nom de la texture centrale
SIDEDEF_SECTOR	rs.w	1	; Numro du SECTOR associ

SIZEOF_SIDEDEF	rs.w	1

; ------------------------------
;	VERTEX
; ------------------------------

	RsReset

VERTEX_X	rs.w	1	; Coordonne X
VERTEX_Y	rs.w	1	; Coordonne Y

SIZEOF_VERTEX	rs.w	1

; ------------------------------
;	SEG
; ------------------------------

	RsReset

SEG_VERTEX1	rs.w	1	; VERTEX de dpart
SEG_VERTEX2	rs.w	1	; VERTEX d'arrive
SEG_ANGLE	rs.w	1	; Angle
SEG_LINEDEF	rs.w	1	; LINEDEF associ
SEG_SIDE	rs.w	1	; Cot du LINEDEF associ
SEG_OFFSET	rs.w	1	; Offset dans le LINEDEF associ

SIZEOF_SEG	rs.w	1

; ------------------------------
;	SSECTOR
; ------------------------------

	RsReset

SSECTOR_NBSEG	rs.w	1	; Nombre de SEGS dans ce SSECTOR
SSECTOR_STSEG	rs.w	1	; SEG de dpart dans ce SSECTOR
SSECTOR_SPRITES	rs.l	1	; Adresse du premier sprite dans le SSECTOR
SSECTOR_SECTOR	rs.l	1	; Adresse du secteur associ

SIZEOF_SSECTOR	rs.w	1
SIZEOF_SSECTOR1	=	SSECTOR_SPRITES

; ------------------------------
;	NODE
; ------------------------------

	RsReset

NODE_XC	rs.w	1	; Ligne de sparation : dpart X
NODE_YC	rs.w	1	; Idem pour Y
NODE_DX	rs.w	1	; Offset depuis XC en X
NODE_DY	rs.w	1	; Idem en Y
;NODE_RIGHT
NODE_R_YU	rs.w	1	; Boite droite
NODE_R_YL	rs.w	1
NODE_R_XL	rs.w	1
NODE_R_XU	rs.w	1
;NODE_LEFT
NODE_L_YU	rs.w	1	; Boite gauche
NODE_L_YL	rs.w	1
NODE_L_XL	rs.w	1
NODE_L_XU	rs.w	1
NODE_R_CHILD	rs.w	1	; SSECTOR droite
NODE_L_CHILD	rs.w	1	; SSECTOR gauche

SIZEOF_NODE	rs.w	1

NODE_RIGHT	=	2*4
NODE_LEFT	=	2*8

	RsReset
NODE_YU	rs.w	1
NODE_YL	rs.w	1
NODE_XL	rs.w	1
NODE_XU	rs.w	1

; ------------------------------
;	SECTOR
; ------------------------------

	RsReset

SECTOR_FLOOR	rs.w	1	; Niveau du sol	(actuel)
SECTOR_CEILING	rs.w	1	; Niveau du plafond (actuel)
SECTOR_FNAME	rs.b	8	; Nom du sol
SECTOR_CNAME	rs.b	8	; Nom du plafond
SECTOR_BRIGHT	rs.w	1	; Lumiere (actuelle)
SECTOR_SPECIAL	rs.w	1	; Special
SECTOR_TRIGGER	rs.w	1	; Trigger

SECTOR_LMOVE	rs.b	1	; Mouvement de la lumiere (oscillate)
SECTOR_LOWLIGHT	rs.b	1	; Valeur minimale de la lumiere
SECTOR_HILIGHT	rs.w	1	; Valeur SECTOR_BRIGHT initiale

SECTOR_FCMOVE	rs.w	1	; Mouvement
SECTOR_FCSPEED	rs.w	1	; Vitesse du mouvement
SECTOR_FCTYPE	rs.w	1	; Type de mouvement
SECTOR_LIMIT1	rs.w	1	; Limite basse du mouvement
SECTOR_LIMIT2	rs.w	1	; Limite haute du mouvement
SECTOR_FLOOR1	rs.w	1	; Sol origine
SECTOR_CEILING1	rs.w	1	; Plafond origine
SECTOR_TIME	rs.l	1	; Temps depuis dmarrage action

SIZEOF_SECTOR	rs.w	1
SIZEOF_SECTOR1	=	SECTOR_LMOVE

; ------------------------------
;	MACROS
; ------------------------------

INVERSE_LONG	MACRO	adress_register,adress_register
	lea	intel+4,\2
	move.b	(\1)+,-(\2)
	move.b	(\1)+,-(\2)
	move.b	(\1)+,-(\2)
	move.b	(\1)+,-(\2)
	ENDM

INVERSE_MOT	MACRO	adress_register,adress_register
	lea	intel+2,\2
	move.b	(\1)+,-(\2)
	move.b	(\1)+,-(\2)
	ENDM

SAUV_REGS	MACRO	list_registers
	movem.l	\1,-(sp)
	ENDM
	
REST_REGS	MACRO	list_registers
	movem.l	(sp)+,\1
	ENDM

INVERSE_MOT1	MACRO	adresse,registre
	move.b	(\1),\2
	ror	#8,\2
	move.b	1(\1),\2
	ENDM

INVERSE_MOT2	MACRO	adresse,registre
	move	(\1)+,\2
	ror	#8,\2
	ENDM

INVERSE_LONG2	MACRO	adresse,registre
	move.l	(\1)+,\2
	ror	#8,\2
	swap	\2
	ror	#8,\2
	ENDM

	BSS
	
intel	ds.l	1
