; ------------------------------
;	Liste des objets de Doom
; ------------------------------

; -------------	Type de gravit de l'objet
;	d1 Numero de l'objet
;	-> d0=0 pas de gravit, 1/sol, 2/plafond

	TEXT
DoomGravite
	cmp	#49,d1
	bmi.s	.NoGravite1
	cmp	#54,d1
	bmi.s	.Gravite2
.NoGravite1
	cmp	#59,d1
	bmi.s	.NoGravite2
	cmp	#64,d1
	bmi.s	.Gravite2
.NoGravite2
	cmp	#73,d1
	bmi.s	.NoGravite3
	cmp	#79,d1
	bmi.s	.Gravite2
.NoGravite3
	cmp	#71,d1
	beq.s	.Gravite0
	cmp	#3005,d1
	beq.s	.Gravite0
	cmp	#3006,d1
	beq.s	.Gravite0
	cmp	#4000,d1
	bpl.s	.Gravite0

	moveq	#1,d0	; Objet au sol
	rts

.Gravite0	moveq	#0,d0	; OVNI
	rts

.Gravite2	moveq	#2,d0	; Objet pendu au plafond
	rts

; -------------	Recherche d'un nom dans une des listes
;	d0 numero du THING
;	-> a4 liste ou chercher

	TEXT
DoomSearchObjectAdress
	cmp	#4000,d0
	bpl.s	.SearchObjectAdressObject4000
	cmp	#3000,d0
	bpl.s	.SearchObjectAdressObject3000
	cmp	#2000,d0
	bpl.s	.SearchObjectAdressObject2000
.SearchObjectAdressObject0000
	lea	DoomObjects0000,a4
	rts
.SearchObjectAdressObject2000
	sub	#2000,d0
	lea	DoomObjects2000,a4
	rts
.SearchObjectAdressObject3000
	sub	#3000,d0
	lea	DoomObjects3000,a4
	rts
.SearchObjectAdressObject4000
	sub	#4000,d0
	lea	DoomObjects4000,a4
	rts

; -------------	Liste des objets de DOOM

	DATA

DoomObjects0000	DEF_SPRITE	0
	DEF_SPRITE	"PLAY","A0",0,ObjTurnAround,40,16,100,-1	; Player 1 start
	DEF_SPRITE	0			; Player 2 start
	DEF_SPRITE	0			; Player 3 start
	DEF_SPRITE	0			; Player 4 start
	DEF_SPRITE	"BKEY","A0",2,ObjAnimed,8,20,0,0	; Blue key
	DEF_SPRITE	"YKEY","A0",2,ObjAnimed,8,20,0,0	; Yellow key
	DEF_SPRITE	"SPID","A0",0,ObjTurnAround,84,128,1000,-1	; SPIDER MASTERMIND
	DEF_SPRITE	"BPAK","A0",0,0,16,20,0,0		; Backpack
	DEF_SPRITE	"SPOS","A0",0,ObjTurnAround,40,20,100,-1	; FORMER HUMAN SERGEANT

	DEF_SPRITE	"PLAY","W0",0,DoomExplPlayer,4,20,0,0	; Exploded player
	DEF_SPRITE	0			; Deathmatch start
	DEF_SPRITE	"PLAY","W0",0,DoomExplPlayer,4,20,0,0	; Exploded player
	DEF_SPRITE	"RKEY","A0",2,ObjAnimed,8,20,0,0	; Red key
	DEF_SPRITE	0			; Teleport landing
	DEF_SPRITE	"PLAY","N0",0,DoomDeadPlayer,4,20,0,0	; Dead player
	DEF_SPRITE	"CYBR","A0",0,ObjTurnAround,94,40,1000,-1	; CYBER DEMON
	DEF_SPRITE	"CELP","A0",0,0,8,20,0,0		; Cell pack
	DEF_SPRITE	"POSS","L0",0,DoomDeadPoss,4,20,0,0	; Dead FORMER HUMAN
	DEF_SPRITE	"SPOS","L0",0,DoomDeadSpos,4,20,0,0	; Dead FORMER HUMAN SERGEANT

	DEF_SPRITE	"TROO","M0",0,DoomDeadImp,4,20,0,0	; Dead IMP
	DEF_SPRITE	"SARG","N0",0,DoomDeadSarg,4,20,0,0	; Dead DEMON
	DEF_SPRITE	"HEAD","L0",0,DoomDeadHead,4,20,0,0	; Dead CACODEMON
	DEF_SPRITE	0			; Dead LOST SOUL (invisible)
	DEF_SPRITE	"POL5","A0",0,0,16,20,0,0		; Pool of blood and flesh
	DEF_SPRITE	"POL1","A0",0,0,16,20,0,0		; Impaled human
	DEF_SPRITE	"POL6","A0",2,ObjAnimed,16,16,0,0	; Twitching impaled human
	DEF_SPRITE	"POL4","A0",0,0,16,16,0,0		; Skull on a pole
	DEF_SPRITE	"POL2","A0",0,0,16,16,0,0		; 5 skulls shish kebob
	DEF_SPRITE	"POL3","A0",2,ObjAnimed,16,16,0,0	; Pile of skulls and candles

	DEF_SPRITE	"COL1","A0",0,0,64,16,0,0		; Tall green pillar
	DEF_SPRITE	"COL2","A0",0,0,32,16,0,0		; Short green pillar
	DEF_SPRITE	"COL3","A0",0,0,64,16,0,0		; Tall red pillar
	DEF_SPRITE	"COL4","A0",0,0,32,16,0,0		; Short red pillar
	DEF_SPRITE	"CAND","A0",0,0,8,16,0,0		; Candle
	DEF_SPRITE	"CBRA","A0",0,0,64,16,0,0		; Candelabra
	DEF_SPRITE	"COL5","A0",2,ObjAnimed,32,16,0,0	; Short green pillar with beating heart
	DEF_SPRITE	"COL6","A0",0,0,32,16,0,0		; Short red pillar with skull
	DEF_SPRITE	"RSKU","A0",2,ObjAnimed,8,20,0,0	; Red skull key
	DEF_SPRITE	"YSKU","A0",2,ObjAnimed,8,20,0,0	; Yellow skull key

	DEF_SPRITE	"BSKU","A0",2,ObjAnimed,8,20,0,0	; Blue skull key
	DEF_SPRITE	"CEYE","A0",3,ObjAnimed,16,16,0,0	; Evil eye
	DEF_SPRITE	"FSKU","A0",3,ObjAnimed,16,16,0,0	; Floating skull
	DEF_SPRITE	"TRE1","A0",0,0,96,16,0,0		; Gray tree
	DEF_SPRITE	"TBLU","A0",4,ObjAnimed,96,16,0,0	; Tall blue firestick
	DEF_SPRITE	"TGRN","A0",4,ObjAnimed,96,16,0,0	; Tall green firestick
	DEF_SPRITE	"TRED","A0",4,ObjAnimed,96,16,0,0	; Tall red firestick
	DEF_SPRITE	"SMIT","A0",0,0,32,16,0,0		; Stalagmite
	DEF_SPRITE	"ELEC","A0",0,0,64,16,0,0		; Tall techno pillar
	DEF_SPRITE	"GOR1","A0",3,ObjAnimed,32,16,0,0	; Hanging victim, twitching

	DEF_SPRITE	"GOR2","A0",0,0,32,16,0,0		; Hanging victim, arms out
	DEF_SPRITE	"GOR3","A0",0,0,32,16,0,0		; Hanging victim, 1-legged
	DEF_SPRITE	"GOR4","A0",0,0,32,16,0,0		; Hanging pair of legs
	DEF_SPRITE	"GOR5","A0",0,0,32,16,0,0		; Hanging leg
	DEF_SPRITE	"TRE2","A0",0,0,96,32,0,0		; Large brown tree
	DEF_SPRITE	"SMBT","A0",4,ObjPingPong,48,16,0,0	; Short blue firestick
	DEF_SPRITE	"SMGT","A0",4,ObjPingPong,48,16,0,0	; Short green firestick
	DEF_SPRITE	"SMRT","A0",4,ObjPingPong,48,16,0,0	; Short red firestick
	DEF_SPRITE	"SARG","A0",0,ObjTurnAround,40,20,100,-1	; SPECTRE
	DEF_SPRITE	"GOR2","A0",0,0,32,16,0,0		; Hanging victim, arms out

	DEF_SPRITE	"GOR4","A0",0,0,32,16,0,0		; Hanging pair of legs
	DEF_SPRITE	"GOR3","A0",0,0,32,16,0,0		; Hanging victim, 1-legged
	DEF_SPRITE	"GOR5","A0",0,0,32,16,0,0		; Hanging leg
	DEF_SPRITE	"GOR1","A0",3,ObjAnimed,32,16,0,0	; Hanging victim, twitching
	DEF_SPRITE	"VILE","A0",0,ObjTurnAround,40,20,500,-1	; ARCH-VILE
	DEF_SPRITE	"CPOS","A0",0,ObjTurnAround,40,20,100,-1	; HEAVY WEAPON DUDE
	DEF_SPRITE	"SKEL","A0",0,ObjTurnAround,40,20,500,-1	; REVENANT
	DEF_SPRITE	"FATT","A0",0,ObjTurnAround,48,48,1000,-1	; MANCUBUS
	DEF_SPRITE	"BSPI","A0",0,ObjTurnAround,48,64,600,-1	; ARACHNOTRON
	DEF_SPRITE	"BOS2","A0",0,ObjTurnAround,48,24,1000,-1	; KNIGHT OF HELL

	DEF_SPRITE	"FCAN","A0",3,ObjAnimed,32,16,0,0	; Burning barrel
	DEF_SPRITE	"PAIN","A0",0,ObjTurnAround,40,31,400,0	; PAIN ELEMENTAL
	DEF_SPRITE	"KEEN","A0",0,0,46,16,6666,0		; COMMANDER KEEN
	DEF_SPRITE	"HDB1","A0",0,0,32,16,0,0		; Hanging victim, guts removed
	DEF_SPRITE	"HDB2","A0",0,0,32,16,0,0		; Hanging victim, guts and brain removed
	DEF_SPRITE	"HDB3","A0",0,0,32,16,0,0		; Hanging torso, looking down
	DEF_SPRITE	"HDB4","A0",0,0,32,16,0,0		; Hanging torso, open skull
	DEF_SPRITE	"HDB5","A0",0,0,32,16,0,0		; Hanging torso, looking up
	DEF_SPRITE	"HDB6","A0",0,0,32,16,0,0		; Hanging torso, brain removed
	DEF_SPRITE	"POB1","A0",0,0,4,20,0,0		; Pool of blood

	DEF_SPRITE	"POB2","A0",0,0,4,20,0,0		; Pool of blood
	DEF_SPRITE	"BRS1","A0",0,0,4,20,0,0		; Pool of brain
	DEF_SPRITE	"SGN2","A0",0,0,8,20,0,0		; Double barreled shotgun
	DEF_SPRITE	"MEGA","A0",4,ObjPingPong,8,20,0,0	; Megasphere
	DEF_SPRITE	"SSWV","A0",0,ObjTurnAround,40,20,100,-1	; WOLFENSTEIN SS
	DEF_SPRITE	"TLMP","A0",4,ObjPingPong,64,16,0,0	; Tall techno floor lamp
	DEF_SPRITE	"TLP2","A0",4,ObjPingPong,32,16,0,0	; Short techno floor lamp
	DEF_SPRITE	0			; Spawn spot
	DEF_SPRITE	"BBRN","A0",0,0,16,16,6666,0		; BOSS BRAIN
	DEF_SPRITE	0			; Boss shooter

DoomObjects2000	DEF_SPRITE	0
	DEF_SPRITE	"SHOT","A0",0,0,8,20,0,0		; Shotgun
	DEF_SPRITE	"MGUN","A0",0,0,8,20,0,0		; Machine gun
	DEF_SPRITE	"LAUN","A0",0,0,8,20,0,0		; Rocket launcher
	DEF_SPRITE	"PLAS","A0",0,0,8,20,0,0		; Plasma gun
	DEF_SPRITE	"CSAW","A0",0,0,8,20,0,0		; Chainsaw
	DEF_SPRITE	"BFUG","A0",0,0,8,20,0,0		; BFG 9000
	DEF_SPRITE	"CLIP","A0",0,0,8,20,0,0		; Ammo clip
	DEF_SPRITE	"SHEL","A0",0,0,8,20,0,0		; Shotgun shells
	DEF_SPRITE	0

	DEF_SPRITE	"ROCK","A0",0,0,8,20,0,0		; Rocket
	DEF_SPRITE	"STIM","A0",0,0,8,20,0,0		; Stimpak
	DEF_SPRITE	"MEDI","A0",0,0,8,20,0,0		; Medikit
	DEF_SPRITE	"SOUL","A0",4,ObjPingPong,8,20,0,0	; Soulsphere
	DEF_SPRITE	"BON1","A0",4,ObjPingPong,8,20,0,0	; Health potion
	DEF_SPRITE	"BON2","A0",4,ObjPingPong,8,20,0,0	; Spirit armor
	DEF_SPRITE	0
	DEF_SPRITE	0
	DEF_SPRITE	"ARM1","A0",2,ObjAnimed,8,20,0,0	; Green armor
	DEF_SPRITE	"ARM2","A0",2,ObjAnimed,8,20,0,0	; Blue armor

	DEF_SPRITE	0
	DEF_SPRITE	0
	DEF_SPRITE	"PINV","A0",4,ObjPingPong,8,20,0,0	; Invulnerability
	DEF_SPRITE	"PSTR","A0",0,0,8,20,0,0		; Berzerk strength and 100% health
	DEF_SPRITE	"PINS","A0",4,ObjPingPong,8,20,0,0	; Invisibility
	DEF_SPRITE	"SUIT","A0",0,0,8,20,0,0		; Radiation suit
	DEF_SPRITE	"PMAP","A0",4,ObjPingPong,8,20,0,0	; Computer map
	DEF_SPRITE	0
	DEF_SPRITE	"COLU","A0",0,0,32,16,0,0		; Floor lamp
	DEF_SPRITE	0

	DEF_SPRITE	0
	DEF_SPRITE	0
	DEF_SPRITE	0
	DEF_SPRITE	0
	DEF_SPRITE	0
	DEF_SPRITE	"BAR1","A0",2,ObjAnimed,32,16,50,-1	; Barrel
	DEF_SPRITE	0
	DEF_SPRITE	0
	DEF_SPRITE	0
	DEF_SPRITE	0

	DEF_SPRITE	0
	DEF_SPRITE	0
	DEF_SPRITE	0
	DEF_SPRITE	0
	DEF_SPRITE	0
	DEF_SPRITE	"PVIS","A0",2,ObjAnimed,8,20,0,0	; Light amplification
	DEF_SPRITE	"BROK","A0",0,0,8,20,0,0		; Box of rockets
	DEF_SPRITE	"CELL","A0",0,0,8,20,0,0		; Cell charge
	DEF_SPRITE	"AMMO","A0",0,0,8,20,0,0		; Box of ammo
	DEF_SPRITE	"SBOX","A0",0,0,8,20,0,0		; Box of shells

DoomObjects3000	DEF_SPRITE	0
	DEF_SPRITE	"TROO","A0",0,ObjTurnAround,40,20,100,-1	; IMP
	DEF_SPRITE	"SARG","A0",0,ObjTurnAround,40,30,400,-1	; DEMON
	DEF_SPRITE	"BOSS","A0",0,ObjTurnAround,48,24,1000,-1	; BARON OF HELL
	DEF_SPRITE	"POSS","A0",0,ObjTurnAround,40,20,100,-1	; FORMER HUMAN
	DEF_SPRITE	"HEAD","A0",0,ObjTurnAround,40,31,400,-1	; CACODEMON
	DEF_SPRITE	"SKUL","A0",0,ObjTurnAround,40,16,50,-1	; LOST SOUL
	DEF_SPRITE	0
	DEF_SPRITE	0
	DEF_SPRITE	0

DoomObjects4000	DEF_SPRITE	0,"A0",0,ObjTurnAround,40,20,100,-1	; Poing
	DEF_SPRITE	0,"A0",0,ObjTurnAround,40,20,100,-1	; Trononneuse
	DEF_SPRITE	0,"A0",0,ObjTurnAround,40,20,100,-1	; Pistolet
	DEF_SPRITE	0,"A0",0,ObjTurnAround,40,20,100,-1	; Fusil
	DEF_SPRITE	0,"A0",0,ObjTurnAround,40,20,100,-1	; Fusil double canon
	DEF_SPRITE	0,"A0",0,ObjTurnAround,40,20,100,-1	; Mitrailleuse
	DEF_SPRITE	"MISL","A0",0,ObjTurnAround,40,20,100,-1	; Lance roquettes
	DEF_SPRITE	"PLSS","A0",0,0,40,20,100,-1		; Fusil  plasma
	DEF_SPRITE	"BFS1","A0",0,0,40,20,100,-1		; BFG 9000
	DEF_SPRITE	"BAL1","A0",0,0,40,20,100,-1		; Tir de IMP

	DEF_SPRITE	"BAL2","A0",0,0,40,20,100,-1		; Tir de CACODEMON
	DEF_SPRITE	"MANF","A0",0,ObjTurnAround,40,20,100,-1	; Tir de MANCUBUS
	DEF_SPRITE	"PLAY","A0",0,ObjTurnAround,40,20,100,-1	; Tir de ARCHVILE
	DEF_SPRITE	"BAL7","A0",0,ObjTurnAround,40,20,100,-1	; Tir de BARON OF HELL
	DEF_SPRITE	"FATB","A0",0,ObjTurnAround,40,20,100,-1	; Tir de REVENANT
	DEF_SPRITE	"APLS","A0",0,0,40,20,100,-1		; Tir de ARACHNOTRON
	DEF_SPRITE	"BOSF","A0",0,0,40,20,100,-1		; Tir de BOSS BRAIN
	DEF_SPRITE	0
	DEF_SPRITE	0
	DEF_SPRITE	0

; -------------	Thing des projectiles

	DATA	; X,Y,ANGLE,TYPE,ATTRIB
ProjMissile	dc.w	0,0,0,4000,0
