; ---------------------------------------------		
;	Timer 35 hz
; ---------------------------------------------		

; ------------------------------
;	Init
; ------------------------------

	TEXT
IT_Timer35hz_init
	move.l	$120.w,_old_timerb
	move.l	#Timer35hz,$120.w

	bset	#3,$fffffa17.w	; soft end of interrupt

	bset	#0,$fffffa07.w
	bset	#0,$fffffa13.w
	move.b	#7,$fffffa1b.w		; 2457600/200=12288
	move.b	#175,$fffffa21.w	; 12288/175=70

	clr	Timer35hz_flag
	clr.l	sys_hz_35
	rts

	BSS
_old_timerb	ds.l	1

; ------------------------------
;	Restauration
; ------------------------------

	TEXT
IT_Timer35hz_restaure
	move.l	_old_timerb,$120.w
	rts

; ------------------------------
;	Timer 35 hz
; ------------------------------

	TEXT
Timer35hz
	not	Timer35hz_flag	; 1 interruption sur 2 = 35hz
	beq	Timer35hz_fin
	addq.l	#1,sys_hz_35
;	move.l	#$66440022,$ffff9800.w

	movem.l	d0-d7/a0-a6,-(sp)

	; Controle player 1
	; Controle player 2
	; Controle player 3
	; Controle player 4
	; Controle objets
	; Controle console

	jsr	([ControleVbl])

; -------------	Zoom map in/out

	tst	maponscreen
	beq.s	no_9
	tst.b	K_7+clavier	; 7 - Zoom in carte
	beq.s	no_7
	subq.w	#1,map_zoom1
	cmp	#1<<2,map_zoom1
	bpl.s	no_7
	move	#1<<2,map_zoom1
no_7	
	tst.b	K_9+clavier	; 9 - Zoom out carte
	beq.s	no_9
	addq.w	#1,map_zoom1
	cmp	#1<<14,map_zoom1
	bmi.s	no_9
	move	#1<<14,map_zoom1
no_9
	tst.b	K_8+clavier	; 8 - Tomb Raider mode ?
	beq.s	not_pad8
	clr.b	K_8+clavier
	not	tombraidermode
not_pad8
	tst.b	K_4+clavier	; 4 - Textures verticales ?
	beq.s	not_pad4
	clr.b	K_4+clavier
	not	textured_walls
not_pad4
	tst.b	K_5+clavier	; 5 - Affichage de l'arme
	beq.s	not_pad5
	clr.b	K_5+clavier
	not	display_weapon
not_pad5
	tst.b	K_6+clavier	; 6 - Textures horizontales ?
	beq.s	not_pad6
	clr.b	K_6+clavier
	not	textured_floors
not_pad6
	tst.b	K_ENTER+clavier	; Enter - Affichage des sprites ?
	beq.s	no_enter
	clr.b	K_ENTER+clavier
	not	display_sprites
no_enter

; -------------	Touches de fonction

CALL_FKEY	MACRO
	tst.b	K_\1+clavier
	beq.s	no_F1\@
	clr.b	K_\1+clavier
	bset	#FUNC_\2,d0
	bra	no_Fkeys
no_F1\@
	ENDM

	move	DoFunctions,d0

	tst.b	K_RSHIFT+clavier
	beq.s	vblno_Rshift
	bset	#FUNC_SHIFT,d0
vblno_Rshift	tst.b	K_LSHIFT+clavier
	beq.s	vblno_Lshift
	bset	#FUNC_SHIFT,d0
vblno_Lshift	
	
	CALL_FKEY	F1,SNAPSHOT
	CALL_FKEY	F2,SAVEGAME
	CALL_FKEY	F3,LOADGAME
	CALL_FKEY	F4,SOUND
	CALL_FKEY	F5,DETAIL
	CALL_FKEY	F6,QUICKSAVE
	CALL_FKEY	F7,ENDGAME
	CALL_FKEY	F8,MESSAGES
	CALL_FKEY	F9,QUICKLOAD
	CALL_FKEY	F10,QUIT
no_Fkeys
	move	d0,DoFunctions

; -------------	Fin interruption

;	clr.l	$ffff9800.w
	movem.l	(sp)+,d0-d7/a0-a6
Timer35hz_fin
	bclr	#0,$fffffa0f.w
	rte
	
	BSS
Timer35hz_flag	ds.w	1
sys_hz_35	ds.l	1
