; ---------------------------------------------
;	Jouons de la Musique
; ---------------------------------------------

MAX_INSTRUMENTS	=	$b5
INPUT_FREQ	=	11025

;OUTPUT_FREQ	=	12292
;BUFSONLEN	=	90
;DMA_FREQ	=	CLK_12K

OUTPUT_FREQ	=	8195
BUFSONLEN	=	58
DMA_FREQ	=	CLK_8K

; ------------------------------
;	Vider les buffers au demarrage
; ------------------------------

	TEXT
Musique_Clear
	BUFFOPER	#0

	; Aucun sample charge au demarrage

	lea	Instruments,a0
	move	#255,d0
bcl_clr_inst
	move.l	#QuietInst,(a0)+
	dbra	d0,bcl_clr_inst

	; Pas de musique a jouer

	clr.l	BufferSon0
	clr.l	BufferSon1

	clr.l	MusPtr
	clr.l	vol_lookup
	clr	MusPlay

; -------------	Init buffer son

	XazMxalloc	#BUFSONLEN*2*2,#XAZ_STRAM
	cmp.l	#XAZ_ERR_MAX,d0
	bhs	Musique_Clear_fin

	move.l	d0,BufferSon0
	add.l	#BUFSONLEN*2,d0
	move.l	d0,BufferSon1

	move.l	BufferSon0,a0
	move.l	BufferSon1,a1
	moveq	#(BUFSONLEN*2)/4-1,d0
clearbufson
	clr.l	(a0)+
	clr.l	(a1)+
	dbra	d0,clearbufson

	clr	BufferFlag

	BSS

MusPlay	ds.w	1
BufferFlag	ds.w	1
BufferSon0	ds.l	1
BufferSon1	ds.l	1

; -------------	Init volume

	TEXT

	XazMxalloc	#128*256,#XAZ_PREFTTRAM
	cmp.l	#XAZ_ERR_MAX,d0
	bhs	Musique_Clear_fin1
	move.l	d0,vol_lookup
	
	move.l	d0,a0

	moveq	#0,d2
	moveq	#0,d1
.3
	move.b	d1,d3
	ext.w	d3
	muls	d2,d3
	divs	#127,d3	; i*j/127
	move.b	d3,(a0)+

	addq.b	#1,d1
	bne	.3

	addq.b	#1,d2
	cmp.b	#128,d2
	bne	.3

	BSS
vol_lookup	ds.l	1

; -------------	Init audio

	TEXT

	SOUNDCMD	#ADDERIN,#ADDR_ADC+ADDR_MATRIX
	SOUNDCMD	#ADCINPUT,#LEFT_MIC+RIGHT_MIC
;	SOUNDCMD	#SETPRESCALE,#CCLK_12K
	SETMODE	#MODE_STEREO8
	SETINTERRUPT	#INT_TIMERA,#INT_PLAY
	DEVCONNECT	#DMAPLAY,#DAC,#CLK_25M,#DMA_FREQ,#NO_SHAKE
	SETBUFFER	#PLAY,BufferSon0,BufferSon1
Musique_Clear_fin
	rts

	; Peut pas allouer table de volume : stop

Musique_Clear_fin1
	SupXazMfree	BufferSon0
	clr.l	BufferSon0
	
	rts

; ------------------------------
;	Lancer une musique
; ------------------------------
;	a0	Nom de la musique (D_xxxxxxx)

	TEXT
Musique_Play
	tst.l	BufferSon0
	beq	Musique_Play_fin
	tst.l	vol_lookup
	beq	Musique_Play_fin
	tst.l	MusPtr
	beq	Musique_Play_start

	move.l	a0,-(sp)
	bsr	Musique_Stop
	move.l	(sp)+,a0
Musique_Play_start

; -------------	Charger la musique

	move.l	dir_start,a1
	move.l	dir_end,a2
	bsr	cherche_adresse
	cmp.l	#0,a0
	beq	Musique_Play_fin
	move.l	4(a0),d0
	move.l	d0,MusMemSize
	clr	d0
	tst.l	d0
	bne	Musique_Play_fin ; Taille>65536 : pas bon
	move.l	(a0),a6

	SupXazMxalloc	MusMemSize,#XAZ_PREFTTRAM
	cmp.l	#XAZ_ERR_MAX,d0
	bhs	Musique_Play_fin
	move.l	d0,MusPtr
	move.l	d0,a5

	; Recopier la musique en memoire (a6)->(a5)

	move.l	MusMemSize,d0
	subq	#1,d0
copy_musique	move.b	(a6)+,(a5)+
	dbra	d0,copy_musique

	BSS
MusPtr	ds.l	1
MusMemSize	ds.l	1

; -------------	Mapper les instruments en mmoire

	TEXT

	clr.l	InstrAlloc
	SupXazFopen	#InstrFile,#XAZ_READONLY
	cmp.l	#XAZ_ERR_MAX,d0
	bhs	Musique_Play_free1
	move.l	d0,InstrAlloc
	
	DATA
InstrFile	dc.b	"MIDI_Instruments",0

	BSS
InstrAlloc	ds.l	1

; -------------	Vrifier que c'est un .MUS

	RsReset
MusID	rs.l	1	; "MUS"^Z
MusLen	rs.w	1
MusStart	rs.w	1
MusChannels1	rs.w	1
MusChannels2	rs.w	1
MusNbInst	rs.w	1
MusDummy	rs.w	1
MusListInst	rs.b	1

	TEXT

	move.l	MusPtr,a0
	move.l	MusMemSize,d3

	cmpi.l	#$4D55531A,MusID(a0)	; "MUS",26
	bne	Musique_Play_free	; not a mus file

	lea	MusLen(a0),a1
	REPT	6
	move	(a1),d0
	ror	#8,d0
	move	d0,(a1)+
	ENDR

	moveq	#0,d0
	move	MusLen(a0),d0
	beq	Musique_Play_free

	moveq	#0,d1
	move	MusStart(a0),d1
	cmp	#18,d1	; start < 18? (1 instr.)
	blt	Musique_Play_free
	add.l	d1,d0	; d0 = total size

	cmp.l	d3,d0	; = file size?
	bne	Musique_Play_free

	move	MusNbInst(a0),d2
	beq	Musique_Play_free
	
	subq	#1,d2
	lea	MusListInst(a0),a1	; a1 = * instr. list
.loop
	move	(a1),d0	; Numero des instruments
	ror	#8,d0

	bsr	LoadInstrument

	move	d0,(a1)+
	dbra	d2,.loop	; next

	move.l	a1,d0	; d0 = * data following list
	sub.l	a0,d0	; - file start
	cmp.l	d0,d1	; = start?
	bne	Musique_Play_free

	move.b	-1(a0,d3.l),d0	; get last byte
	lsr.b	#4,d0
	cmp.b	#6,d0	; last byte = $6x? (end)
	bne	Musique_Play_free
	
; -------------	Init la musique

	move.l	MusPtr,a0
	moveq	#0,d0
	move	MusStart(a0),d0		; score start
	add.l	d0,a0		; a0 = start

	move.l	a0,MusIndex		; MusIndex = start

	move.l	#QuietInst,Channel0
	move.l	#QuietInst,Channel1
	move.l	#QuietInst,Channel2
	move.l	#QuietInst,Channel3
	move.l	#QuietInst,Channel4
	move.l	#QuietInst,Channel5
	move.l	#QuietInst,Channel6
	move.l	#QuietInst,Channel7
	move.l	#QuietInst,Channel8
	move.l	#QuietInst,Channel9
	move.l	#QuietInst,Channel10
	move.l	#QuietInst,Channel11
	move.l	#QuietInst,Channel12
	move.l	#QuietInst,Channel13
	move.l	#QuietInst,Channel14
	move.l	#QuietInst,Channel15

	clr.l	MusDelay		; MusDelay = 0
	clr.l	VoiceAvail		; all voices available

	clr.b	Voice0+vc_Flags		; disable voices
	clr.b	Voice1+vc_Flags
	clr.b	Voice2+vc_Flags
	clr.b	Voice3+vc_Flags
	clr.b	Voice4+vc_Flags
	clr.b	Voice5+vc_Flags
	clr.b	Voice6+vc_Flags
	clr.b	Voice7+vc_Flags
	clr.b	Voice8+vc_Flags
	clr.b	Voice9+vc_Flags
	clr.b	Voice10+vc_Flags
	clr.b	Voice11+vc_Flags
	clr.b	Voice12+vc_Flags
	clr.b	Voice13+vc_Flags
	clr.b	Voice14+vc_Flags
	clr.b	Voice15+vc_Flags

	DATA

	RsReset
ch_Instr	rs.l	1
ch_Map	rs.l	1
ch_Pitch	rs.l	1
ch_LtVol	rs.l	1
ch_RtVol	rs.l	1
ch_Vol	rs.b	1
ch_Pan	rs.b	1
ch_Size	rs.w	1

Channels	dc.l	Channel0,Channel1,Channel2,Channel3
	dc.l	Channel4,Channel5,Channel6,Channel7
	dc.l	Channel8,Channel9,Channel10,Channel11
	dc.l	Channel12,Channel13,Channel14,Channel15

MAKECHANNEL	MACRO	numero
Channel\1	dc.l	0	; instrument
	dc.l	Channel\1Map	; note to voice map
	dc.l	0	; pitch wheel setting
	dc.l	0	; left volume table
	dc.l	0	; right volume table
	dc.b	0	; volume
	dc.b	0	; pan setting
Channel\1Map	dcb.b	128,0
	ENDM

	MAKECHANNEL	0
	MAKECHANNEL	1
	MAKECHANNEL	2
	MAKECHANNEL	3
	MAKECHANNEL	4
	MAKECHANNEL	5
	MAKECHANNEL	6
	MAKECHANNEL	7
	MAKECHANNEL	8
	MAKECHANNEL	9
	MAKECHANNEL	10
	MAKECHANNEL	11
	MAKECHANNEL	12
	MAKECHANNEL	13
	MAKECHANNEL	14
	MAKECHANNEL	15

	RsReset
vc_Next	rs.l	1
vc_Channel	rs.l	1
vc_Wave	rs.l	1
vc_Index	rs.l	1
vc_Step	rs.l	1
vc_Loop	rs.l	1
vc_Length	rs.l	1
vc_LtVol	rs.l	1
vc_RtVol	rs.l	1
vc_Flags	rs.b	1	; b7 = SFX, b1 = RLS, b0 = EN
vc_Size	rs.w	1

Voices	dc.l	Voice0,Voice1,Voice2,Voice3
	dc.l	Voice4,Voice5,Voice6,Voice7
	dc.l	Voice8,Voice9,Voice10,Voice11
	dc.l	Voice12,Voice13,Voice14,Voice15

MAKEVOICE	MACRO	num_voice
	IFEQ	\1-15
Voice\1	dc.l	0
	ELSE
Voice\1	dc.l	Voice\1+vc_Size
	ENDC
	dc.l	0,0,0,0,0,0,0,0
	dc.b	0
	ENDM

	MAKEVOICE	0
	MAKEVOICE	1
	MAKEVOICE	2
	MAKEVOICE	3
	MAKEVOICE	4
	MAKEVOICE	5
	MAKEVOICE	6
	MAKEVOICE	7
	MAKEVOICE	8
	MAKEVOICE	9
	MAKEVOICE	10
	MAKEVOICE	11
	MAKEVOICE	12
	MAKEVOICE	13
	MAKEVOICE	14
	MAKEVOICE	15

	BSS

MusIndex	ds.l	1	; Position dans la musique
MusDelay	ds.l	1
VoiceAvail	ds.l	1

; -------------	Lancer la musique

	TEXT

	move.l	BufferSon0,a0
	move.l	BufferSon1,a1
	moveq	#(BUFSONLEN*2)/4-1,d0
clearbufson1
	clr.l	(a0)+
	clr.l	(a1)+
	dbra	d0,clearbufson1

	move	#1,MusPlay
	BUFFOPER	#PLAY_ENABLE+PLAY_REPEAT
Musique_Play_free
	SupXazFclose	InstrAlloc
Musique_Play_fin
	rts

Musique_Play_free1
	SupXazMfree	MusPtr
	rts

; ------------------------------
;	Charger un instrument
; ------------------------------
;	d0	numero de l'instrument
;	InstrAlloc	fichier mappe en memoire
;	Instruments	infos des instruments

	RsReset
in_Wave	rs.l	1	; Frequence -> Adresse du sample
in_Loop	rs.l	1	; Boucle
in_Length	rs.l	1	; Longueur
in_Flags	rs.b	1	; Flags
in_Base	rs.b	1	; Note de base
in_Sample	rs.b	1	; Sample
in_Size	=	in_Sample

	TEXT
LoadInstrument
	movem.l	d0-d7/a0-a6,-(sp)

	cmp	#MAX_INSTRUMENTS,d0
	bhi	LoadInstrument_fin
	lea	Instruments,a4
	lea	(a4,d0.w*4),a4
	move.l	InstrAlloc,a6
	move.l	(a6,d0.w*4),d7
	beq	LoadInstrument_fin

	lea	(a6,d7.l),a5
	clr.l	d6
	move	in_Length(a5),d6	; Longueur	
	add	#in_Size,d6		; + entete
	SupXazMxalloc	d6,#XAZ_PREFTTRAM
	cmp.l	#XAZ_ERR_MAX,d0
	bhs	LoadInstrument_fin
	move.l	d0,(a4)
	; a5 = source
	move.l	d0,a6
	move.l	in_Loop(a5),in_Loop(a6)
	move.l	in_Length(a5),in_Length(a6)
	move.b	#1,in_Flags(a6)
	move.b	in_Base(a5),in_Base(a6)
	lea	in_Size(a6),a4
	move.l	a4,in_Wave(a6)

	move	in_Length(a5),d0
	lea	in_Size(a5),a5
	subq	#1,d0
loadinst_bcl	move.b	(a5)+,(a4)+
	dbra	d0,loadinst_bcl

LoadInstrument_fin
	movem.l	(sp)+,d0-d7/a0-a6
	rts

	DATA
	
Instruments	dcb.l	256,0	; Adresse des instruments

QuietInst	dc.l	0,0,0
	dc.b	0,0

; ------------------------------
;	Arreter une musique
; ------------------------------

	TEXT
Musique_Stop
	clr	MusPlay

	; Arreter de jouer

	BUFFOPER	#0
	
	; Liberer tous les samples utilises

	lea	Instruments,a6
	move	#255,d7
free_inst
	move.l	(a6),d0
	cmp.l	#QuietInst,d0	
	beq	free_inst_next
	move.l	#QuietInst,(a6)
	SupXazMfree	d0

free_inst_next	addq	#4,a6
	dbra	d7,free_inst

	; Liberer la musique en cours
	
	tst.l	MusPtr
	beq	musstop_nomus
	SupXazMfree	MusPtr
	clr.l	MusPtr
musstop_nomus	
	rts

; ------------------------------
;	Init
; ------------------------------

	TEXT
IT_music_init
	move.l	$134.w,_old_timera
	move.l	#AudioINT2,$134.w

	bset	#5,$fffffa07.w
	bset	#5,$fffffa13.w
	move.b	#8,$fffffa19.w
	move.b	#1,$fffffa1f.w

	rts

	BSS
_old_timera	ds.l	1

; ------------------------------
;	Restauration
; ------------------------------

	TEXT
IT_music_restaure
	move.l	_old_timera,$134.w
	rts

; ------------------------------
;	Interruption musique , jouer les buffers
; ------------------------------
;	140 Hz : 11025/140=80 octets/voix

	TEXT
AudioINT2
	tst	MusPlay
	beq	AudioINT2_fin

	movem.l	d0-d7/a0-a6,-(sp)
	subq.l	#1,MusDelay
	bpl	.setaudio

	bsr	NextEvent
.setaudio	
	move.l	BufferSon0,a1
	not	BufferFlag
	beq	noswapbuf
	move.l	BufferSon1,a1
noswapbuf	move.l	a1,AudioBuffer

	bsr	FillBuffer

; -------------	Choix du buffer son

	move.l	AudioBuffer,a1
	lea	$ffff8900.w,a0

	move.l	a1,d0
	move.b	d0,$07(a0)
	ror	#8,d0
	move.l	d0,$02(a0)
	ror	#8,d0

	add.l	#BUFSONLEN*2,d0

	move.b	d0,$13(a0)
	ror	#8,d0
	move.l	d0,$0e(a0)
	ror	#8,d0

	movem.l	(sp)+,d0-d7/a0-a6
AudioINT2_fin
	bclr	#5,$fffffa0f.w
	rte
	
	BSS
AudioBuffer	ds.l	1

;--------------	Remplissage buffer audio

	TEXT
FillBuffer
;	move.l	AudioBuffer,a1
	moveq	#(BUFSONLEN*2)/4-1,d0
.lcloop	clr.l	(a1)+
	dbra	d0,.lcloop

	lea	Voice0,a0	; music voices
	bra	.1stvoice
.next
	move.l	vc_Next(a0),d0	; next voice
	bne	.chkvoice
	rts
.chkvoice
	move.l	d0,a0
.1stvoice
	btst	#0,vc_Flags(a0)
	beq	.next	; not enabled

;------------------
; do voice

	btst	#1,vc_Flags(a0)
	beq	.1	; not releasing

	tst.l	vc_LtVol(a0)
	beq	.0
	sub.l	#256,vc_LtVol(a0)

.0	tst.l	vc_RtVol(a0)
	beq	.1
	sub.l	#256,vc_RtVol(a0)

.1	move.l	vc_LtVol(a0),d6
	move.l	vc_RtVol(a0),d7
	tst.l	d6
	bne	.2	; not off yet
	tst.l	d7
	bne	.2	; not off yet

	clr.b	vc_Flags(a0)	; voice off
	bra	.next

.2
;	lea	tempAudio,a1	; audio buffer
	move.l	AudioBuffer,a1
	move.l	vol_lookup,a5

	movem.l	vc_Index(a0),d1-d4	; index,step,loop,length

	move.l	vc_Channel(a0),a3
	move.l	ch_Pitch(a3),d0
	muls.l	d0,d5:d2
	move	d5,d2
	swap	d2
	add.l	vc_Step(a0),d2	; final sample rate
	mulu.l	#INPUT_FREQ,d5:d2
	divu.l	#OUTPUT_FREQ,d5:d2

	move.l	vc_Wave(a0),a3	; sample data

	moveq	#BUFSONLEN-1,d5	; 80 samples
.floop	
	move.l	d1,d0
	swap	d0
	move.b	(a3,d0.w),d6	; sample
	move.b	d6,d7
	move.b	(a5,d6.l),d6	; convert
	move.b	(a5,d7.l),d7	; convert
	asr.b	#2,d6
	asr.b	#2,d7
	add.b	d6,(a1)+	; left sample
	add.b	d7,(a1)+	; right sample

	add.l	d2,d1
	cmp.l	d4,d1
	blo	.3
	sub.l	d4,d1
	add.l	d3,d1
	tst.l	d3
	beq	.4	; no looping
.3	dbra	d5,.floop
	bra	.done	; done with voice

; ran out of data
.4	clr.b	vc_Flags(a0)	; voice off

.done	move.l	d1,vc_Index(a0)
	bra	.next

; -------------	Evnement MIDI

	TEXT
NextEvent
	move.l	MusIndex,a1
.0
	move.b	(a1)+,d0	; get next event
	move.b	d0,d1
	lsr	#4,d1
	and	#7,d1
	jsr	([EventTable,d1.w*4])
	tst.b	d0
	bpl.b	.0	; more events

	moveq	#0,d1	; time = 0
.1	move.b	(a1)+,d0	; get byte
	bpl	.2

	and	#$7F,d0	; kill sign bit
	or.b	d0,d1	; time = time + 7 bits
	lsl.l	#7,d1	; * 128
	bra	.1	; get next 7 bits

.2	or.b	d0,d1	; time = time + last 7 bits
	subq.l	#1,d1	; delay = time - 1
	bmi.b	.0	; (no delay)

	move.l	d1,MusDelay	; store delay
	move.l	a1,MusIndex	; store index
	rts

; ------------------------------
;	Evnements MIDI
; ------------------------------

	TEXT
SetVolume
	move.b	d2,ch_Vol(a2)
	moveq	#0,d3
	move.b	ch_Pan(a2),d3
	addq.w	#1,d3	; sep += 1
	move	d2,d4
	muls	d3,d4
	muls	d3,d4
	clr	d4
	swap	d4
	neg	d4
	add	d2,d4	; ltvol = vol - vol * (sep+1)^2 / 256^2
	lsl.l	#8,d4
	move.l	d4,ch_LtVol(a2)

	sub.l	#257,d3	; sep -= 257
	move	d2,d4
	muls	d3,d4
	muls	d3,d4
	clr	d4
	swap	d4
	neg	d4
	add	d2,d4	; rtvol = vol - vol * (sep-257)^2 / 256^2
	lsl.l	#8,d4
	move.l	d4,ch_RtVol(a2)

	rts

; -------------	Release

Release	moveq	#15,d1
	and.b	d0,d1	; d1 = channel

	lea	Channels,a0
	move.l	(a0,d1.w*4),a0	; channel record
	move.l	ch_Map(a0),a0	; channel map

	move.b	(a1)+,d1	; note #
	moveq	#0,d2
	move.b	(a0,d1.w),d2	; voice #
	beq	.exit	; no mapping

	clr.b	(a0,d1.w)	; clear mapping
	move.l	VoiceAvail,d3
	bclr	d2,d3	; voice free for use
	move.l	d3,VoiceAvail

	lea	Voices,a0
	move.l	(a0,d2.w*4),a0	; voice
	bset	#1,vc_Flags(a0)	; do release

.exit	rts

;--------------	PlayNote

PlayNote	moveq	#15,d1
	and.b	d0,d1	; d1 = channel

	lea	Channels,a0
	move.l	(a0,d1.w*4),a2	; channel record
	move.l	ch_Map(a2),a0	; channel map

	moveq	#-1,d2	; no volume change
	move.b	(a1)+,d1	; note #
	bclr	#7,d1
	beq	.getvc	; no volume

	moveq	#0,d2
	move.b	(a1)+,d2	; volume

.getvc	moveq	#0,d3
	move.l	VoiceAvail,d4
.vloop	bset	d3,d4
	beq	.foundfree
	addq.b	#1,d3
	cmp.b	#16,d3
	bne	.vloop
; no free voices
	rts

.foundfree	move.b	d3,(a0,d1.w)	; voice mapping
	move.l	d4,VoiceAvail

	lea	Voices,a0
	move.l	(a0,d3.w*4),a3	; voice

	; new channel volume ?

	tst.b	d2
	bmi	.skip

	bsr	SetVolume

.skip	move.l	ch_LtVol(a2),vc_LtVol(a3)
	move.l	ch_RtVol(a2),vc_RtVol(a3)

	moveq	#15,d2
	and.b	d0,d2
	cmp.b	#15,d2
	beq	.percussion

	move.l	ch_Instr(a2),a4		; instrument record

	lea	NoteTable,a0
	moveq	#72,d2		; one octave above middle c
	sub.b	in_Base(a4),d2
	add.b	d1,d2
	move.l	(a0,d2.w*4),vc_Step(a3)	; step value for note

	clr.l	vc_Index(a3)

	move.l	a2,vc_Channel(a3)	; back link (for pitch wheel)

	move.l	in_Wave(a4),vc_Wave(a3)
	move.l	in_Loop(a4),vc_Loop(a3)
	move.l	in_Length(a4),vc_Length(a3)
	move.b	in_Flags(a4),vc_Flags(a3)
.exit	rts

; for the percussion channel, the note played sets the percussion instrument

.percussion	move.l	#65536,vc_Step(a3)	; sample rate always 1.0

	clr.l	vc_Index(a3)

	move.l	a2,vc_Channel(a3)	; back link

	add.b	#100,d1	; percussion instruments

	lea	Instruments,a0
	move.l	(a0,d1.w*4),a0		; instrument record
	move.l	in_Wave(a0),vc_Wave(a3)
	move.l	in_Loop(a0),vc_Loop(a3)
	move.l	in_Length(a0),vc_Length(a3)
	move.b	in_Flags(a0),vc_Flags(a3)
	rts

;--------------	Pitch

Pitch	moveq	#15,d1
	and.b	d0,d1	; d1 = channel

	lea	Channels,a0
	move.l	(a0,d1.w*4),a2	; channel record

	moveq	#0,d1
	move.b	(a1)+,d1	; pitch wheel setting
	lea	PitchTable,a0
	move.l	(a0,d1.w*4),ch_Pitch(a2)
	rts

;--------------	Tempo

Tempo	addq.l	#1,a1	; skip value
	rts

;--------------	Change control

ChangeCtrl	moveq	#15,d1
	and.b	d0,d1	; d1 = channel

	lea	Channels,a0
	move.l	(a0,d1.w*4),a2	; channel

	move.b	(a1)+,d1	; get controller

	moveq	#0,d2
	move.b	(a1)+,d2	; value

	; set channel instrument ?
	
	tst.b	d1
	bne	.1

	lea	Instruments,a0
	move.l	(a0,d2.w*4),ch_Instr(a2)
	bne	.0
	move.l	#QuietInst,ch_Instr(a2)
.0	rts

	; set channel volume ?

.1	cmp.b	#3,d1	; volume?
	bne	.2

	bsr	SetVolume

	rts

	; set channel pan ?

.2	cmp.b	#4,d1	; pan?
	bne	.exit

	add.b	d2,d2	; pan -> sep
	move.b	d2,ch_Pan(a2)

	bsr	SetVolume
.exit
	rts

;--------------	No event

NoEvent	rts

;--------------	End score

EndScore	move.l	MusPtr,a1
	moveq	#0,d1
	move	6(a1),d1	; score start
	add.l	d1,a1	; a1 = start

	rts

; -------------	Donnes diverses

	DATA

EventTable	dc.l	Release
	dc.l	PlayNote
	dc.l	Pitch
	dc.l	Tempo
	dc.l	ChangeCtrl
	dc.l	NoEvent
	dc.l	EndScore
	dc.l	NoEvent

NoteTable	dc.l	65536/64,69433/64,73562/64,77936/64,82570/64,87480/64,92682/64,98193/64,104032/64,110218/64,116772/64,123715/64
	dc.l	65536/32,69433/32,73562/32,77936/32,82570/32,87480/32,92682/32,98193/32,104032/32,110218/32,116772/32,123715/32
	dc.l	65536/16,69433/16,73562/16,77936/16,82570/16,87480/16,92682/16,98193/16,104032/16,110218/16,116772/16,123715/16
	dc.l	65536/8,69433/8,73562/8,77936/8,82570/8,87480/8,92682/8,98193/8,104032/8,110218/8,116772/8,123715/8
	dc.l	65536/4,69433/4,73562/4,77936/4,82570/4,87480/4,92682/4,98193/4,104032/4,110218/4,116772/4,123715/4
	dc.l	65536/2,69433/2,73562/2,77936/2,82570/2,87480/2,92682/2,98193/2,104032/2,110218/2,116772/2,123715/2
	dc.l	65536,69433,73562,77936,82570,87480,92682,98193,104032,110218,116772,123715
	dc.l	65536*2,69433*2,73562*2,77936*2,82570*2,87480*2,92682*2,98193*2,104032*2,110218*2,116772*2,123715*2
	dc.l	65536*4,69433*4,73562*4,77936*4,82570*4,87480*4,92682*4,98193*4,104032*4,110218*4,116772*4,123715*4
	dc.l	65536*8,69433*8,73562*8,77936*8,82570*8,87480*8,92682*8,98193*8,104032*8,110218*8,116772*8,123715*8
	dc.l	65536*16,69433*16,73562*16,77936*16,82570*16,87480*16,92682*16,98193*16

PitchTable

pitch_ix	SET	128

	REPT	128
	dc.l	-3678*pitch_ix/64
pitch_ix	SET	pitch_ix-1
	ENDR

	REPT	128
	dc.l	3897*pitch_ix/64
pitch_ix	SET	pitch_ix+1
	ENDR
