; ------------------------------
;	Activation d'un LINEDEF
; -----------------------------

CALCUL_BLOC1L	MACRO	pos_joueur,bloc_origine,bloc_start,bloc_end

	move	\1,d7
	sub	\2,d7
	move	d7,d6
	asr	#7,d7
	and	#127,d6
	move	d7,\3
	move	d7,\4

	cmp	d2,d6
	bpl.s	bx_start\@
	subq	#1,d7
	move	d7,\3
	bra.s	bx_end\@
bx_start\@	cmp	d3,d6
	bmi.s	bx_end\@
	addq	#1,d7
	move	d7,\4
bx_end\@
	ENDM

CALCUL_BLOC2L	MACRO	pos_joueur,bloc_origine,bloc_start,bloc_end

	move	\1,d7
	sub	\2,d7
	move	d7,d6
	asr	#7,d7
	and	#127,d6

	cmp	d2,d6
	bpl.s	bx_start1\@
	subq	#1,d7
bx_start1\@	cmp	d3,d6
	bmi.s	bx_end1\@
	addq	#1,d7
bx_end1\@
	cmp	\3,d7
	bpl.s	bx_comp1\@
	move	d7,\3
bx_comp1\@
	cmp	\4,d7
	bmi.s	bx_comp2\@
	move	d7,\4
bx_comp2\@
	ENDM

BLOC_CLIPL	MACRO	variable,limite
	move	\1,d4
	bpl.s	testact_c1\@
	moveq	#0,d4
testact_c1\@	cmp	\2,d4
	bmi.s	testact_c2\@
	move	\2,d4
	subq	#1,d4
testact_c2\@	move	d4,\1
	ENDM

; ------------------------------
;	Savoir quels sont les blocs concerns
; ------------------------------
;	a0 Objet concern

	TEXT
TestActivation
	move	OBJET_RAYON(a0),d6
	add	#24,d6
	move	d6,act_rayon
	ext.l	d6

	; Calculer le point d'arrive de l'activation

	move	OBJET_A(a0),d5
	move.l	([cosinus],d5.w),d4
	move.l	([sinus],d5.w),d5

	muls.l	d6,d4
	add.l	OBJET_X(a0),d4
	swap	d4

	muls.l	d6,d5
	add.l	OBJET_Y(a0),d5
	swap	d5

	; Calculer les blocs de depart/arrive

	move.l	adr_blockmap,a1
	move.l	a1,a2
	movem	(a1)+,d0-d1	; blockmap origine x,y

	move	act_rayon,d2
	move	#128,d3
	sub	d2,d3
	CALCUL_BLOC1L	OBJET_X(a0),d0,bxdebut,bxfin
	CALCUL_BLOC1L	OBJET_Y(a0),d1,bydebut,byfin

	move	OBJET_RAYON(a0),d2
	sub	#24,d2
	move	#128,d3
	sub	d2,d3
	CALCUL_BLOC2L	d4,d0,bxdebut,bxfin
	CALCUL_BLOC2L	d5,d1,bydebut,byfin

	; Clipping des blocs de depart/arrivee

	movem	(a1)+,d2-d3	; blockmap colonnes,lignes
	BLOC_CLIPL	bxdebut,d2
	BLOC_CLIPL	bxfin,d2
	BLOC_CLIPL	bydebut,d3
	BLOC_CLIPL	byfin,d3

	; Permuter si le bloc de fin < bloc debut

	move	bxdebut,d0
	move	bxfin,d1
	cmp	d0,d1
	bpl.s	.bxdebutinffin
	move	d1,bxdebut
	move	d0,bxfin
.bxdebutinffin
	move	bydebut,d0
	move	byfin,d1
	cmp	d0,d1
	bpl.s	.bydebutinffin
	move	d1,bydebut
	move	d0,byfin
.bydebutinffin

	; Et on fait la double boucle
	; a2 Adresse de la blockmap
	; d2 Nombre de colonnes
	; d3 Nombre de lignes

	move	#-1,LinedefActivate
	
	move	bydebut,d0
	move	d0,d3
	mulu	d2,d3
	lea	(a1,d3.l*2),a1	; Adresse de la ligne de blocs
.bloc_boucley
	move	bxdebut,d1
	lea	(a1,d1.w*2),a4	; a4 Bloc dans la ligne
.bloc_bouclex
	move	(a4)+,d3	; colonne suivante
	lea	2(a2,d3.w*2),a3	; Adresse de la liste de LINEDEFS (on passe le zero)
.bloc_bclldf_nxt
	move	(a3)+,d3	; Au moins un LINEDEF
	bmi.s	.bloc_bclldf_fin
	bsr	TestActivationLinedef
	bra.s	.bloc_bclldf_nxt
.bloc_bclldf_fin
	addq	#1,d1
	cmp	bxfin,d1
	ble.s	.bloc_bouclex

	lea	(a1,d2.w*2),a1	; ligne suivante
	addq	#1,d0
	cmp	byfin,d0
	ble.s	.bloc_boucley

	move	LinedefActivate,d0
	ble.s	TAL_NoActLine

	mulu	#SIZEOF_LINEDEF,d0
	lea	([adr_linedefs],d0.l),a1
	move	LINEDEF_RSIDE(a1),d0
	move	LINEDEF_LSIDE(a1),d1

	move	#COND_S,ActivateType
	move	Clefs,d0
	and	#%111,d0
	lsl	#COND_BLUEKEY,d0
	or	d0,ActivateType
	
	bsr	ActivateLinedef
TAL_NoActLine
	rts

; -----------------------------
;	Activation d'un LINEDEF ?
; -----------------------------
;	d3	Numro du LINEDEF

	TEXT
TestActivationLinedef
	movem.l	d0-d7/a0-a6,-(sp)

	move	d3,LinedefNumber
	mulu	#SIZEOF_LINEDEF,d3
	lea	([adr_linedefs],d3.l),a1
	tst	LINEDEF_TYPE(a1)
	beq	TA_bcl_next

	; Calcul du cote

	move	OBJET_X(a0),d0
	move	OBJET_Y(a0),d1
	bsr	TCL_CalcSide
	move	d7,LinedefSide

	; Projection dans direction observateur
	
	move	OBJET_A(a0),d7
	move.l	([cosinus],d7.w),d6
	move.l	([sinus],d7.w),d7
	
	move	LINEDEF_VERTEX1(a1),d0
	movem	(VERTEX_X,[adr_vertexes],d0.w*SIZEOF_VERTEX),d2-d3
	sub	OBJET_X(a0),d2
	ext.l	d2
	sub	OBJET_Y(a0),d3
	ext.l	d3
	move.l	d2,d4
	move.l	d3,d5
	
	muls.l	d6,d2	; d2=x*cos a
	muls.l	d7,d3	; d3=y*sin a
	muls.l	d6,d5	; d5=y*cos a
	muls.l	d7,d4	; d4=x*sin a	
	add.l	d3,d2	; d2= x*cos a+y*sin a
	sub.l	d4,d5	; d5=-x*sin a+y*cos a
	move.l	d2,act_x1
	move.l	d5,act_y1

	move	LINEDEF_VERTEX2(a1),d0
	movem	(VERTEX_X,[adr_vertexes],d0.w*SIZEOF_VERTEX),d2-d3
	sub	OBJET_X(a0),d2
	ext.l	d2
	sub	OBJET_Y(a0),d3
	ext.l	d3
	move.l	d2,d4
	move.l	d3,d5
	
	muls.l	d6,d2	; d2=x*cos a
	muls.l	d7,d3	; d3=y*sin a
	muls.l	d6,d5	; d5=y*cos a
	muls.l	d7,d4	; d4=x*sin a	
	add.l	d3,d2	; d2= x*cos a+y*sin a
	sub.l	d4,d5	; d5=-x*sin a+y*cos a
	move.l	d2,act_x2
	move.l	d5,act_y2
	
	; Si Intersection avec y=0 et 0<x<PR+24 alors activation

	move.l	act_x1,d2
	move.l	act_y1,d3
	move.l	act_x2,d4
	move.l	act_y2,d5

	; Si y1 et y2 du meme signe : pas bon

	tst.l	d3
	bmi.s	TA_y1neg
	tst.l	d5
	bpl	TA_bcl_next
	bra.s	TA_y2pos
TA_y1neg	tst.l	d5
	bmi	TA_bcl_next
TA_y2pos

	; Si x1 et x2 ngatifs : pas bon
	
	tst.l	d2
	bpl.s	TA_x1pos
	tst.l	d4
	bmi	TA_bcl_next
TA_x1pos
;	bset	#WALL_COLLISION-8,LINEDEF_ATTRIB(a1)

	; Si y1 ngatif : pas bon = cote gauche

	tst.l	d3
	bmi	TA_bcl_next

	; Calculer le point x tel que y=0
	; x=x1+(0-y1)*(x2-x1)/(y2-y1)

	sub.l	d2,d4	; d4=x2-x1
	sub.l	d3,d5	; d5=y2-y1
	neg.l	d3	; d3=-y1
	muls.l	d3,d7:d4	; d7:d4=(-y1)*(x2-x1)
	divs.l	d5,d7:d4	; d4=(-y1)*(x2-x1)/(y2-y1)
	add.l	d2,d4	; d4=x1-y1*(x2-x1)/(y2-y1)
	swap	d4

	tst	d4	; si x ngatif pas bon
	bmi.s	TA_bcl_next
	cmp	act_rayon,d4
	bpl.s	TA_bcl_next

	tst	LinedefActivate
	bmi.s	TA_FirstLinedef
	cmp	act_dist,d4	; Si linedef>dist alors pas acti
	bpl.s	TA_bcl_next
TA_FirstLinedef
	move	d4,act_dist	; Distance d'activation
	move	LinedefSide,LinedefActSide
	move	LinedefNumber,LinedefActivate
TA_bcl_next
	movem.l	(sp)+,d0-d7/a0-a6
	rts

	BSS
act_x1	ds.l	1
act_y1	ds.l	1
act_x2	ds.l	1
act_y2	ds.l	1

act_dist	ds.w	1
act_rayon	ds.w	1	; rayon+24

