; ------------------------------
;	Activation d'un LINEDEF
; ------------------------------
;	a0 Objet qui active
;	a1 LINEDEF associ

	TEXT
ActivateLinedef
	move	LINEDEF_TYPE(a1),d1
	move	d1,ActivateNb
	cmp	ActivateMax,d1
	bpl.s	AL_not_ok

	mulu	#SIZEOF_ACTION,d1
	lea	([ActivateTable],d1.l),a3

	; Tester si activation possible suivant conditions

	clr	d0
	move.b	ACT_CONDITION(a3),d0
	and	ActivateType,d0
	beq.s	AL_not_ok

	; Si c'est un switch: permuter texture
	
	btst	#COND_SWITCH,d0
	beq.s	AL_NoSwitch

	move	LINEDEF_RSIDE(a1),d2
	bmi.s	AL_NoSwitch

	move.l	adr_sidedefs,a2
	mulu	#SIZEOF_SIDEDEF,d2
	add.l	d2,a2
	
	movem	SIDEDEF_NAME(a2),d2-d3
	exg	d2,d3
	movem	d2-d3,SIDEDEF_NAME(a2)

	movem	SIDEDEF_UPNAME(a2),d2-d3
	exg	d2,d3
	movem	d2-d3,SIDEDEF_UPNAME(a2)

	movem	SIDEDEF_LONAME(a2),d2-d3
	exg	d2,d3
	movem	d2-d3,SIDEDEF_LONAME(a2)
AL_NoSwitch
	
	; Tester si un secteur ou tous secteurs taggs
	
	cmp.b	#ETENDUE_ALL,ACT_ETENDUE(a3)
	beq.s	AL_EtendueAll
	bra.s	AL_EtendueOne
AL_not_ok	
	rts

	BSS
ActivateMax	ds.w	1	; Nb d'activations possibles+1
ActivateTable	ds.l	1
ActivateType	ds.w	1	; Type d'activation
ActivateNb	ds.w	1	; Type du Linedef  activer

; ------------------------------
;	Un seul secteur
; ------------------------------

	TEXT
AL_EtendueOne
	tst.l	ACT_ROUTINE(a3)
	beq.s	AL_EtendueOne_stop

	tst	ACT_REPETE(a3)
	bne.s	AL_EO_Repeat
	clr	LINEDEF_TYPE(a1)
AL_EO_Repeat
	jsr	([ACT_ROUTINE,a3])
AL_EtendueOne_stop
	rts

; ------------------------------
;	Tous les secteurs taggs
; ------------------------------

	TEXT
AL_EtendueAll
	tst.l	ACT_ROUTINE(a3)
	beq.s	AL_EtendueAll_stop

	tst	ACT_REPETE(a3)
	bne.s	AL_EA_Repeat
	clr	LINEDEF_TYPE(a1)
AL_EA_Repeat
	move	LINEDEF_TAG(a1),d0
	move.l	adr_sectors,a2
	move.l	num_sectors,d1
	subq	#1,d1
AL_EA_bcl
	cmp	SECTOR_TRIGGER(a2),d0
	bne.s	AL_EA_bcl_next
	tst	SECTOR_FCMOVE(a2)
	bne.s	AL_EA_bcl_next
	jsr	([ACT_ROUTINE,a3])
AL_EA_bcl_next
	lea	SIZEOF_SECTOR(a2),a2
	dbra	d1,AL_EA_bcl
AL_EtendueAll_stop
	rts

; ------------------------------
;	Rechercher une hauteur limite
; ------------------------------
;	Trouver un LINEDEF TWOSIDED commun avec a2
;	a0 Routine de comparaison
;	a2 SECTOR
;	d7 Valeur de dpart de la limite

;	d7 -> valeur trouve
; ------------------------------

SearchLimit
	movem.l	d3-d6/a3-a5,-(sp)

	move.l	adr_linedefs,a3
	move.l	num_linedefs,d3
	subq	#1,d3
SL_bcl
	btst	#TWO_SIDED,LINEDEF_ATTRIB+1(a3)
	beq.s	SL_bcl_next
	move.l	adr_sectors,a5
	
	move	LINEDEF_RSIDE(a3),d4
	mulu	#SIZEOF_SIDEDEF,d4
	move	(SIDEDEF_SECTOR,[adr_sidedefs],d4.l),d4
	mulu	#SIZEOF_SECTOR,d4
	lea	(a5,d4.l),a4

	move	LINEDEF_LSIDE(a3),d5
	mulu	#SIZEOF_SIDEDEF,d5
	move	(SIDEDEF_SECTOR,[adr_sidedefs],d5.l),d5
	mulu	#SIZEOF_SECTOR,d5
	lea	(a5,d5.l),a5

	cmp.l	a2,a4
	beq.s	SL_found
	cmp.l	a2,a5
	bne.s	SL_bcl_next
	exg.l	a4,a5	; a4=a2, a5 autre secteur
SL_found
	jsr	(a0)	; Appeler la routine de comparaison

SL_bcl_next	lea	SIZEOF_LINEDEF(a3),a3
	dbra	d3,SL_bcl
	movem.l	(sp)+,d3-d6/a3-a5
	rts

; -------------	Routines de comparaison

	; Plafond le plus haut
	
CompareHC	move	SECTOR_CEILING1(a5),d6
	cmp	d6,d7
	bge.s	CompareHC_done
	move	d6,d7
CompareHC_done	rts

	; Plafond le plus bas
	
CompareLC	move	SECTOR_CEILING1(a5),d6
	cmp	d6,d7
	ble.s	CompareLC_done
	move	d6,d7
CompareLC_done	rts
	
	; Sol le plus haut

CompareHF	move	SECTOR_FLOOR1(a5),d6
	cmp	d6,d7
	bge.s	CompareHF_done
	move	d6,d7
CompareHF_done	rts

	; Sol le plus bas
	
CompareLF	move	SECTOR_FLOOR1(a5),d6
	cmp	d6,d7
	ble.s	CompareLF_done
	move	d6,d7
CompareLF_done	rts

	; Sol le plus haut apres le secteur courant

CompareNHF	move	SECTOR_FLOOR1(a5),d6
	cmp	d6,d7
	bgt.s	CompareNHF_done
	move	d6,d7
CompareNHF_done	rts

	; Lumire la plus leve

CompareHAL	move	SECTOR_BRIGHT(a5),d6
	cmp	d6,d7
	bge.s	CompareHAL_done
	move	d6,d7
CompareHAL_done	rts

	; Lumire la plus faible

CompareLAL	move	SECTOR_BRIGHT(a5),d6
	cmp	d6,d7
	ble.s	CompareLAL_done
	move	d6,d7
CompareLAL_done	rts

; -------------	Macros de calcul

SEARCH_LECM4	MACRO
	move.l	a0,-(sp)
	move.l	#CompareLC,a0
	move	#$7fff,d7
	bsr	SearchLimit
	subq	#4,d7	
	move.l	(sp)+,a0
	ENDM

SEARCH_LEC	MACRO
	move.l	a0,-(sp)
	move.l	#CompareLC,a0
	move	#$7fff,d7
	bsr	SearchLimit
	move.l	(sp)+,a0
	ENDM

SEARCH_HEF	MACRO
	move.l	a0,-(sp)
	move.l	#CompareHF,a0
	move	#$8000,d7
	bsr	SearchLimit
	move.l	(sp)+,a0
	ENDM

SEARCH_LEF	MACRO
	move.l	a0,-(sp)
	move.l	#CompareLF,a0
	move	#$7fff,d7
	bsr	SearchLimit
	move.l	(sp)+,a0
	ENDM

SEARCH_NHEF	MACRO
	move.l	a0,-(sp)
	move.l	#CompareNHF,a0
	move	#$8000,d7
	bsr	SearchLimit
	move.l	(sp)+,a0
	ENDM

SEARCH_HEC	MACRO
	move.l	a0,-(sp)
	move.l	#CompareHC,a0
	move	#$8000,d7
	bsr	SearchLimit
	move.l	(sp)+,a0
	ENDM

SEARCH_HIF	MACRO
	move.l	a0,-(sp)
	move.l	#CompareHF,a0
	move	SECTOR_FLOOR1(a2),d7
	bsr	SearchLimit
	move.l	(sp)+,a0
	ENDM	

SEARCH_HIC	MACRO
	move.l	a0,-(sp)
	move.l	#CompareHF,a0
	move	SECTOR_CEILING1(a2),d7
	bsr	SearchLimit
	move.l	(sp)+,a0
	ENDM	

SEARCH_LIF	MACRO
	move.l	a0,-(sp)
	move.l	#CompareLF,a0
	move	SECTOR_FLOOR1(a2),d7
	bsr	SearchLimit
	move.l	(sp)+,a0
	ENDM	

SEARCH_LIC	MACRO
	move.l	a0,-(sp)
	move.l	#CompareLC,a0
	move	SECTOR_CEILING1(a2),d7
	bsr	SearchLimit
	move.l	(sp)+,a0
	ENDM	

; -----------------------------
;	Calcul des limites et raz du mvt si dpassement
; -----------------------------
;	a3	Action
;	a2	Secteur adjacent

	TEXT
AI_CalculLimites
	; Chercher limite infrieure

	clr	d7
	move.b	ACT_LIMIT1(a3),d7
	jsr	([AI_TableLimites,d7.w*4])
	move	d7,SECTOR_LIMIT1(a2)
	move	d7,d6

	; Chercher limite suprieure

	clr	d7
	move.b	ACT_LIMIT2(a3),d7
	jsr	([AI_TableLimites,d7.w*4])
	move	d7,SECTOR_LIMIT2(a2)

	; Si le mouvement a atteint sa limite, alors pas de mouvement
	; d6 limit1, d7 limit2

	; si ceilup et plafond>limit2 alors stop

	cmp.b	#SCM_CEILUP,SECTOR_FCMOVE(a2)
	bne.s	AI_CL_NotCeilUp
	cmp	SECTOR_CEILING(a2),d7
	ble.s	AI_CL_NotCeilUp
	clr	SECTOR_FCMOVE(a2)
	rts
AI_CL_NotCeilUp
	
	; si ceildn et plafond<limit1 alors stop

	cmp.b	#SCM_CEILDN,SECTOR_FCMOVE(a2)
	bne.s	AI_CL_NotCeilDn
	cmp	SECTOR_CEILING(a2),d6
	bge.s	AI_CL_NotCeilDn
	clr	SECTOR_FCMOVE(a2)
	rts
AI_CL_NotCeilDn

	; si florup et sol>limit2 alors stop

	cmp.b	#SCM_FLOORUP,SECTOR_FCMOVE(a2)
	bne.s	AI_CL_NotFloorUp
	cmp	SECTOR_FLOOR(a2),d7
	ble.s	AI_CL_NotFloorUp
	clr	SECTOR_FCMOVE(a2)
	rts
AI_CL_NotFloorUp

	; si flordn et sol<limit1 alors stop
	
	cmp.b	#SCM_FLOORDN,SECTOR_FCMOVE(a2)
	bne.s	AI_CL_NotFloorDn
	cmp	SECTOR_FLOOR(a2),d6
	bge.s	AI_CL_NotFloorDn
	clr	SECTOR_FCMOVE(a2)
;	rts
AI_CL_NotFloorDn
	rts

; -------------	Routines de calcul de limite

AIL_F	move	SECTOR_FLOOR1(a2),d7
	rts

AIL_C	move	SECTOR_CEILING1(a2),d7
	rts

AIL_LIF	SEARCH_LIF
	rts

AIL_LIC	SEARCH_LIC
	rts

AIL_HIF	SEARCH_HIF
	rts

AIL_HIC	SEARCH_HIC
	rts

AIL_LEF	SEARCH_LEF
	rts

AIL_LEC	SEARCH_LEC
	rts

AIL_LECM4	SEARCH_LEC
	subq	#4,d7
	rts

AIL_HEF	SEARCH_HEF
	rts

AIL_HEC	SEARCH_HEC
	rts

AIL_HEFP8	SEARCH_HEF
	addq	#8,d7
	rts

AIL_NHEF	SEARCH_NHEF
	rts

AIL_LICM8	SEARCH_LIC
	subq	#8,d7
	rts	

AIL_FP8	move	SECTOR_FLOOR1(a2),d7
	addq	#8,d7
	rts

AIL_FP24	move	SECTOR_FLOOR1(a2),d7
	add	#24,d7
	rts

AIL_FP32	move	SECTOR_FLOOR1(a2),d7
	add	#32,d7
	rts

AIL_FP512	move	SECTOR_FLOOR1(a2),d7
	add	#512,d7
	rts

AIL_FPSLT	move	SECTOR_FLOOR1(a2),d7
	add	#16,d7
	rts
	
	DATA

AI_TableLimites	dc.l	AIL_F
	dc.l	AIL_C
	dc.l	AIL_LIF
	dc.l	AIL_LIC
	dc.l	AIL_HIF
	dc.l	AIL_HIC
	dc.l	AIL_LEF
	dc.l	AIL_LEC
	dc.l	AIL_LECM4
	dc.l	AIL_HEF
	dc.l	AIL_HEC
	dc.l	AIL_HEFP8
	dc.l	AIL_NHEF
	dc.l	AIL_LICM8
	dc.l	AIL_FP8
	dc.l	AIL_FP24
	dc.l	AIL_FP32
	dc.l	AIL_FP512
	dc.l	AIL_FPSLT

; -----------------------------
;	Portes manuelles
; -----------------------------

	TEXT
ActInitManualDoor	; Portes manuelles

	move	LINEDEF_LSIDE(a1),d0
	mulu	#SIZEOF_SIDEDEF,d0

	move	(SIDEDEF_SECTOR,[adr_sidedefs],d0.l),d0
	mulu	#SIZEOF_SECTOR,d0
	lea	([adr_sectors],d0.l),a2

	tst	SECTOR_FCMOVE(a2)
	beq.s	ActInitRemoteDoor
	rts

; -----------------------------
;	Mouvements de sol/plafond
; -----------------------------

ActInitRemoteDoor	; Portes distantes
ActInitMovingCeiling	; Plafond en mouvement
ActInitLift		; Ascenseur
ActInitFloor		; Sol
ActInitMovingFloor	; Sol en mouvement
ActInitCrushCeil	; Plafond qui crase 

	move	ACT_VITESSE(a3),SECTOR_FCSPEED(a2)

	move.l	game_timer,SECTOR_TIME(a2)

	clr	d7
	move.b	ACT_TYPE(a3),d7
	move	d7,SECTOR_FCTYPE(a2)

	clr	d7
	move.b	ACT_MVT(a3),d7
	move	d7,SECTOR_FCMOVE(a2)
	
	bsr	AI_CalculLimites
	rts

ActStopMovingFloor	; Arreter le sol en mouvement
ActStopCrushCeil	; Arreter plafond qui crase
	move	#SCM_NONE,SECTOR_FCMOVE(a2)
	move	#SCT_STOP,SECTOR_FCTYPE(a2)
	rts

; ------------------------------
;	Donut
; ------------------------------

ActInitDonut
	movem.l	d0-d1/a0-a3,-(sp)

	move.l	game_timer,SECTOR_TIME(a2)
	move	ACT_VITESSE(a3),SECTOR_FCSPEED(a2)
	clr	d7
	move.b	ACT_MVT(a3),d7
	move	d7,SECTOR_FCMOVE(a2)
	clr	d7
	move.b	ACT_TYPE(a3),d7
	move	d7,SECTOR_FCTYPE(a2)

	SEARCH_LIF
	move	d7,SECTOR_LIMIT1(a2)
	move	SECTOR_FLOOR1(a2),SECTOR_LIMIT2(a2)

	; Maintenant chercher le beignet

	move.l	adr_linedefs,a3
	move.l	num_linedefs,d3
	subq	#1,d3
Donut2_bcl
	btst	#TWO_SIDED,LINEDEF_ATTRIB+1(a3)
	beq	Donut2_bcl_next
	move.l	adr_sectors,a5
	
	move	LINEDEF_RSIDE(a3),d4
	mulu	#SIZEOF_SIDEDEF,d4
	move	(SIDEDEF_SECTOR,[adr_sidedefs],d4.l),d4
	mulu	#SIZEOF_SECTOR,d4
	lea	(a5,d4.l),a4

	move	LINEDEF_LSIDE(a3),d5
	mulu	#SIZEOF_SIDEDEF,d5
	move	(SIDEDEF_SECTOR,[adr_sidedefs],d5.l),d5
	mulu	#SIZEOF_SECTOR,d5
	lea	(a5,d5.l),a5

	cmp.l	a2,a4
	beq.s	Donut2_found
	cmp.l	a2,a5
	bne	Donut2_bcl_next
	exg.l	a4,a5	; a4=a2, a5 autre secteur
Donut2_found
	; a5 Secteur externe au pilier

	move.l	a5,a1
	
	; Trouver secteur externe a a5
	; Qui ne soit pas le pilier

	move.l	adr_linedefs,a0
	move.l	num_linedefs,d0
	subq	#1,d0
Donut3_bcl
	btst	#TWO_SIDED,LINEDEF_ATTRIB+1(a0)
	beq.s	Donut3_bcl_next
	move.l	adr_sectors,a5
	
	move	LINEDEF_RSIDE(a0),d4
	mulu	#SIZEOF_SIDEDEF,d4
	move	(SIDEDEF_SECTOR,[adr_sidedefs],d4.l),d4
	mulu	#SIZEOF_SECTOR,d4
	lea	(a5,d4.l),a4

	move	LINEDEF_LSIDE(a0),d5
	mulu	#SIZEOF_SIDEDEF,d5
	move	(SIDEDEF_SECTOR,[adr_sidedefs],d5.l),d5
	mulu	#SIZEOF_SECTOR,d5
	lea	(a5,d5.l),a5

	cmp.l	a1,a4
	beq.s	Donut3_found
	cmp.l	a1,a5
	bne.s	Donut3_bcl_next
	exg.l	a4,a5	; a4=a1, a5 autre secteur
Donut3_found
	cmp.l	a2,a5	; Si c'est le central on passe
	beq.s	Donut3_bcl_next

	; a2=secteur central
	; a1=secteur donut
	; a5=secteur externe

	move	SECTOR_FLOOR1(a5),SECTOR_LIMIT1(a2)
	
	; Le donut monte
	
	move	#SCM_FLOORUP,SECTOR_FCMOVE(a1)
	move	#SPD_SLOW,SECTOR_FCSPEED(a1)
	move	#SCT_FLOOR,SECTOR_FCTYPE(a1)
	move.l	game_timer,SECTOR_TIME(a1)
	move	SECTOR_FLOOR1(a1),SECTOR_LIMIT1(a1)
	move	SECTOR_FLOOR1(a5),SECTOR_LIMIT2(a1)

	bra.s	Donut_bcl_next
Donut3_bcl_next
	lea	SIZEOF_LINEDEF(a0),a0
	dbra	d0,Donut3_bcl
	bra.s	Donut_bcl_next

Donut2_bcl_next	lea	SIZEOF_LINEDEF(a3),a3
	dbra	d3,Donut2_bcl

Donut_bcl_next
	movem.l	(sp)+,d0-d1/a0-a3
	rts

; -----------------------------
;	Escaliers
; -----------------------------
;	On prend le sector oppos au LINEDEF cliqu
;	On le met en route
;	  On met en route tous les secteurs qui sont en commun avec celui la

ActInitStairs
	move.l	a2,StairA2Orig
	move.l	a3,StairA3Orig

	move	SECTOR_FLOOR1(a2),d6
	move	d6,d5

	moveq	#8,d7
	cmp	#SPD_TURBO,ACT_VITESSE(a3)
	bne.s	SI_NoTurbo
	moveq	#16,d7
SI_NoTurbo

	; Dmarrer escalier avec premier secteur
SI_new_sector
	move.l	StairA3Orig,a3

	move.l	game_timer,SECTOR_TIME(a2)
	move	ACT_VITESSE(a3),SECTOR_FCSPEED(a2)
	clr	d4
	move.b	ACT_MVT(a3),d4
	move	d4,SECTOR_FCMOVE(a2)
	clr	d4
	move.b	ACT_TYPE(a3),d4
	move	d4,SECTOR_FCTYPE(a2)

	move	d5,SECTOR_LIMIT1(a2)
	add	d7,d6
	move	d6,SECTOR_LIMIT2(a2)

	; Prendre les Linedefs 2-sided
	; si l'un deux a le cote droit sur le secteur actuel
	;   on active l'autre cote

	; Ensuite trouver dans ce secteur un 2sided avec cote droit
	; dans secteur courant

	move.l	adr_ssectors,a3
	move.l	num_ssectors,d3
	subq	#1,d3
SI_bcl2
	cmp.l	SSECTOR_SECTOR(a3),a2
	bne	SI_bcl2_next

	move	SSECTOR_NBSEG(a3),d4
	subq	#1,d4
	move	SSECTOR_STSEG(a3),d0
	mulu	#SIZEOF_SEG,d0
	lea	([adr_segs],d0.l),a4
SI_bcl3	
	tst	SEG_SIDE(a4)	; Si pas cote droit : pas bon
	bne.s	SI_bcl3_next

	move	SEG_LINEDEF(a4),d0
	mulu	#SIZEOF_LINEDEF,d0
	lea	([adr_linedefs],d0.l),a5
	btst	#TWO_SIDED,LINEDEF_ATTRIB+1(a5)
	beq.s	SI_bcl3_next	; Pas 2-sided : pas bon

;	move	LINEDEF_RSIDE(a5),d0
;	mulu	#SIZEOF_SIDEDEF,d0
;	move	(SIDEDEF_SECTOR,[adr_sidedefs],d0.l),d0
;	mulu	#SIZEOF_SECTOR,d0
;	lea	([adr_sectors],d0.l),a6
;	cmp.l	a2,a6	; Si a droite pas secteur de depart : suivant
;	bne.s	SI_bcl3_next

	move	LINEDEF_LSIDE(a5),d0
	mulu	#SIZEOF_SIDEDEF,d0
	move	(SIDEDEF_SECTOR,[adr_sidedefs],d0.l),d0
	mulu	#SIZEOF_SECTOR,d0
	lea	([adr_sectors],d0.l),a5

	; Si la texture du sol est differente on arrete

	move.l	SECTOR_FNAME(a2),d0
	cmp.l	SECTOR_FNAME(a5),d0
	bne.s	SI_bcl3_next

	; Si ce secteur subit deja l'effet on arrete

	cmp	#SCM_FLOORUP,SECTOR_FCMOVE(a5)
	beq.s	SI_bcl3_next
	
	move.l	a5,a2
	bra	SI_new_sector

SI_bcl3_next	lea	SIZEOF_SEG(a4),a4
	dbra	d4,SI_bcl3

SI_bcl2_next	lea	SIZEOF_SSECTOR(a3),a3
	dbra	d3,SI_bcl2

SI_bcl_next
	move.l	StairA2Orig,a2
	move.l	StairA3Orig,a3
	rts

	BSS
StairA2Orig	ds.l	1
StairA3Orig	ds.l	1

; -----------------------------
;	Fin du niveau
; -----------------------------

	TEXT
ActInitExit
	move.l	#BoucleInterScreen,BouclePrincipale
	move.l	#ControleInterScreen,ControleVbl
	move	#2,InterSemaphore

	cmp	#2,game_type
	bne.s	.NotDoom2

	clr	d0
	move.b	game_level+3,d0
	sub.b	#"0",d0
	mulu	#10,d0
	clr	d1
	move.b	game_level+4,d1
	sub.b	#"0",d1
	add	d1,d0	; d0 Numro du niveau

	addq	#1,d0
	
	clr.l	d1
	move	d0,d1
	divu	#10,d1
	add.b	#"0",d1
	move.b	d1,game_level+3
	swap	d1
	add.b	#"0",d1
	move.b	d1,game_level+4

	rts
.NotDoom2
	add.b	#1,game_level+3
	rts

; -----------------------------
;	Tlportation
; -----------------------------

ActInitTeleport
	tst	LinedefActSide	; Si pas cote droit
	bne.s	STL_stop

	move	LINEDEF_TAG(a1),d1
	move.l	adr_sectors,a2
	move.l	num_sectors,d2
	subq	#1,d2
STL_bcl1
	cmp	SECTOR_TRIGGER(a2),d1
	beq.s	STL_bcl_stop
	lea	SIZEOF_SECTOR(a2),a2
	dbra	d2,STL_bcl1
	rts
STL_bcl_stop
	; Chercher le THING d'atterrissage dans le SECTOR (type 14)
	; a2 SECTOR d'atterrissage

	move.l	adr_ssectors,a3
	move.l	num_ssectors,d2
	subq	#1,d2
STL_bcl2
	cmp.l	SSECTOR_SECTOR(a3),a2
	bne.s	STL_bcl2_next
	move.l	SSECTOR_SPRITES(a3),a4	; Chercher THING type 14
STL_bcl2_search
	cmp.l	#0,a4
	beq.s	STL_bcl2_next
	move.l	OBJET_THING(a4),a5
	cmp	#14,THING_TYPE(a5)
	beq.s	STL_land_found
	move.l	OBJET_NEXT(a4),a4
	bra.s	STL_bcl2_search
STL_bcl2_next
	lea	SIZEOF_SSECTOR(a3),a3
	dbra	d2,STL_bcl2
STL_stop
	rts

STL_land_found
	move	OBJET_X(a4),OBJET_X1(a0)
	move	OBJET_Y(a4),OBJET_Y1(a0)
	move	SECTOR_FLOOR(a2),OBJET_Z1(a0)
	move	OBJET_A(a4),d1
	and	#-4,d1
	move	d1,OBJET_A1(a0)
	rts

; -----------------------------
;	Lumire
; -----------------------------

	DATA
AI_LightTable
	dc.l	AIL_Light0
	dc.l	AIL_Light255
	dc.l	AIL_LightLE
	dc.l	AIL_LightHE
	dc.l	AIL_LightBlink

	TEXT
ActInitLight	
	move	LINEDEF_LSIDE(a1),d0
	mulu	#SIZEOF_SIDEDEF,d0

	move	(SIDEDEF_SECTOR,[adr_sidedefs],d0.l),d0
	mulu	#SIZEOF_SECTOR,d0
	lea	([adr_sectors],d0.l),a2

	clr	d0
	move.b	ACT_LIMIT1(a3),d0
	jmp	([AI_LightTable,d0.w*4])	

AIL_Light0	clr	SECTOR_HILIGHT(a2)
	rts

AIL_Light255	move	#255,SECTOR_HILIGHT(a2)
	rts

AIL_LightLE	move.l	a0,-(sp)
	move.l	#CompareLAL,a0
	move	#255,d7
	bsr	SearchLimit
	move.l	(sp)+,a0
	move	d7,SECTOR_HILIGHT(a2)
	rts

AIL_LightHE	move.l	a0,-(sp)
	move.l	#CompareHAL,a0
	clr	d7
	bsr	SearchLimit
	move.l	(sp)+,a0
	move	d7,SECTOR_HILIGHT(a2)
	rts

AIL_LightBlink	move	#3,SECTOR_SPECIAL(a2)
	rts
