; -----------------------------
;	SECTORs en cours d'activit
; -----------------------------

	TEXT
ActivateSectors
	move.l	adr_sectors,a0
	move.l	num_sectors,d0
	subq	#1,d0
ActiSect_bcl

; -------------	Gestion de la lumiere

	move	SECTOR_HILIGHT(a0),d2
	move	SECTOR_SPECIAL(a0),d1
	beq	end_light_effect
	cmp	#1,d1
	beq.s	light_randomoff
	cmp	#2,d1
	beq.s	light_blinkondemisecond
	cmp	#3,d1
	beq.s	light_blinkononesecond
	cmp	#4,d1
	beq.s	light_blinkondemisecond
	cmp	#8,d1
	beq.s	light_oscillate
	cmp	#12,d1
	beq.s	light_blinkondemisecondsync
	cmp	#13,d1
	beq.s	light_blinkononesecondsync
	cmp	#17,d1
	beq.s	light_flickerrandom
	bra	end_light_effect

light_randomoff
light_flickerrandom
	move.l	game_timer,d1
	lsr	#3,d1
	ror	d1,d1
	btst	#0,d1
	beq.s	end_light_effect
	clr	d2
	move.b	SECTOR_LOWLIGHT(a0),d2
	bra.s	end_light_effect

light_blinkononesecond
light_blinkononesecondsync
	move.l	game_timer,d1
	and	#31,d1
	cmp	#31-8,d1
	bpl.s	end_light_effect
	clr	d2
	move.b	SECTOR_LOWLIGHT(a0),d2
	bra.s	end_light_effect

light_blinkondemisecond
light_blinkondemisecondsync
	move.l	game_timer,d1
	and	#15,d1
	cmp	#15-4,d1
	bpl.s	end_light_effect
	clr	d2
	move.b	SECTOR_LOWLIGHT(a0),d2
	bra.s	end_light_effect

light_oscillate
	move.l	game_timer,d1
	add.l	d1,d1
	add.l	d1,d1

	move	SECTOR_HILIGHT(a0),d4
	clr	d3
	move.b	SECTOR_LOWLIGHT(a0),d3
	sub	d3,d4
	bmi.s	end_light_effect
	move	d4,d2
	add	d4,d4	
	divu	d4,d1
	swap	d1
	
	cmp	d2,d1
	bpl.s	light_osc_down
light_osc_up	clr	d2
	move.b	SECTOR_LOWLIGHT(a0),d2
	add	d1,d2
	bra.s	end_light_effect
light_osc_down	sub	d2,d1
	move	SECTOR_HILIGHT(a0),d2
	sub	d1,d2

end_light_effect
	move	d2,SECTOR_BRIGHT(a0)

; -------------	Gestion des mouvements des sols/plafonds

ActiSect_moves
	move	SECTOR_FCMOVE(a0),d1	; Type de mouvement
	beq	ActiSect_bcl_next
	cmp	#SCM_PAUSE,d1
	beq	AS_Paused
	cmp	#SCM_CEILUP,d1
	beq	AS_CeilUp
	cmp	#SCM_FLOORUP,d1
	beq	AS_FloorUp
	cmp	#SCM_CEILDN,d1
	beq	AS_CeilDn
	cmp	#SCM_FLOORDN,d1
	beq	AS_FloorDn
	bra	ActiSect_bcl_next

; --- Mouvement en pause (porte ouverte ...)

AS_Paused
	move.l	game_timer,d2
	sub.l	SECTOR_TIME(a0),d2
	cmp	#4*GAME_TIMER_FREQ,d2	; >4secs	
	bmi	ActiSect_bcl_next
	move.l	game_timer,SECTOR_TIME(a0)

	move	SECTOR_FCTYPE(a0),d2
	cmp	#SCT_OPENCLOSE,d2
	beq.s	AS_PausedDoor
	cmp	#SCT_CLOSEOPEN,d2
	beq.s	AS_PausedDoor1
	cmp	#SCT_LIFT,d2
	beq.s	AS_PausedLift
	bra	ActiSect_bcl_next
	
AS_PausedDoor	move	#SCM_CEILDN,SECTOR_FCMOVE(a0)
	move	#SCT_STOP,SECTOR_FCTYPE(a0)
	bra	ActiSect_bcl_next

AS_PausedDoor1	move	#SCM_CEILUP,SECTOR_FCMOVE(a0)
	move	#SCT_STOP,SECTOR_FCTYPE(a0)
	bra	ActiSect_bcl_next

AS_PausedLift	move	#SCM_FLOORUP,SECTOR_FCMOVE(a0)
	move	#SCT_STOP,SECTOR_FCTYPE(a0)
	bra	ActiSect_bcl_next

; --- Plafond monte

AS_CeilUp
	move.l	game_timer,d1
	sub.l	SECTOR_TIME(a0),d1	; Temps coul depuis dernire fois
	mulu	SECTOR_FCSPEED(a0),d1	; * Vitesse (8:8)
	lsr.l	#8,d1
	add	SECTOR_LIMIT1(a0),d1	; + Depart

	move	SECTOR_LIMIT2(a0),d3
	cmp	d3,d1
	blt.s	ActiSect_CU_lim
	move	d3,d1
	move.l	game_timer,SECTOR_TIME(a0)

	move	SECTOR_FCTYPE(a0),d3
	
	moveq	#SCM_PAUSE,d2		; Si pas de va/vient : stop
	cmp	#SCT_OPENCLOSE,d3
	beq.s	ActiSect_CU_next
	cmp	#SCT_CLOSEOPEN,d3
	beq.s	ActiSect_CU_next

	moveq	#SCM_CEILDN,d2		; Plafond en mvt
	cmp	#SCT_CEILMV,d3
	beq.s	ActiSect_CU_next

	moveq	#SCM_NONE,d2
ActiSect_CU_next
	move	d2,SECTOR_FCMOVE(a0)
ActiSect_CU_lim
	move	d1,SECTOR_CEILING(a0)
	bra	ActiSect_bcl_next

; --- Sol monte

AS_FloorUp
	move.l	game_timer,d1
	sub.l	SECTOR_TIME(a0),d1	; Temps coul depuis dernire fois
	mulu	SECTOR_FCSPEED(a0),d1
	lsr.l	#8,d1		; * Vitesse (8:8)
	add	SECTOR_LIMIT1(a0),d1	; + Depart

	move	SECTOR_LIMIT2(a0),d3
	cmp	d3,d1		; Sol<Limite:stop
	blt.s	ActiSect_FU_lim
	move	d3,d1
	move.l	game_timer,SECTOR_TIME(a0)

	move	SECTOR_FCTYPE(a0),d3
	moveq	#SCM_PAUSE,d2		; Si pas de va/vient : stop
	cmp	#SCT_LIFT,d3
	beq.s	ActiSect_FU_next

	moveq	#SCM_FLOORDN,d2		; Sol qui bouge
	cmp	#SCT_FLOORMV,d3
	beq.s	ActiSect_FU_next

	moveq	#SCM_NONE,d2
ActiSect_FU_next
	move	d2,SECTOR_FCMOVE(a0)
ActiSect_FU_lim
	move	d1,SECTOR_FLOOR(a0)
	bra	ActiSect_bcl_next

; --- Plafond descend

AS_CeilDn
	move	SECTOR_LIMIT2(a0),d1
	move.l	game_timer,d2
	sub.l	SECTOR_TIME(a0),d2	; Temps coul depuis dernire fois
	mulu	SECTOR_FCSPEED(a0),d2	; * Vitesse (8:8)
	lsr.l	#8,d2
	sub	d2,d1

	move	SECTOR_LIMIT1(a0),d3
	cmp	d3,d1		; Plafond<Limite:stop
	bgt.s	ActiSect_CD_lim
	move	d3,d1
	move.l	game_timer,SECTOR_TIME(a0)
	
	move	SECTOR_FCTYPE(a0),d3
	moveq	#SCM_PAUSE,d2		; Si pas de va/vient : stop
	cmp	#SCT_OPENCLOSE,d3
	beq.s	ActiSect_CD_next
	cmp	#SCT_CLOSEOPEN,d3
	beq.s	ActiSect_CD_next

	moveq	#SCM_CEILUP,d2		; Plafond qui crase
	cmp	#SCT_CEILMV,d3
	beq.s	ActiSect_CD_next

	moveq	#SCM_NONE,d2
ActiSect_CD_next
	move	d2,SECTOR_FCMOVE(a0)
ActiSect_CD_lim
	move	d1,SECTOR_CEILING(a0)
	bra	ActiSect_bcl_next

; --- Sol descend

AS_FloorDn
	move	SECTOR_LIMIT2(a0),d1
	move.l	game_timer,d2
	sub.l	SECTOR_TIME(a0),d2	; Temps coul depuis dernire fois
	mulu	SECTOR_FCSPEED(a0),d2	; * Vitesse (8:8)
	lsr.l	#8,d2
	sub	d2,d1

	move	SECTOR_LIMIT1(a0),d3
	cmp	d3,d1		; Sol>Limite:stop
	bgt.s	ActiSect_FD_lim
	move	d3,d1
	move.l	game_timer,SECTOR_TIME(a0)

	move	SECTOR_FCTYPE(a0),d3
	moveq	#SCM_PAUSE,d2		; Si pas de va/vient : stop
	cmp	#SCT_LIFT,d3
	beq.s	ActiSect_FD_next

	moveq	#SCM_FLOORUP,d2		; Sol qui bouge
	cmp	#SCT_FLOORMV,d3
	beq.s	ActiSect_FD_next

	moveq	#SCM_NONE,d2
ActiSect_FD_next
	move	d2,SECTOR_FCMOVE(a0)
ActiSect_FD_lim
	move	d1,SECTOR_FLOOR(a0)
	bra	ActiSect_bcl_next

; -------------	SECTOR suivant

	nop
ActiSect_bcl_next
	lea	SIZEOF_SECTOR(a0),a0
	dbra	d0,ActiSect_bcl
	rts