; -------------------------------------------------------------
;	Test de collision avec les murs
; -------------------------------------------------------------
;	OBJET_[XY]1	nouvelles coordonnes
;	OBJET_[XY]	anciennes coordonnes

	TEXT

CALCUL_BLOC1	MACRO	pos_joueur,bloc_origine,bloc_start,bloc_end

	move	\1,d7
	sub	\2,d7
	move	d7,d6
	asr	#7,d7
	and	#127,d6
	move	d7,\3
	move	d7,\4

	cmp	d2,d6
	bpl.s	bx_start\@
	subq	#1,d7
	move	d7,\3
	bra.s	bx_end\@
bx_start\@	cmp	d3,d6
	bmi.s	bx_end\@
	addq	#1,d7
	move	d7,\4
bx_end\@
	ENDM

CALCUL_BLOC2	MACRO	pos_joueur,bloc_origine,bloc_start,bloc_end

	move	\1,d7
	sub	\2,d7
	move	d7,d6
	asr	#7,d7
	and	#127,d6

	cmp	d2,d6
	bpl.s	bx_start1\@
	subq	#1,d7
bx_start1\@	cmp	d3,d6
	bmi.s	bx_end1\@
	addq	#1,d7
bx_end1\@
	cmp	\3,d7
	bpl.s	bx_comp1\@
	move	d7,\3
bx_comp1\@
	cmp	\4,d7
	bmi.s	bx_comp2\@
	move	d7,\4
bx_comp2\@
	ENDM

CLIP_BLOC	MACRO	limite,registre

	move	\1,d4
	bpl.s	testcol_clip1\@
	moveq	#0,d4
testcol_clip1\@	cmp	\2,d4
	bmi.s	testcol_clip2\@
	move	\2,d4
	subq	#1,d4
testcol_clip2\@	move	d4,\1

	ENDM

; ------------------------------
;	Savoir quels sont les blocs concerns
; ------------------------------
;	a0 Objet concern

TestCollision
	move.l	adr_blockmap,a1
	move.l	a1,a2
	movem	(a1)+,d0-d1	; blockmap origine x,y
	
	; Calculer les blocs de depart/arrive

	move	OBJET_RAYON(a0),d2
	move	#128,d3
	sub	d2,d3
	
	CALCUL_BLOC1	OBJET_X(a0),d0,bxdebut,bxfin
	CALCUL_BLOC1	OBJET_Y(a0),d1,bydebut,byfin

	CALCUL_BLOC2	OBJET_X1(a0),d0,bxdebut,bxfin
	CALCUL_BLOC2	OBJET_Y1(a0),d1,bydebut,byfin

	; Clipping des blocs de depart/arrivee

	movem	(a1)+,d2-d3	; blockmap colonnes,lignes
	CLIP_BLOC	bxdebut,d2
	CLIP_BLOC	bxfin,d2
	CLIP_BLOC	bydebut,d3
	CLIP_BLOC	byfin,d3

	; Permuter si le bloc de fin < bloc debut

	move	bxdebut,d0
	move	bxfin,d1
	cmp	d0,d1
	bpl.s	bxdebutinffin
	move	d1,bxdebut
	move	d0,bxfin
bxdebutinffin
	move	bydebut,d0
	move	byfin,d1
	cmp	d0,d1
	bpl.s	bydebutinffin
	move	d1,bydebut
	move	d0,byfin
bydebutinffin

	; Et on fait la double boucle
	; a2 Adresse de la blockmap
	; d2 Nombre de colonnes
	; d3 Nombre de lignes

	move	#-1,LinedefActivate
	move	OBJET_X1(a0),SlideX
	move	OBJET_Y1(a0),SlideY
	
	move	bydebut,d0
	move	d0,d3
	mulu	d2,d3
	lea	(a1,d3.l*2),a1	; Adresse de la ligne de blocs
bloc_boucley
	move	bxdebut,d1
	lea	(a1,d1.w*2),a4	; a4 Bloc dans la ligne
bloc_bouclex
	move	(a4)+,d3	; colonne suivante
	lea	2(a2,d3.w*2),a3	; Adresse de la liste de LINEDEFS (on passe le zero)
bloc_bclldf_nxt
	move	(a3)+,d3	; Au moins un LINEDEF
	bmi.s	bloc_bclldf_fin
	bsr	TestCollisionLinedef
	bra.s	bloc_bclldf_nxt
bloc_bclldf_fin
	addq	#1,d1
	cmp	bxfin,d1
	ble.s	bloc_bouclex

	lea	(a1,d2.w*2),a1	; ligne suivante
	addq	#1,d0
	cmp	byfin,d0
	ble.s	bloc_boucley

	move	LinedefActivate,d0
	ble.s	TCL_NoActLine

	move	#COND_W,ActivateType

	mulu	#SIZEOF_LINEDEF,d0
	lea	([adr_linedefs],d0.l),a1
;	bset	#WALL_COLLISION-8,LINEDEF_ATTRIB(a1)

	bsr	ActivateLinedef
TCL_NoActLine
	rts

	BSS

bxdebut	ds.w	1	; Bloc pour player_?
bydebut	ds.w	1
bxfin	ds.w	1	; Bloc pour player_?1
byfin	ds.w	1

SlideX	ds.w	1	; Coord de glissement sur mur
SlideY	ds.w	1

; -------------	Tester la collision entre un LINEDEF et l'objet
;	a0	Objet
;	d3	Numro du LINEDEF

;	Objet va de ox,oy a ox1,oy1 (ox2,oy2 si glissement sur mur)
;	O0 : carr de cote 2*r centr sur ox,oy
;	O1 : carr de cote 2*r centr sur ox1,oy1
;	R : rectangle qui est le mur x1,y1;x2,y2
;	Si O1 n'intersecte pas R alors pas de collision
;	Tester si un des 4 coins de O1 traverse le mur  (<>centre O1)
;	Si aucun ne traverse le mur alors pas de collision
;	Si le mur est 2-sided , tester avec les hauteurs
;	  Si c'est passable, le mur peut etre activ : cote droit ?
;	Recalculer ox1,oy1 pour que le carr ne traverse pas le mur
;	Ainsi que ox2,oy2 pour la glissade

;	Calculer le cote actuel
;	Pour chacun des 4 coins:
;	. Si il change de cote
;	. . Recalculer point intersection
;	. . Si pi pas dans segment mur
;	. . . ne pas le prendre en compte

;	Point d'intersection de deux segments :
;	Segment 1 : (mx1,my1)-(mx2,my2)
;	Segment 2 : (ox1,oy1)-(ox2,oy2)
;	c1=(mx2-mx1)	d1=(my2-my1)	g=mx2*my1-my2*mx1
;	c2=(ox2-ox1)	d2=(oy2-oy1)	h=ox2*oy1-oy2*ox1
;	i=c1*d2+d1*c2
;		x=(c2*g+c1*h)/i		y=(d2*g+d1*h)/i



	TEXT
TestCollisionLinedef
	movem.l	d0-d7/a0-a6,-(sp)

	; Mise en place du rectangle du LINEDEF

	move	d3,LinedefNumber
	mulu	#SIZEOF_LINEDEF,d3
	lea	([adr_linedefs],d3.l),a1
	move	LINEDEF_VERTEX1(a1),d0
	movem	(VERTEX_X,[adr_vertexes],d0.w*SIZEOF_VERTEX),d0-d1
	move	LINEDEF_VERTEX2(a1),d2
	movem	(VERTEX_X,[adr_vertexes],d2.w*SIZEOF_VERTEX),d2-d3

	move	d0,LinedefRx1
	move	d1,LinedefRy1
	move	d2,LinedefRx2
	move	d3,LinedefRy2

	move	d2,d6
	sub	d0,d6
	move	d6,LinedefRdx
	move	d3,d7
	sub	d1,d7
	move	d7,LinedefRdy
	
	; Tester si objet entre dans rectangle du LINEDEF
	; x1-R<=Ox1<=x2+R et y1-R<=Oy1<=y2+R

	cmp	d0,d2
	bgt.s	TestCollLinedef_Xmin
	exg	d0,d2
TestCollLinedef_Xmin
	cmp	d1,d3
	bgt.s	TestCollLinedef_Ymin
	exg	d1,d3
TestCollLinedef_Ymin

	sub	OBJET_RAYON(a0),d0	; x1-R
	add	OBJET_RAYON(a0),d2	; x2+R
	sub	OBJET_RAYON(a0),d1	; y1-R
	add	OBJET_RAYON(a0),d3	; y2+R

	cmp	OBJET_X1(a0),d0
	bgt	TestCollLinedef_fin
	cmp	OBJET_X1(a0),d2
	blt	TestCollLinedef_fin	
	cmp	OBJET_Y1(a0),d1
	bgt	TestCollLinedef_fin
	cmp	OBJET_Y1(a0),d3
	blt	TestCollLinedef_fin	

	; Calculer de quel cote se trouve l'objet OX,OY

	move	OBJET_X(a0),d0
	move	OBJET_Y(a0),d1
	bsr	TCL_CalcSide
	move	d7,LinedefSide

	; Calculer si un des quatres coins de OX1,OY1 traverse le LINEDEF

	move	OBJET_X1(a0),d0
	sub	OBJET_RAYON(a0),d0
	move	d0,LinedefOx1

	move	OBJET_Y1(a0),d0
	sub	OBJET_RAYON(a0),d0
	move	d0,LinedefOy1

	move	OBJET_X1(a0),d0
	add	OBJET_RAYON(a0),d0
	move	d0,LinedefOx2

	move	OBJET_Y1(a0),d0
	add	OBJET_RAYON(a0),d0
	move	d0,LinedefOy2

	; -> Cote different de l'objet

	move	LinedefSide,d6

	move	LinedefOx1,d0		; Cote haut-gauche
	move	LinedefOy1,d1
	bsr	TCL_CalcSide
	cmp	d6,d7
	bne.s	TestCollLinedef_cont
	; Recalculer Ox1Oy1 pour que ce point soit sur le mur

	move	LinedefOx2,d0		; Cote haut-droit
	move	LinedefOy1,d1
	bsr	TCL_CalcSide
	cmp	d6,d7
	bne.s	TestCollLinedef_cont
	; Recalculer Ox1Oy1 pour que ce point soit sur le mur

	move	LinedefOx2,d0		; Cote bas-droit
	move	LinedefOy2,d1
	bsr	TCL_CalcSide
	cmp	d6,d7
	bne.s	TestCollLinedef_cont
	; Recalculer Ox1Oy1 pour que ce point soit sur le mur

	move	LinedefOx1,d0		; Cote bas-gauche
	move	LinedefOy2,d1
	bsr	TCL_CalcSide
	cmp	d6,d7
	bne.s	TestCollLinedef_cont
	; Recalculer Ox1Oy1 pour que ce point soit sur le mur

	bra	TestCollLinedef_fin

	; Un des 4 coins a chang de cot
	; Tester si on peut traverser

TestCollLinedef_cont
	move	LINEDEF_ATTRIB(a1),d0
	and	#255,d0
	beq	TestCollLinedef_newpos
	btst	#TWO_SIDED,d0
	beq	TestCollLinedef_newpos
	btst	#IMPASSABLE,d0
	bne	TestCollLinedef_newpos

	; Two-sided passable : tester suivant les hauteurs
	; a1 : adresse du LINEDEF

	move	LINEDEF_RSIDE(a1),d1
	move	LINEDEF_LSIDE(a1),d2
	tst	LinedefSide
	beq.s	TCL_Rside
	exg	d1,d2
TCL_Rside
	move.l	adr_sectors,a3
	move.l	adr_sidedefs,a4

	mulu	#SIZEOF_SIDEDEF,d1
	move	SIDEDEF_SECTOR(a4,d1.l),d1
	mulu	#SIZEOF_SECTOR,d1
	lea	(a3,d1.l),a2

	mulu	#SIZEOF_SIDEDEF,d2
	move	SIDEDEF_SECTOR(a4,d2.l),d2
	mulu	#SIZEOF_SECTOR,d2
	lea	(a3,d2.l),a3

	; a2 SECTOR objet
	; a3 SECTOR oppos

	; Prendre le plafond le + bas et le sol le + haut

	move	SECTOR_CEILING(a2),d1
	move	SECTOR_CEILING(a3),d2
	cmp	d2,d1
	ble.s	TCL_MinCeil
	move	d2,d1
TCL_MinCeil
	move	SECTOR_FLOOR(a2),d2
	move	SECTOR_FLOOR(a3),d3
	cmp	d3,d2
	bge.s	TCL_MaxFloor
	move	d3,d2
TCL_MaxFloor
	; Si diffrence entre les deux>hauteur alors ok
	
	sub	d2,d1
	cmp	#56,d1
	blt.s	TestCollLinedef_newpos

	; Si objet_z+objet_h-plafond_a3>16 ok
	
	move	SECTOR_CEILING(a3),d1
	add	OBJET_H(a0),d1
	sub	OBJET_Z(a0),d1
	cmp	#16,d1
	blt.s	TestCollLinedef_newpos

	; Si objet_z-sol_a3>24 ok

	move	SECTOR_FLOOR(a3),d1
	sub	OBJET_Z(a0),d1
	cmp	#24,d1
	bgt.s	TestCollLinedef_newpos	

	; Traverse OK : activation LINEDEF

	move	LinedefSide,LinedefActSide
	move	LinedefNumber,LinedefActivate
	bra.s	TestCollLinedef_fin

	; On ne peut pas traverser : recalculer le point de destination

TestCollLinedef_newpos
	move	#-1,LinedefActivate
	move	OBJET_X(a0),OBJET_X1(a0)
	move	OBJET_Y(a0),OBJET_Y1(a0)
	
	; Fin du test de collision avec le LINEDEF

TestCollLinedef_fin
	movem.l	(sp)+,d0-d7/a0-a6
	rts

	BSS
LinedefRx1	ds.w	1	; Coordonnes du LINEDEF
LinedefRy1	ds.w	1
LinedefRx2	ds.w	1
LinedefRy2	ds.w	1
LinedefRdx	ds.w	1	; x2-x1
LinedefRdy	ds.w	1	; y2-y1

LinedefNumber	ds.w	1	; Numro du LINEDEF en cours
LinedefSide	ds.w	1	; De quel cote est il travers ?
			; 0 droit, -1 gauche

LinedefActivate	ds.w	1	; Linedef  activer si <>-1
LinedefActSide	ds.w	1	; Cote duquel on est parti
			; Teleport : actif si cote droit
			; Tous les autres : n'importe quel cote

LinedefOx1	ds.w	1	; Carr de l'objet
LinedefOy1	ds.w	1
LinedefOx2	ds.w	1
LinedefOy2	ds.w	1

; -------------	Calculer de quel cote du LINEDEF se trouve un point
;	d0,d1 Point
;	d7 -> 0 cote droit, -1 cote gauche

	TEXT
TCL_CalcSide
	movem.l	d0-d1,-(sp)
	sub	LinedefRx1,d0	; d0=X-x1
	sub	LinedefRy1,d1	; d1=Y-y1
	muls	LinedefRdy,d0	; d0=(X-x1)*dy
	muls	LinedefRdx,d1	; d1=(Y-y1)*dx
	sub.l	d0,d1
	spl	d7
	ext.w	d7
	movem.l	(sp)+,d0-d1
	rts
