; ------------------------------
;	Charge le niveau
;	ExMy ou MAPxy
; ------------------------------

; -------------	Une 'tite macro

INIT_LEVEL	MACRO	nom,adresse,taille
	move.l	\1,a1
	movem.l	(a1),d0-d1
	cmp.l	8(a0),d0
	bne.s	fin_init_level\@
	cmp.l	12(a0),d1
	bne.s	fin_init_level\@
	
	move.l	(a0),\2
	move.l	4(a0),d0
	move.l	d0,\3
	add.l	d0,level_length
	lea	16(a0),a0
	bra	init_niveau
fin_init_level\@
	ENDM

; -------------	Init nom de la bordure

	TEXT
charger_niveau
	lea	fond_doom,a0
	cmp	#3,game_type
	bne.s	no_heretic_game
	lea	fond_heretic,a0
no_heretic_game
	move.l	fnames_start,a1
	move.l	fnames_end,a2
	bsr	cherche_adresse
	clr.l	fond_adresse
	cmp.l	#0,a0
	beq.s	fond_pastrouve
	move.l	(a0),fond_adresse
fond_pastrouve
	
	DATA

fond_doom	dc.b	"FLOOR7_2"
fond_heretic	dc.b	"FLOOR00",0

	BSS
	
fond_adresse	ds.l	1

; -------------	Init nom du ciel

	TEXT
	
	move.b	game_level+1,nom_ciel+3

	; Heretic E4M1 ?
	
	cmp	#3,game_type
	bne.s	level_not_heretic

	cmp.b	#"4",game_level+1
	bne.s	level_not_heretic
	move.b	#"1",nom_ciel+3
level_not_heretic

	; DOOM 2 ?
	
	cmp	#2,game_type
	bne.s	level_not_doom2

	moveq	#0,d2
	move.b	game_level+3,d2
	sub.b	#"0",d2
	mulu	#10,d2
	moveq	#0,d3
	move.b	game_level+4,d3
	sub.b	#"0",d3
	add	d3,d2

	move.b	#"1",d3
	cmp.b	#12,d2
	bmi.s	level_skynb
	move.b	#"2",d3
	cmp.b	#20,d2
	bmi.s	level_skynb
	move.b	#"3",d3
level_skynb
	move.b	d3,nom_ciel+3
level_not_doom2

	; Malloc pour le ciel

	SupXazMxalloc	#256*256,#XAZ_PREFTTRAM
	move.l	d0,ciel_texture
	cmp.l	#XAZ_ERR_MAX,d0
	bhs	erreur_charger_niveau

;	move.l	d0,a0
;	move	#256-1,d0
;bcl_clrsky_y	move	#256/8-1,d1
;bcl_clrsky_x	clr.l	(a0)+
;	clr.l	(a0)+
;	clr.l	(a0)+
;	clr.l	(a0)+
;	dbra	d1,bcl_clrsky_x
;	dbra	d0,bcl_clrsky_y
	
	DATA
	
nom_ciel	dc.b	"SKY",0,0,0,0,0

	BSS
ciel_offset	ds.w	1
ciel_texture	ds.l	1

; -------------	Charge le niveau

	TEXT
	
;	lea	loading_level,a0
;	bsr	AjoutMessage
	
	clr.l	level_length
	
	lea	game_level,a0
	move.l	dir_start,a1
	move.l	dir_end,a2
	bsr	cherche_adresse
	cmp.l	#0,a0
	beq	erreur_charger_niveau
	lea	16(a0),a0
init_niveau
	INIT_LEVEL	#things,adr_things,siz_things
	INIT_LEVEL	#linedefs,adr_linedefs,siz_linedefs
	INIT_LEVEL	#sidedefs,adr_sidedefs,siz_sidedefs
	INIT_LEVEL	#vertexes,adr_vertexes,siz_vertexes
	INIT_LEVEL	#segs,adr_segs,siz_segs
	INIT_LEVEL	#ssectors,adr_ssectors,siz_ssectors
	INIT_LEVEL	#nodes,adr_nodes,siz_nodes
	INIT_LEVEL	#sectors,adr_sectors,siz_sectors
	INIT_LEVEL	#reject,adr_reject,siz_reject
	INIT_LEVEL	#blockmap,adr_blockmap,siz_blockmap
stop_init_niveau

	move.l	siz_linedefs,d0	; pour les nouveaux champs
	sub.l	d0,level_length
	divu.l	#SIZEOF_LINEDEF1,d0
	mulu.l	#SIZEOF_LINEDEF,d0
	move.l	d0,siz_linedefs
	add.l	d0,level_length

	move.l	siz_ssectors,d0	; pour les nouveaux champs
	sub.l	d0,level_length
	divu.l	#SIZEOF_SSECTOR1,d0
	mulu.l	#SIZEOF_SSECTOR,d0
	move.l	d0,siz_ssectors
	add.l	d0,level_length

	move.l	siz_sectors,d0	; pour les nouveaux champs
	sub.l	d0,level_length
	divu.l	#SIZEOF_SECTOR1,d0
	mulu.l	#SIZEOF_SECTOR,d0
	move.l	d0,siz_sectors
	add.l	d0,level_length

	DATA

;loading_level	dc.b	"LOADING LEVEL "
;	even

things	dc.b	"THINGS",0,0
linedefs	dc.b	"LINEDEFS"
sidedefs	dc.b	"SIDEDEFS"
vertexes	dc.b	"VERTEXES"
segs	dc.b	"SEGS",0,0,0,0
ssectors	dc.b	"SSECTORS"
nodes	dc.b	"NODES",0,0,0
sectors	dc.b	"SECTORS",0
reject	dc.b	"REJECT",0,0
blockmap	dc.b	"BLOCKMAP"

	BSS

adr_things	ds.l	1	; adresses des composantes du niveau
adr_linedefs	ds.l	1
adr_sidedefs	ds.l	1
adr_vertexes	ds.l	1
adr_segs	ds.l	1
adr_ssectors	ds.l	1
adr_nodes	ds.l	1
adr_sectors	ds.l	1
adr_reject	ds.l	1
adr_blockmap	ds.l	1

siz_things	ds.l	1	; taille des composantes du niveau
siz_linedefs	ds.l	1
siz_sidedefs	ds.l	1
siz_vertexes	ds.l	1
siz_segs	ds.l	1
siz_ssectors	ds.l	1
siz_nodes	ds.l	1
siz_sectors	ds.l	1
siz_reject	ds.l	1
siz_blockmap	ds.l	1

num_things	ds.l	1	; Nombre de composantes
num_linedefs	ds.l	1
num_sidedefs	ds.l	1
num_vertexes	ds.l	1
num_segs	ds.l	1
num_ssectors	ds.l	1
num_nodes	ds.l	1
num_sectors	ds.l	1

; ------------------------------
;	Chargement du niveau au format motorola
; ------------------------------

	TEXT

	SupXazMxalloc	level_length,#XAZ_PREFTTRAM
	move.l	d0,level_malloc
	cmp.l	#XAZ_ERR_MAX,d0
	bhs	erreur_charger_niveau
	move.l	level_malloc,a1

	BSS
	
level_malloc	ds.l	1	; Adr relle
level_length	ds.l	1	; Taille du niveau
	
; -------------	Things

	TEXT
	
	move.l	adr_things,a0
	move.l	a1,adr_things
	move.l	siz_things,d0
	divu	#SIZEOF_THING,d0
	move.l	d0,num_things
	subq	#1,d0
level_things
	REPT	5
	INVERSE_MOT2	a0,d1
	move	d1,(a1)+
	ENDR
	dbra	d0,level_things
	
; -------------	Linedefs

	move.l	adr_linedefs,a0
	move.l	a1,adr_linedefs
	move.l	siz_linedefs,d0
	divu	#SIZEOF_LINEDEF,d0
	move.l	d0,num_linedefs
	subq	#1,d0
level_linedefs
	REPT	7
	INVERSE_MOT2	a0,d1
	move	d1,(a1)+
	ENDR
	clr.l	(a1)+
	dbra	d0,level_linedefs

; -------------	Sidedefs

	move.l	adr_sidedefs,a0
	move.l	a1,adr_sidedefs
	move.l	siz_sidedefs,d0
	divu	#SIZEOF_SIDEDEF,d0
	move.l	d0,num_sidedefs
	subq	#1,d0
level_sidedefs
	INVERSE_MOT2	a0,d1
	move	d1,(a1)+
	INVERSE_MOT2	a0,d1
	move	d1,(a1)+

	move.l	(a0)+,(a1)+
	move.l	(a0)+,(a1)+
	move.l	(a0)+,(a1)+
	move.l	(a0)+,(a1)+
	move.l	(a0)+,(a1)+
	move.l	(a0)+,(a1)+

	INVERSE_MOT2	a0,d1
	move	d1,(a1)+
	dbra	d0,level_sidedefs
	
; -------------	Vertexes

	move.l	adr_vertexes,a0
	move.l	a1,adr_vertexes
	move.l	siz_vertexes,d0
	divu	#SIZEOF_VERTEX,d0
	move.l	d0,num_vertexes
	subq	#1,d0
level_vertexes
	INVERSE_MOT2	a0,d1
	move	d1,(a1)+
	INVERSE_MOT2	a0,d1
	move	d1,(a1)+
	dbra	d0,level_vertexes
	
; -------------	Segs

	move.l	adr_segs,a0
	move.l	a1,adr_segs
	move.l	siz_segs,d0
	divu	#SIZEOF_SEG,d0
	move.l	d0,num_segs
	subq	#1,d0
level_segs
	REPT	6
	INVERSE_MOT2	a0,d1
	move	d1,(a1)+
	ENDR
	dbra	d0,level_segs
	
; -------------	Ssectors

	move.l	adr_ssectors,a0
	move.l	a1,adr_ssectors
	move.l	siz_ssectors,d0
	divu	#SIZEOF_SSECTOR,d0
	move.l	d0,num_ssectors
	subq	#1,d0
level_ssectors
	INVERSE_MOT2	a0,d1
	move	d1,(a1)+
	INVERSE_MOT2	a0,d1
	move	d1,(a1)+
	clr.l	(a1)+
	clr.l	(a1)+
	dbra	d0,level_ssectors

; -------------	Nodes

	move.l	adr_nodes,a0
	move.l	a1,adr_nodes
	move.l	siz_nodes,d0
	divu	#SIZEOF_NODE,d0
	move.l	d0,num_nodes
	subq	#1,d0
level_nodes
	REPT	14
	INVERSE_MOT2	a0,d1
	move	d1,(a1)+
	ENDR
	dbra	d0,level_nodes
	
; -------------	Sectors

	move.l	adr_sectors,a0
	move.l	a1,adr_sectors
	move.l	siz_sectors,d0
	divu	#SIZEOF_SECTOR,d0
	move.l	d0,num_sectors
	subq	#1,d0
level_sectors
	INVERSE_MOT2	a0,d1
	move	d1,(a1)+
	INVERSE_MOT2	a0,d1
	move	d1,(a1)+
	
	move.l	(a0)+,(a1)+
	move.l	(a0)+,(a1)+
	
	move.l	(a0)+,(a1)+
	move.l	(a0)+,(a1)+
	
	REPT	3
	INVERSE_MOT2	a0,d1
	move	d1,(a1)+
	ENDR
	
	move.l	#$ffff0000,(a1)+	; Lumiere

	clr.l	(a1)+
	clr.l	(a1)+
	clr.l	(a1)+
	clr.l	(a1)+
	clr	(a1)+
	dbra	d0,level_sectors
	
; -------------	Reject
	
; -------------	Blockmap

	move.l	adr_blockmap,a0
	move.l	a1,adr_blockmap
	move.l	siz_blockmap,d0
	lsr.l	#1,d0
level_blockmap
	INVERSE_MOT2	a0,d1
	move	d1,(a1)+
	dbra	d0,level_blockmap

; -------------	Calcul de la longueur des LINEDEFs
;	Mettre bit pour texture scrollante

	move.l	adr_linedefs,a0
	move.l	num_linedefs,d0
	subq	#1,d0

	move.l	adr_vertexes,a1
calc_linedef_bcl
	clr.b	LINEDEF_ATTRIB(a0) ;Met  zro bits 15-8
	cmp	#48,LINEDEF_TYPE(a0)
	bne.s	.NoType48
	or	#1<<TEXTLSCROLL,LINEDEF_ATTRIB(a0)
.NoType48
	cmp	#3,game_type
	bne.s	.NoHeretic
	cmp	#99,LINEDEF_TYPE(a0)
	bne.s	.NoType99
	or	#1<<TEXTRSCROLL,LINEDEF_ATTRIB(a0)
.NoType99
.NoHeretic

	; Calcule la longueur

	move	LINEDEF_VERTEX2(a0),d2
	movem	VERTEX_X(a1,d2.w*SIZEOF_VERTEX),d1-d2
	move	LINEDEF_VERTEX1(a0),d3
	movem	VERTEX_X(a1,d3.w*SIZEOF_VERTEX),d3-d4

	sub	d3,d1
	move	d1,d6
	sub	d4,d2
	move	d2,d7
	
	muls	d1,d1
	muls	d2,d2
	add.l	d2,d1	; d1=x^2+y^2

	move.l	d1,d2	; d1 = a , x = d2
calc_racine1	move.l	d2,d4
	move.l	d1,d3
	divu.l	d2,d3	; d3 = a / x
	add.l	d2,d3	; d3 = x + a / x
	lsr.l	#1,d3	; d3 = ( x + a/x ) / 2
	move.l	d3,d2
	sub.l	d2,d4	; arrete si |ancien-nouveau|<2
	cmp.l	#2,d4
	bpl.s	calc_racine1
	move	d2,LINEDEF_LENGTH(a0)

	lea	SIZEOF_LINEDEF(a0),a0
	dbra	d0,calc_linedef_bcl

; -------------	Rechercher l'angle des LINEDEFs

	move.l	adr_segs,a0
	move.l	num_segs,d0
	subq	#1,d0

	move.l	adr_linedefs,a1
calc_seg_bcl
	move	SEG_ANGLE(a0),d1
	and	#-4,d1
	tst	SEG_SIDE(a0)
	beq.s	calc_seg_bcl_neg
	add	#$8000,d1
calc_seg_bcl_neg
	move	SEG_LINEDEF(a0),d2
	mulu	#SIZEOF_LINEDEF,d2
	move	d1,LINEDEF_ANGLE(a1,d2.l)

	lea	SIZEOF_SEG(a0),a0
	dbra	d0,calc_seg_bcl

; -------------	On annule les textures haut/bas entre 2 ciels

	move.l	adr_linedefs,a0
	move.l	num_linedefs,d0
	subq	#1,d0
cancel_linedef_bcl
	move	LINEDEF_LSIDE(a0),d1
	bmi	cancel_linedef_cont

	mulu	#SIZEOF_SIDEDEF,d1
	lea	([adr_sidedefs],d1.l),a1
	move	SIDEDEF_SECTOR(a1),d1
	mulu	#SIZEOF_SECTOR,d1
	lea	([adr_sectors],d1.l),a2

	move	LINEDEF_RSIDE(a0),d1
	bmi	cancel_linedef_cont
	mulu	#SIZEOF_SIDEDEF,d1
	lea	([adr_sidedefs],d1.l),a3
	move	SIDEDEF_SECTOR(a3),d1
	mulu	#SIZEOF_SECTOR,d1
	lea	([adr_sectors],d1.l),a4

	and	#$ffff-1<<BETWEEN_UPSKY-1<<BETWEEN_DNSKY,LINEDEF_ATTRIB(a0)
	
	; En haut
	
	cmp.l	#"F_SK",SECTOR_CNAME(a2)
	bne.s	cancel_linedef_up
	cmp	#"Y1",SECTOR_CNAME+4(a2)
	bne.s	cancel_linedef_up
	cmp.l	#"F_SK",SECTOR_CNAME(a4)
	bne.s	cancel_linedef_up
	cmp	#"Y1",SECTOR_CNAME+4(a4)
	
	move	#-1,SIDEDEF_UPNAME(a1)
	clr	SIDEDEF_UPNAME+2(a1)
	clr.l	SIDEDEF_UPNAME+4(a1)
	move	#-1,SIDEDEF_UPNAME(a3)
	clr	SIDEDEF_UPNAME+2(a3)
	clr.l	SIDEDEF_UPNAME+4(a3)

	or	#1<<BETWEEN_UPSKY,LINEDEF_ATTRIB(a0)
cancel_linedef_up
	
	; En bas

	cmp.l	#"F_SK",SECTOR_FNAME(a2)
	bne.s	cancel_linedef_down
	cmp	#"Y1",SECTOR_FNAME+4(a2)
	bne.s	cancel_linedef_down
	cmp.l	#"F_SK",SECTOR_FNAME(a4)
	bne.s	cancel_linedef_down
	cmp	#"Y1",SECTOR_FNAME+4(a4)
	
	move	#-1,SIDEDEF_LONAME(a1)
	clr	SIDEDEF_LONAME+2(a1)
	clr.l	SIDEDEF_LONAME+4(a1)
	move	#-1,SIDEDEF_LONAME(a3)
	clr	SIDEDEF_LONAME+2(a3)
	clr.l	SIDEDEF_LONAME+4(a3)

	or	#1<<BETWEEN_DNSKY,LINEDEF_ATTRIB(a0)
cancel_linedef_down
	
	; Suivant

cancel_linedef_cont
	lea	SIZEOF_LINEDEF(a0),a0
	dbra	d0,cancel_linedef_bcl

; -------------	Initialise les SSECTORS avec les adresses des SECTORS

	move.l	adr_ssectors,a0
	move.l	num_ssectors,d0
	subq	#1,d0

	move.l	adr_linedefs,a1
	move.l	adr_segs,a2
	move.l	adr_sidedefs,a3
	move.l	adr_sectors,a4
init_ssectors
	move	SSECTOR_STSEG(a0),d1	; premier SEG du SSECTOR
	mulu	#SIZEOF_SEG,d1
	move	SEG_LINEDEF(a2,d1.l),d2
	mulu	#SIZEOF_LINEDEF,d2
	move	LINEDEF_RSIDE(a1,d2.l),d3

	tst	SEG_SIDE(a2,d1.l)
	beq.s	init_ssectors_not_left_side
	move	LINEDEF_LSIDE(a1,d2.l),d3
init_ssectors_not_left_side	
	mulu	#SIZEOF_SIDEDEF,d3
	move	SIDEDEF_SECTOR(a3,d3.l),d1
	mulu	#SIZEOF_SECTOR,d1
	lea	(a4,d1.l),a5
	move.l	a5,SSECTOR_SECTOR(a0)

	lea	SIZEOF_SSECTOR(a0),a0
	dbra	d0,init_ssectors
	moveq	#0,d0
	rts

; -------------	Initialise les objets

Niveau_initobjets
;	bsr	AllocObjects
;	tst	d0
;	bmi	erreur_charger_niveau

	clr.l	num_objects
	move.l	adr_things,a0
	move.l	num_things,d0
	subq	#1,d0
init_things
	move	THING_TYPE(a0),d1
	cmp	#1,d1	; Player 1 start
	beq.s	init_thing_ok
	cmp	#2,d1	; Player 2 start
	beq.s	init_thing_ok
	cmp	#3,d1	; Player 3 start
	beq.s	init_thing_ok
	cmp	#4,d1	; Player 4 start
	beq.s	init_thing_ok
	cmp	#11,d1	; Deathmatch start
	beq.s	init_thing_ok
	cmp	#14,d1	; Teleport land
	beq.s	init_thing_ok

	move	THING_ATTRIB(a0),d1

	btst	#4,d1
	bne	init_thing_nxt

	btst	#0,d1
	beq.s	thing_no_level12
	cmp	#1,game_skill
	beq.s	init_thing_ok
	cmp	#2,game_skill
	beq.s	init_thing_ok
thing_no_level12
	btst	#1,d1
	beq.s	thing_no_level3
	cmp	#3,game_skill
	beq.s	init_thing_ok
thing_no_level3
	btst	#2,d1
	beq.s	init_thing_nxt
	cmp	#4,game_skill
	beq.s	init_thing_ok
	cmp	#5,game_skill
	bne.s	init_thing_nxt
init_thing_ok
	movem.l	d0/a0,-(sp)
	bsr	CreateObject

	cmp	#3,game_type
	bne.s	init_thing_pas_heretic
	move	THING_TYPE(a0),d0
	cmp	#94,d0
	bmi.s	init_thing_pas_heretic
	cmp	#96+1,d0
	bpl.s	init_thing_pas_heretic

	lea	HereticMyGizmo,a1
	move	THING_X(a0),THING_X(a1)
	move	THING_Y(a0),THING_Y(a1)
	move	THING_ANGLE(a0),THING_ANGLE(a1)
	move	#97,THING_TYPE(a1)
	move	THING_ATTRIB(a0),THING_ATTRIB(a1)
	move.l	a1,a0
	bsr	CreateObject

init_thing_pas_heretic
	movem.l	(sp)+,d0/a0
init_thing_nxt
	lea	SIZEOF_THING(a0),a0
	dbra	d0,init_things

	BSS
HereticMyGizmo	ds.w	SIZEOF_THING

; -------------	S'assurer que la lumiere est entre 0 et 255

	TEXT

	move.l	adr_sectors,a0
	move.l	num_sectors,d0
	subq	#1,d0
test_light_bcl
	clr.b	SECTOR_BRIGHT(a0)
	lea	SIZEOF_SECTOR(a0),a0
	dbra	d0,test_light_bcl

; -------------	Initialise les SECTORS avec la lumiere la plus faible autour

	move.l	adr_sectors,a6
	
	move.l	adr_linedefs,a0
	move.l	num_linedefs,d0
	subq	#1,d0
init_light_bcl
	btst	#TWO_SIDED,LINEDEF_ATTRIB+1(a0)
	beq.s	init_light_next
	
	; Cote droit

	move	LINEDEF_RSIDE(a0),d1
	mulu	#SIZEOF_SIDEDEF,d1
	move	(SIDEDEF_SECTOR,[adr_sidedefs],d1.l),d1
	mulu	#SIZEOF_SECTOR,d1
	lea	(a6,d1.l),a1

	; Cote gauche
	
	move	LINEDEF_LSIDE(a0),d2
	mulu	#SIZEOF_SIDEDEF,d2
	move	(SIDEDEF_SECTOR,[adr_sidedefs],d2.l),d2
	mulu	#SIZEOF_SECTOR,d2
	lea	(a6,d2.l),a2

	; si la lumiere actuelle du cote gauche<lumiere basse cote droit
	; alors lbcd=lacg

init_light_droite
	clr	d3
	move.b	SECTOR_LOWLIGHT(a1),d3
	cmp	SECTOR_BRIGHT(a2),d3
	bmi.s	init_light_gauche
	move.b	SECTOR_BRIGHT+1(a2),SECTOR_LOWLIGHT(a1)
	move.b	#-1,SECTOR_LMOVE(a1)

init_light_gauche	
	clr	d3
	move.b	SECTOR_LOWLIGHT(a2),d3
	cmp	SECTOR_BRIGHT(a1),d3
	bmi.s	init_light_next
	move.b	SECTOR_BRIGHT+1(a1),SECTOR_LOWLIGHT(a2)
	move.b	#-1,SECTOR_LMOVE(a2)
	
init_light_next	lea	SIZEOF_LINEDEF(a0),a0
	dbra	d0,init_light_bcl

; -------------	Mettre  zro la LOWLIGHT si pas trouve + recopie niveau max

	move.l	adr_sectors,a0
	move.l	num_sectors,d0
	subq	#1,d0
init_light1_bcl
	move	SECTOR_BRIGHT(a0),SECTOR_HILIGHT(a0)
	move	SECTOR_FLOOR(a0),SECTOR_FLOOR1(a0)
	move	SECTOR_CEILING(a0),SECTOR_CEILING1(a0)

	tst.b	SECTOR_LMOVE(a0)
	bne.s	init_light1_next
	clr.b	SECTOR_LMOVE(a0)
	clr.b	SECTOR_LOWLIGHT(a0)
init_light1_next
	lea	SIZEOF_SECTOR(a0),a0
	dbra	d0,init_light1_bcl
	
; ------------------------------
;	On a fini
; ------------------------------

	TEXT
	
	moveq	#0,d0
	rts
erreur_charger_niveau
	moveq	#-1,d0
	rts

; ------------------------------
;	Initialisation du ciel
; ------------------------------

	TEXT
Niveau_initciel
	lea	nom_ciel,a0
	bsr	cherche_texnum
	tst	d0
	bmi	fin_init_ciel
	move.l	(4,[texture_malloc],d0.w*4),a2

	move.l	ciel_texture,tcache_adr
	clr	tcache_ox
	clr	tcache_oy
	move	#256,tcache_tx
	move	#256,tcache_ty

	lea	8+4+4+4(a2),a2
	move	(a2)+,d0	; nb de patchs
	subq	#1,d0
ciel_bcl_pat
	addq	#4+2,a2
	move.l	(a2)+,a0	; adr virtuelle du patch
	cmp.l	#0,a0
	beq	ciel_nxt_pat

	; Dessine le patch

	movem.l	d0/a2,-(sp)

	move.l	a0,a6
	
	INVERSE_MOT2	a0,d0	; taille x du patch
	cmp	#256,d0
	bmi.s	.skyokx
	move	#256,d0
.skyokx	move	d0,tcache_tx

	INVERSE_MOT2	a0,d1	; taille y du patch
	cmp	#256,d1
	bmi.s	.skyoky
	move	#256,d1
.skyoky	move	d1,tcache_ty

	addq.l	#2+2,a0	; ox , oy
	subq.l	#1,d0

	move	tcache_ox,d1
sky_patch_x
	tst	d1
	bmi.s	next_sky_x
	cmp	tcache_tx,d1
	bpl.s	next_sky_x

	move.l	a0,a2
	INVERSE_LONG2	a2,d7
	lea	(a6,d7.l),a1	; pointeur + adr depart
	
sky_nxpost	moveq	#0,d2
	move.b	(a1)+,d2
	cmp.b	#255,d2
	beq.s	next_sky_x
	
	add	tcache_oy,d2
	move	d2,d3
	lsl	#8,d2
	move.b	d1,d2
	lea	([tcache_adr.l],d2.l),a2

	moveq.l	#0,d2
	move.b	(a1)+,d2
	subq.l	#1,d2
	addq.l	#1,a1	; octet en trop
sky_ligne	
	tst	d3
	bmi.s	sky_ligne1
	cmp	tcache_ty,d3
	bpl.s	sky_ligne1
	
	move.b	(a1),(a2)
sky_ligne1
	addq.l	#1,a1	; on saute un octet
	lea	256(a2),a2	; ligne suivante
	addq.w	#1,d3	; idem pour compter
	dbra	d2,sky_ligne
	addq.l	#1,a1	; octet en trop
	bra.s	sky_nxpost
next_sky_x
	addq.l	#4,a0
	addq	#1,d1
	dbra	d0,sky_patch_x

	movem.l	(sp)+,d0/a2
ciel_nxt_pat
	dbra	d0,ciel_bcl_pat

	; Si la texture <128 de haut alors recopie

	move	#100<<8,ciel_offset
	move	tcache_ty,d0
	cmp	#129,d0
	bpl.s	fin_init_ciel
	clr	ciel_offset
	move.l	ciel_texture,a0
	lea	(256*128.l,a0),a1
	move	#256*128/4-1,d0
ciel_copie	move.l	(a0)+,(a1)+
	dbra	d0,ciel_copie	
fin_init_ciel
	rts

; ------------------------------
;	Remplacer le nom des textures par leur numero
; ------------------------------

	TEXT
Niveau_initsidedefs
	move.l	adr_sidedefs,a0
	move.l	a0,a1
	move.l	num_sidedefs,d2
	subq	#1,d2
level_sidedefs1
	addq	#4,a0
	addq	#4,a1

	; Remplace le nom des textures par leur numero

	; Texture haute

	bsr	cherche_texnum
	lea	8(a0),a0
	move	d0,(a1)+	; Switch off
	move	d1,(a1)+	; Switch on
	clr.l	(a1)+

	; Texture basse

	bsr	cherche_texnum
	lea	8(a0),a0
	move	d0,(a1)+	; Switch off
	move	d1,(a1)+	; Switch on
	clr.l	(a1)+

	; Texture centrale

	bsr	cherche_texnum
	lea	8(a0),a0
	move	d0,(a1)+	; Switch off
	move	d1,(a1)+	; Switch on
	clr.l	(a1)+

	addq	#2,a0
	addq	#2,a1
	dbra	d2,level_sidedefs1
	rts

; -------------	Charge les textures des murs

	TEXT
Niveau_preloadwalls
;	lea	loading_walls,a0
;	bsr	AjoutMessage

;	CCONWS	#loading_walls

	move	#-1,tcache_flag
	move.l	adr_sidedefs,a0
	move.l	num_sidedefs,d1
	subq	#1,d1
sidedef_load_bcl
	movem	SIDEDEF_NAME(a0),d2-d3
	movem	SIDEDEF_UPNAME(a0),d4-d5
	movem	SIDEDEF_LONAME(a0),d6-d7
	
	move.l	a0,-(sp)

	move	d2,d0
	bsr	cherche_texture
	move	d3,d0
	bsr	cherche_texture
	move	d4,d0
	bsr	cherche_texture
	move	d5,d0
	bsr	cherche_texture
	move	d6,d0
	bsr	cherche_texture
	move	d7,d0
	bsr	cherche_texture

	move.l	(sp)+,a0
	lea	SIZEOF_SIDEDEF(a0),a0
	dbra	d1,sidedef_load_bcl
	rts

	DATA
loading_walls	dc.b	"PRELOADING WALL TEXTURES",13,10,0
	even

; -------------	Remplacer les noms des textures par leur adresse

	TEXT
Niveau_preloadfloors	
	move.l	fnames_start,a1
	move.l	fnames_end,a2

	move.l	adr_sectors,a6
	move.l	num_sectors,d7
	subq	#1,d7
floor_load_bcl
	lea	SECTOR_CNAME(a6),a0
	movem.l	(a0),d1-d2
	cmp.l	#"F_SK",d1
	bne.s	floor_ceiling_ok
	cmp.l	#"Y1"<<16,d2
	beq.s	floor_nocname
floor_ceiling_ok
	bsr	cherche_adresse
	move.l	a0,SECTOR_CNAME(a6)
floor_nocname

	lea	SECTOR_FNAME(a6),a0
	movem.l	(a0),d1-d2
	cmp.l	#"F_SK",d1
	bne.s	floor_floor_ok
	cmp.l	#"Y1"<<16,d2
	beq.s	floor_nofname
floor_floor_ok
	bsr	cherche_adresse
	move.l	a0,SECTOR_FNAME(a6)
floor_nofname
	lea	SIZEOF_SECTOR(a6),a6
	dbra	d7,floor_load_bcl

; -------------	Charge les textures des sols/plafonds

;	lea	loading_floors,a0
;	bsr	AjoutMessage

;	CCONWS	#loading_floors

	move.l	adr_sectors,a6
	move.l	num_sectors,d7
	subq	#1,d7
sector_load_bcl
	lea	SECTOR_CNAME(a6),a0
	movem.l	(a0),d1-d2
	tst.l	d1
	beq.s	sector_nocname
	cmp.l	#"F_SK",d1
	bne.s	sector_cname_ok
	cmp.l	#"Y1"<<16,d2
	beq.s	sector_nocname
sector_cname_ok
	move.l	d1,a1	; Adresse des donnes
	move.l	(a1),a1	; Adresse du patch
	tst	(a1)
sector_nocname

	lea	SECTOR_FNAME(a6),a0
	movem.l	(a0),d1-d2
	tst.l	d1
	beq.s	sector_nofname
	cmp.l	#"F_SK",d1
	bne.s	sector_fname_ok
	cmp.l	#"Y1"<<16,d2
	beq.s	sector_nofname
sector_fname_ok
	move.l	d1,a1
	move.l	(a1),a1
	tst	(a1)
sector_nofname
	lea	SIZEOF_SECTOR(a6),a6
	dbra	d7,sector_load_bcl

	rts
	
	DATA
loading_floors	dc.b	"PRELOADING FLOOR TEXTURES",13,10,0
	even

; ------------------------------
;	Libre la mem
; ------------------------------
	
	TEXT
free_level
;	bsr	FreeObjects
	bsr	MfreeObjBlocs

	tst.l	level_malloc
	beq.s	free_level0
	SupXazMfree	level_malloc
	clr.l	level_malloc
free_level0
	tst.l	ciel_texture
	beq.s	free_level1
	SupXazMfree	ciel_texture
	clr.l	ciel_texture
free_level1
	rts
