; ------------------------------
;	Affichage d'un lump
; ------------------------------

	BSS

PrintX	ds.w	1	; Coordonnes ou l'afficher
PrintY	ds.w	1

;PrintMaxX	ds.w	1	; Coordonnes pour le clipping
;PrintMaxY	ds.w	1

; -------------	Affichage d'un lump
;	a0 nom du lump

	TEXT
PrintLump
	; Cherche l'adresse du lump

	movem.l	a1-a2,-(sp)
	move.l	dir_start,a1
	move.l	dir_end,a2
	bsr	cherche_adresse
	movem.l	(sp)+,a1-a2
PrintLumpAdress	
	movem.l	d0-d7/a0-a6,-(sp)
	cmp.l	#0,a0
	beq	PrintLumpStop
	move.l	(a0),a0

	bsr	PrintLumpInfo

	; Afficher le lump

	move.l	a0,a1
	INVERSE_MOT2	a1,d0	; Taille x
	subq	#1,d0

	move.l	affiche1,a2
	move.l	palette,a4
	clr	d3

	move	PrintX,d1
	lea	(a2,d1.w*2),a2
	moveq	#0,d1
PrintLumpBclx
;	tst	d1
;	bmi	PrintLumpBclxNext
;	cmp	PrintMaxX,d1
;	bpl	PrintLumpBclxNext

	lea	8(a0,d1.w*4),a1
	INVERSE_LONG	a1,a6
	move.l	(a6),a1	; Offset de la colonne
	add.l	a0,a1	; + Adresse sprite = adresse colonne

PrintLumpBcly
	clr	d2
	move.b	(a1)+,d2	; Ligne de depart
	cmp.b	#255,d2
	beq.s	PrintLumpBclxNext
	sub	PrintOY,d2
;	IFNE	DOUBLE_PIXEL
;	asr	#1,d2
;	ENDC
	add	PrintY,d2
	mulu	#screenx*2,d2
	lea	(a2,d2.l),a3

	clr	d2
	clr	d4
	move.b	(a1)+,d2	; Nombre de points
	addq	#1,a1
	move	d2,d5
;	IFNE	DOUBLE_PIXEL
;	lsr	#1,d2
;	ENDC
	subq	#1,d2
	bmi.s	PrintLumpBcly2
PrintLumpBcly1
	move.b	(a1,d4.w),d3
	move	(a4,d3.w*4),(a3)
;	IFEQ	DOUBLE_PIXEL
	addq	#1,d4
;	ELSE
;	addq	#2,d4
;	ENDC
	lea	screenx*2(a3),a3
	dbra	d2,PrintLumpBcly1
PrintLumpBcly2
	add	d5,a1
	addq	#1,a1
	bra	PrintLumpBcly

	; Colonne suivante

PrintLumpBclxNext
	addq	#1,d1
	addq	#2,a2
	dbra	d0,PrintLumpBclx	
PrintLumpStop
	movem.l	(sp)+,d0-d7/a0-a6
	rts

; -------------	Informations d'un lump
;	a0 adresse

	TEXT
PrintLumpInfo
	movem.l	a0-a1,-(sp)

	lea	PrintTX,a1
	INVERSE_MOT2	a0,d0
	move	d0,(a1)+	; Taille X
	INVERSE_MOT2	a0,d0
	move	d0,(a1)+	; Taille Y
	INVERSE_MOT2	a0,d0
	move	d0,(a1)+	; Offset X
	INVERSE_MOT2	a0,d0
	move	d0,(a1)+	; Offset Y

	movem.l	(sp)+,a0-a1
	rts

	BSS
PrintTX	ds.w	1
PrintTY	ds.w	1
PrintOX	ds.w	1
PrintOY	ds.w	1

; -------------	Afficher un nombre  trois chiffres
;	d1	Nombre
;	a1	Fonte

	TEXT
PrintNb3
	movem.l	d0/d2-d3/a0,-(sp)

	moveq	#3-1,d2	; 3 Chiffres
	move	#100,d3	; Diviseur
.PrintNb3_bcl
	divu	d3,d1
	move.l	(a1,d1.w*8),a0
	bsr	PrintLumpAdress
	clr	d1
	swap	d1
	divu	#10,d3
	move	PrintTX,d0
	add	d0,PrintX
	dbra	d2,.PrintNb3_bcl

	movem.l	(sp)+,d0/d2-d3/a0
	rts

; -------------	Affichage d'un flat  l'cran (Ecrans de HERETIC)
;	Ecrans 320x200

PrintFlatAdress
	movem.l	d0-d7/a0-a6,-(sp)

	cmp.l	#0,a0
	beq	PrintFlatAdress_stop
	move.l	(a0),a0
	move	#320,PrintTX
	move	#200,PrintTY

	move.l	affiche1,a2
	move.l	palette,a4

	moveq	#0,d2

;	IFEQ	DOUBLE_PIXEL
	move	#200-1,d0
;	ELSE
;	move	#100-1,d0
;	ENDC
PFA_bcly
	move.l	a0,a3
	move	#320-1,d1
PFA_bclx
	move.b	(a3)+,d2
	move	(a4,d2.w*4),(a2)+

	dbra	d1,PFA_bclx
	
;	IFEQ	DOUBLE_PIXEL
	lea	320(a0),a0
;	ELSE
;	lea	320*2(a0),a0
;	ENDC
	
	dbra	d0,PFA_bcly
	
PrintFlatAdress_stop
	movem.l	(sp)+,d0-d7/a0-a6
	rts

; -------------	Affichage d'une chaine de caractres
;	a0	Adresse de dpart des caractres
;	a1	Texte

PrintStringAdress
	movem.l	d0-d7/a0-a6,-(sp)
	move.l	a0,a2

.PSA_bcl	clr	d1
	move.b	(a1)+,d1
	beq.s	.PSA_stop
	moveq	#4,d2
	sub	#33,d1
	bmi.s	.PSA_next
	cmp	TextMax,d1
	bpl.s	.PSA_next
	lsl	#4,d1
	lea	(a2,d1.w),a0
	
	bsr	PrintLumpAdress
	move	PrintTX,d2

.PSA_next	add	d2,PrintX
	bra.s	.PSA_bcl
.PSA_stop
	movem.l	(sp)+,d0-d7/a0-a6
	rts
