; ---------------------------------------------
; 	Init mode video
; ---------------------------------------------

	TEXT
VideoSetScreens
	CCONWS	#textforscreens
	clr.l	ecr_alloc1
	clr.l	ecr_alloc2
	clr	ScreenLock

; -------------	Lecture mode vido courant pour restauration

	VGETMONITOR
	move	d0,v_monitor
	LOGBASE
	move.l	d0,v_base
	VSETMODE	#-1
	move	d0,v_mode

; -------------	Malloc des 2 buffers crans

	XazMxalloc	#screenx*screeny*2+256,#XAZ_STRAM
	move.l	d0,ecr_alloc1
	cmp.l	#XAZ_ERR_MAX,d0
	bhs	VideoErreur
	add.l	#256,d0
	clr.b	d0
	move.l	d0,ecran1

	XazMxalloc	#screenx*screeny*2+256,#XAZ_STRAM
	move.l	d0,ecr_alloc2
	cmp.l	#XAZ_ERR_MAX,d0
	bhs	VideoErreur
	add.l	#256,d0
	clr.b	d0
	move.l	d0,ecran2

; -------------	Vider les ecrans
	
	move.l	ecran1,a0
	move.l	ecran2,a1
	move	#screeny-1,d0
clear_scry	move	#screenx/4-1,d1	
clear_scrx	clr.l	(a0)+
	clr.l	(a0)+
	clr.l	(a1)+
	clr.l	(a1)+
	dbra	d1,clear_scrx
	dbra	d0,clear_scry

	move	#1,ScreenRatioX
	move	#1,ScreenRatioY
	
; -------------	Init mode video

	move	v_mode,d7	
	and	#VGA+PAL,d7
	or	#BPS16,d7
	cmp	#2,v_monitor
	bne.s	not_vga1
;	btst	#4,d7
;	beq.s	not_vga1
	or	#VERTFLAG,d7
not_vga1	
	IFEQ	DEBUG
	SETSCREEN	#-1,ecran1,#-1
	VSETMODE	d7

	SUPER	#0

	cmp	#2,v_monitor	; VGA 320x240 -> 320x200
	bne.s	not_vga2
	add	#80,$ffff82a8.w
	sub	#80,$ffff82aa.w
	add	#80,$ffff82a6.w
	sub	#80,$ffff82a4.w
not_vga2
	move	$ffff8210.w,d1	; Longueur de ligne en 320x200
	add	d1,d1
	move	d1,ScreenLineLen

	SUPER	d0
	ENDC
	
; -------------	Fin init video
	
	moveq	#0,d0
	rts
VideoErreur
	bsr	VideoFreeScreens
	moveq	#-1,d0
	rts

	BSS
ScreenLock	ds.w	1	; 0 on peut changer resolution
;ScreenKeep	ds.w	1	; -1 garder la rsolution de lancement
;ScreenX	ds.w	1
;ScreenY	ds.w	1

; ------------------------------
;	Afficher cran de travail
; ------------------------------

	TEXT
VideoShowScreen
	; Recopier les lignes si VGA et ratioY=2
	
	cmp	#2,v_monitor
	bne.s	RatioY2	

	cmp	#2,ScreenRatioY
	bne.s	RatioY2
	
	move.l	affiche,a0	; Source
	lea	screenx*2(a0),a1	; Destination
	move	ScreenLineLen,d2
	move	resy,d0
	subq	#1,d0
RY_VGA_bcly
	move.l	a0,a2
	move.l	a1,a3
	move	resx,d1
	subq	#1,d1
RY_VGA_bclx
	move	(a2)+,(a3)+
	dbra	d1,RY_VGA_bclx
	add	d2,a0
	add	d2,a1
	dbra	d0,RY_VGA_bcly
RatioY2

	; Afficher ecran

	SETSCREEN	#-1,affiche1,#-1

	; Modifier registres 

	cmp	#2,v_monitor
	beq.s	RatioY1VGA

	cmp	#1,ScreenRatioY
	beq.s	RatioY1RVB
RatioY2RVB
	clr	$ffff8264.w
	move	$ffff8210.w,$ffff820e.w
	move	#1,$ffff82c2.w
	bra.s	RatioY

RatioY1RVB
	clr	$ffff82c2.w
RatioY1VGA
	clr	$ffff8264.w
	clr	$ffff820e.w
RatioY
	rts

; ------------------------------
;	Restaurer ancien cran
; ------------------------------

VideoRestoreScreen
	SETSCREEN	v_base,v_base,#-1
	VSETMODE	v_mode
	rts

; ------------------------------
;	Librer la mmoire des crans
; ------------------------------

VideoFreeScreens
	tst.l	ecr_alloc1
	beq.s	.Notecr1
	XazMfree	ecr_alloc1
	clr.l	ecr_alloc1
.Notecr1
	tst.l	ecr_alloc2
	beq.s	.Notecr2
	XazMfree	ecr_alloc2
	clr.l	ecr_alloc2
.Notecr2
	rts

; -------------	Variables

	DATA
textforscreens	dc.b	"Allocating screens",13,10,0
	even

	BSS

ScreenRatioX	ds.w	1
ScreenRatioY	ds.w	1
ScreenLineLen	ds.w	1

v_monitor	ds.w	1

v_mode	ds.w	1
v_base	ds.l	1
ecran1	ds.l	1
ecran2	ds.l	1
ecr_alloc1	ds.l	1
ecr_alloc2	ds.l	1
