; ---------------------------------------------
;	Gestion mmoire des objets
; ---------------------------------------------

	BSS
object_malloc	ds.l	1	; Adresse premier bloc de 8K
;num_objects	ds.l	1	; Nombre d'objets

; -------------	Un bloc :
;	BLOC *next
;	OBJET objets[MAXOBJPERBLOC]

; ------------------------------
;	Ajouter un objet
; ------------------------------
;	-> a2 Adresse malloce pour l'objet
;	Prendre liste des blocs de 8K
;	Si place dans un bloc alors ok
;	Si pas de place dispo dans un des blocs
;	  Crer un nouveau bloc
;	  Mettre l'objet dans ce bloc
;	-> Renvoyer adresse o mettre l'objet

	TEXT
MallocObjet	
	movem.l	d0/a0-a1,-(sp)

	lea	object_malloc,a1
	move.l	(a1),d0
	beq	MO_ToDo

; -------------	Chercher si place dans un des blocs disponibles

MO_SearchFreeSlot
	move.l	d0,a0
	lea	4(a0),a2
MO_SFS_Next
	move	#MAXOBJPERBLOC-1,d0
MO_SFS_bcl
	tst	OBJET_PRESENT(a2)
	bne	MallocObjet_done

	lea	SIZEOF_OBJET(a2),a2
	dbra	d0,MO_SFS_bcl	

	move.l	(a0),d0
	bne	MO_SearchFreeSlot

; -------------	Malloc un nouveau bloc

MO_ToDo
	SupXazMxalloc	#SIZEOF_BLOCOBJ,#XAZ_PREFTTRAM
	move.l	d0,a0
	cmp.l	#XAZ_ERR_MAX,a0
	bhs	erreur_MallocObjet

; -------------	Chercher le dernier de la liste	pour l'ajouter	

	tst.l	(a1)
	beq	MO_SLB_Done
MO_SearchLastBloc
	move.l	(a1),a1
MO_SLB_Next
	move.l	(a1),d0
	beq.s	MO_SLB_Done
	move.l	d0,a1
	bra.s	MO_SLB_Next
MO_SLB_Done
	move.l	a0,(a1)	

; -------------	Initialiser le bloc et renvoyer adresse

MO_ClearBloc
	clr.l	(a0)
	lea	4(a0),a2
	move.l	a2,a1
	move	#MAXOBJPERBLOC-1,d0
MO_CB_bcl
	move	#-1,OBJET_PRESENT(a1)
	lea	SIZEOF_OBJET(a1),a1
	dbra	d0,MO_CB_bcl
	bra.s	MallocObjet_done

; -------------	Erreur : plus de mmoire

erreur_MallocObjet
	lea	0,a2
MallocObjet_done
	movem.l	(sp)+,d0/a0-a1
	rts

; ------------------------------
;	Supprimer un objet
; ------------------------------
;	a0	Adresse de l'objet
;	Mettre son flag de prsence  -1
;	Si tous les flags du bloc sont  -1
;                 Supprimer le bloc

	TEXT
MfreeObjet	
	move	#-1,OBJET_PRESENT(a0)
	rts

; ------------------------------
;	Librer tous les blocs
; ------------------------------

	TEXT
MfreeObjBlocs
	move.l	object_malloc,d0
	bne.s	MB_next
	rts
MB_next
	move.l	d0,a0
	move.l	4(a0),d0
	SupXazMfree	a0
	tst.l	d0
	bne.s	MB_next
	clr.l	object_malloc
	rts

; ------------------------------
;	Renvoie adresse d'un objet dont on cherche le type
; ------------------------------
;	d0	type de l'objet recherch
;	-> a0	Adresse objet ou zro

	TEXT
SearchObjet	
	lea	object_malloc,a0
SO_SearchBloc
	tst.l	(a0)
	beq.s	SO_notfound
	move.l	(a0),a0	
	lea	4(a0),a1
	move	#MAXOBJPERBLOC-1,d1
SO_bcl
	tst	OBJET_PRESENT(a1)
	bne.s	SO_bcl_next
	move.l	OBJET_THING(a1),a2
	cmp	THING_TYPE(a2),d0
	beq.s	SO_found
SO_bcl_next
	lea	SIZEOF_OBJET(a1),a1
	dbra	d1,SO_bcl	
	bra.s	SO_SearchBloc
SO_found
	move.l	a1,a0
	rts
SO_notfound
	lea	0,a0
	rts
