; ------------------------------
;	Gestion des objets
; ------------------------------

	BSS
num_objects	ds.l	1

; -------------	Cre un objet dans un SSECTOR en l'ajoutant  la liste
;	a0	adresse du THING  crer
;	-> a2	adresse de l'objet cr

	TEXT
CreateObject
	addq.l	#1,num_objects

	; Chercher dans quel SSECTOR il se trouve

	move.l	adr_nodes,a1
	add.l	siz_nodes,a1
	sub.l	#SIZEOF_NODE,a1
	bsr	SearchThingSsector

	and	#$7fff,d0
	move	d0,d7
	mulu	#SIZEOF_SSECTOR,d7
	lea	([adr_ssectors],d7.l),a1

	; Cherche la hauteur du sol

	move	SSECTOR_STSEG(a1),d3
	mulu	#SIZEOF_SEG,d3
	move	(SEG_LINEDEF,[adr_segs],d3.l),d1
	mulu	#SIZEOF_LINEDEF,d1
	move	(LINEDEF_RSIDE,[adr_linedefs],d1.l),d2

	tst	(SEG_SIDE,[adr_segs],d3.l)
	beq.s	co_not_left_side
	move	(LINEDEF_LSIDE,[adr_linedefs],d1.l),d2
co_not_left_side	
	mulu	#SIZEOF_SIDEDEF,d2
	move	(SIDEDEF_SECTOR,[adr_sidedefs],d2.l),d3
	mulu	#SIZEOF_SECTOR,d3
	move	(SECTOR_CEILING,[adr_sectors],d3.l),d4
	move	(SECTOR_FLOOR,[adr_sectors],d3.l),d3
	swap	d3
	clr	d3

	; -------------	Remplir les champs pour le nouvel objet

	bsr	MallocObjet
	cmp.l	#0,a2
	beq	CreateObject_done
;	move.l	object_current,a2

	; Position X

	clr.l	d1
	move	THING_X(a0),d1
	swap	d1
	move.l	d1,OBJET_X(a2)
	move.l	d1,OBJET_X1(a2)

	; Position Y

	clr.l	d1
	move	THING_Y(a0),d1
	swap	d1
	move.l	d1,OBJET_Y(a2)
	move.l	d1,OBJET_Y1(a2)

	; Position Z

	move.l	d3,OBJET_Z(a2)
	move.l	d3,OBJET_Z1(a2)

	; Angle

	move	THING_ANGLE(a0),d1
	mulu	#nb_angles,d1
	divu	#360/4,d1
	and	#-4,d1	
	move	d1,OBJET_A(a2)
	move	d1,OBJET_A1(a2)

	move.l	a0,OBJET_THING(a2)	; THING associ
	move	THING_TYPE(a0),OBJET_TYPE(a2)	; TYPE de l'objet
	move	d0,OBJET_SSECTOR(a2)	; SSECTOR dans lequel se trouve l'objet
	clr.l	OBJET_SPRITE(a2)	; Adresse du sprite
	clr.l	OBJET_LIFE(a2)		; Routine de controle de l'objet
	clr	OBJET_FIXE(a2)
	clr.l	OBJET_NEXT(a2)		; Objet suivant dans la liste

	; -------------	Recherche du sprite de l'objet

	move	OBJET_TYPE(a2),d0
	ble.s	co_nosprite

	jsr	([SrchObjAdrRout])

	mulu	#SIZEOF_SPRITE,d0	; a0 adresse entre
	lea	(a4,d0.l),a4

	move	SPR_HEIGHT(a4),OBJET_H(a2)	; Hauteur
	move	SPR_RADIUS(a4),OBJET_RAYON(a2)	; Rayon
	move.l	SPR_LIFE(a4),OBJET_LIFE(a2)	; Controle
	move	SPR_FIXE(a4),OBJET_FIXE(a2)	; Fixe/mobile

	tst.l	SPR_ENTRY(a4)
	beq.s	co_nosprite
	move.l	SPR_ENTRY(a4),a5
	move.l	(a5),OBJET_SPRITE(a2)
co_nosprite

	; -------------	Le placer au plafond si il le faut

	clr	OBJET_PRESENT(a2)
	
	move	OBJET_TYPE(a2),d1
	jsr	([GraviteRout])
	move	d0,OBJET_GRAVITE(a2)

	move.l	OBJET_SPRITE(a2),a3
	cmp.l	#0,a3
	beq.s	Ssector_GraviteDone

	tst	d0
	beq.s	Ssector_GraviteMid
	cmp	#2,d0
	bne.s	Ssector_GraviteDone

	addq	#2,a3
	INVERSE_MOT2	a3,d0
	sub	d0,d4	; plafond-taille y
	swap	d4
	clr	d4
	move.l	d4,OBJET_Z(a2)
	move.l	d4,OBJET_Z1(a2)
	bra.s	Ssector_GraviteDone
Ssector_GraviteMid
	; OVNI : entre plafond-taille Y et sol
	
	addq	#2,a3
	INVERSE_MOT2	a3,d0
	sub	d0,d4
	swap	d3
	add	d3,d4	; d4=plafond-TY+sol
	asr	#1,d4
	swap	d4
	clr	d4
	move.l	d4,OBJET_Z(a2)
	move.l	d4,OBJET_Z1(a2)
Ssector_GraviteDone

	; -------------	Petite modif pour HERETIC

	cmp	#3,game_type
	bne.s	co_nogizmo
	move	OBJET_TYPE(a2),d0
	cmp	#94,d0
	bmi.s	co_nogizmo
	cmp	#96+1,d0
	bpl.s	co_nogizmo

	add	#51,d3
	move	d3,OBJET_Z(a2)
	move	d3,OBJET_Z1(a2)
co_nogizmo

	; -------------	L'ajouter a la liste des objets du SSECTOR

	move.l	SSECTOR_SPRITES(a1),a3
	cmp.l	#0,a3
	bne.s	Ssector0adr
	move.l	a2,SSECTOR_SPRITES(a1)
	bra.s	Ssector_endinit

Ssector0adr	move.l	a3,a4
	move.l	OBJET_NEXT(a4),a3
	cmp.l	#0,a3
	bne.s	Ssector0adr
	move.l	a2,OBJET_NEXT(a4)
Ssector_endinit	

CreateObject_done
	rts

; -------------	Supprimer un objet
;	a0	adresse de l'objet  dtruire

	TEXT
RemoveObject
	; Le chercher

	move	OBJET_SSECTOR(a0),d0
	mulu	#SIZEOF_SSECTOR,d0
	lea	([adr_ssectors],d0.l),a1
	move.l	SSECTOR_SPRITES(a1),a2
	move.l	a2,a3
	moveq	#0,d0
RemoveObject_bcl
	cmp.l	#0,a2
	beq.s	RemoveObject_stop
	cmp.l	a0,a2
	beq.s	RemoveObject_found
	move.l	a2,a3
	move.l	OBJET_NEXT(a2),a2
	moveq	#-1,d0
	bra.s	RemoveObject_bcl
	
	; Le supprimer
	; a2 adresse objet  supprimer
	; a3 adresse objet prcdent
	; d0=0 si premier objet d'un SSECTOR

RemoveObject_found
	tst	d0
	bne.s	RemoveObject_found1
	move.l	OBJET_NEXT(a2),SSECTOR_SPRITES(a1)
	rts
	
	; a3->a2->X	a3->X

RemoveObject_found1
	move.l	OBJET_NEXT(a2),OBJET_NEXT(a3)

RemoveObject_stop
	rts

; -------------	Dplacer un objet
;	a0	adresse de l'objet  dplacer
;	d0	numero du nouveau SSECTOR

	TEXT
MoveObject
	; Chercher son nouveau SSECTOR

	move.l	adr_nodes,a1
	add.l	siz_nodes,a1
	sub.l	#SIZEOF_NODE,a1
	bsr	SearchObjectSsector

	move	OBJET_SSECTOR(a0),d1
	and	#$7fff,d0
	cmp	d1,d0
	beq.s	MoveObject_cont1

	; L'enlever de l'ancien

	mulu	#SIZEOF_SSECTOR,d1
	lea	([adr_ssectors],d1.l),a1
	move.l	SSECTOR_SPRITES(a1),a2
	moveq	#0,d2
MoveObject_bcl
	cmp.l	#0,a2
	beq.s	MoveObject_cont
	cmp.l	a0,a2
	beq.s	MoveObject_found
	move.l	a2,a3
	move.l	OBJET_NEXT(a2),a2
	moveq	#-1,d2
	bra.s	MoveObject_bcl
	
	; Le supprimer
	; a2 adresse objet  supprimer
	; a3 adresse objet prcdent
	; d2=0 si premier objet d'un SSECTOR

MoveObject_found
	tst	d2
	bne.s	MoveObject_found1
	move.l	OBJET_NEXT(a2),SSECTOR_SPRITES(a1)
	bra.s	MoveObject_cont
	
	; a3->a2->X	a3->X

MoveObject_found1
	move.l	OBJET_NEXT(a2),OBJET_NEXT(a3)

	; Ajouter dans le nouveau
	; d0 nouveau SSECTOR

MoveObject_cont
	move	d0,d2
	mulu	#SIZEOF_SSECTOR,d2
	lea	([adr_ssectors],d2.l),a1
	move.l	SSECTOR_SPRITES(a1),OBJET_NEXT(a0)
	move.l	a0,SSECTOR_SPRITES(a1)
	move	d0,OBJET_SSECTOR(a0)

MoveObject_cont1
	mulu	#SIZEOF_SSECTOR,d0
	move.l	(SSECTOR_SECTOR,[adr_ssectors],d0.l),a1

	cmp	#1,OBJET_GRAVITE(a0)
	bne.s	MoveObject_stop
	
	move	OBJET_Z(a0),d0
	cmp	SECTOR_FLOOR(a1),d0
	ble.s	MoveObject_OnFloor
	subq	#8,d0
	bra.s	MoveObject_OnFloor1
MoveObject_OnFloor
	move	SECTOR_FLOOR(a1),d0
MoveObject_OnFloor1
	move	d0,OBJET_Z(a0)
	move	d0,OBJET_Z1(a0)
MoveObject_stop
	rts

; -------------	Cherche le noeud dans lequel se trouve un objet
;	a0 adresse du THING
;	a1 adresse du node  tracer

	TEXT
SearchThingSsector

	; Calcul pour savoir si THING a gauche ou a droite

	move	NODE_DX(a1),d0	; xv
	move	NODE_DY(a1),d1	; yv
	move	THING_X(a0),d2
	sub	NODE_XC(a1),d2	; xp
	move	THING_Y(a0),d3
	sub	NODE_YC(a1),d3	; yp

	muls	d3,d0
	muls	d2,d1
	
	sub.l	d1,d0
	bpl.s	sts_left_side	; on est a droite: on trace d'abord le gauche

	; On trace le droite

sts_right_side	move	NODE_R_CHILD(a1),d0
	bmi.s	sts_right_ssector
	move.l	adr_nodes,a1
	mulu	#SIZEOF_NODE,d0
	add.l	d0,a1
	bsr	SearchThingSsector
sts_right_ssector
	rts

	; On trace le gauche

sts_left_side	move	NODE_L_CHILD(a1),d0
	bmi.s	sts_left_ssector
	move.l	adr_nodes,a1
	mulu	#SIZEOF_NODE,d0
	add.l	d0,a1
	bsr	SearchThingSsector
sts_left_ssector
	rts

; -------------	Cherche le noeud dans lequel se trouve un objet
;	a0 adresse de l'objet
;	a1 adresse du node  tracer

	TEXT
SearchObjectSsector

	; Calcul pour savoir si THING a gauche ou a droite

	move	NODE_DX(a1),d0	; xv
	move	NODE_DY(a1),d1	; yv
	move	OBJET_X(a0),d2
	sub	NODE_XC(a1),d2	; xp
	move	OBJET_Y(a0),d3
	sub	NODE_YC(a1),d3	; yp

	muls	d3,d0
	muls	d2,d1
	
	sub.l	d1,d0
	bpl.s	sos_left_side	; on est a droite: on trace d'abord le gauche

	; On trace le droite

sos_right_side	move	NODE_R_CHILD(a1),d0
	bmi.s	sos_right_ssector
	move.l	adr_nodes,a1
	mulu	#SIZEOF_NODE,d0
	add.l	d0,a1
	bsr	SearchObjectSsector
sos_right_ssector
	rts

	; On trace le gauche

sos_left_side	move	NODE_L_CHILD(a1),d0
	bmi.s	sos_left_ssector
	move.l	adr_nodes,a1
	mulu	#SIZEOF_NODE,d0
	add.l	d0,a1
	bsr	SearchObjectSsector
sos_left_ssector
	rts

; -------------	Remplacer les noms des objets par :
;	L'adresse de dpart dans le directory
;	Le nombre d'entres avec ce nom
;	a6 adresse liste d'objets
;	d0 Nombre d'objets

	TEXT
InitSprites
	subq	#1,d0
InitSprites_bcl
	move.l	a6,a0	

	move.l	snames_start,a1
	move.l	snames_end,a2
	bsr	cherche_adresse_4	
	move.l	SPR_NAME(a6),d1		; Nom gnral
	move.l	a0,SPR_ENTRY(a6)	; Remplacer par adresse trouve

	cmp.l	#0,a0	; a0 adresse entre
	beq.s	InitSprites_next
	
	; Compter le nombre d'entres dans le directory

	clr	d2
InitSprites_bcl1
	cmp.l	8(a0),d1
	bne.s	InitSprites_bcl1_next
	addq	#1,d2
InitSprites_bcl1_next
	lea	16(a0),a0
	cmp.l	a0,a2
	bpl.s	InitSprites_bcl1
InitSprites_bcl1_stop

	move	d2,SPR_NB(a6)

InitSprites_next
	lea	SIZEOF_SPRITE(a6),a6
	dbra	d0,InitSprites_bcl
	rts

; -------------	Recherche d'un sprite
;	a4	Donnes du sprite
;	d2	char [2] Sous-nom  chercher
;	-> d0	=0 si sens normal,-1 si symetrie
;	-> a2	Adresse de l'entre

	TEXT
SearchSprite
	movem.l	d1-d3,-(sp)
	moveq	#0,d0	; Sens ou on a trouve
	
	move.l	SPR_ENTRY(a4),a2 ; Premiere adresse pour le sprite
	cmp.l	#0,a2
	beq.s	SearchSprite_found	

	move.l	SPR_NAME(a4),d3	; Nom de base
	move	SPR_NB(a4),d1	; Nb d'entres possibles
	subq	#1,d1
SearchSprite_bcl
	cmp.l	8(a2),d3
	bne.s	SearchSprite_next
	cmp	12(a2),d2
	beq.s	SearchSprite_found
	not	d0
	cmp	14(a2),d2
	beq.s	SearchSprite_found
	not	d0
	lea	16(a2),a2
	dbra	d1,SearchSprite_bcl
	bra.s	SearchSprite_found
SearchSprite_next
	lea	16(a2),a2
	bra.s	SearchSprite_bcl
SearchSprite_found
	movem.l	(sp)+,d1-d3
	rts