; ------------------------------
;	DOOM
; ------------------------------
;	DSP : seg : pour calcul x,y pb si denom=0
;	Si une seule colonne  tracer faire moyenne de seg_[xy][12]
;	Lumiere sol/plafond
;	Tri en Z des sprites

	output	dm081.ttp

PLAYER_ONLY	=	-1
PENCHER_TETE	=	-1
DEBUG	=	0
GAME_TIMER_FREQ	=	35

screenx	=	320
screeny	=	200
nb_angles	=	16384

	include	gemdos.s
	include	xbios.s
	include	doom2swa.s
	include	init_app.s
	include	string.i

	include	doom.i
	include	activate.i
	include	menu.i
	include	keyboard.i
	include	demo.i
	include	function.i
	include	objet.i

; ---------------------------------------------
;	C'est parti
; ---------------------------------------------

	TEXT

	START_APP	#4096

; -------------	Chargement 

	CCONWS	#loading_doom
	XazOn
	tst	d0
	bne	fatal_error

	DATA
	
loading_doom	dc.b	27,"H",27,"E",27,"p"
	dc.b	"  DOOM/DOOM2/HERETIC compatible  ",13,10
	dc.b	"       game engine  V0.81        ",13,10
	dc.b	"                                 ",13,10
	dc.b	"   Main code : Patrice MANDIN    ",13,10
	dc.b	" Virtual memory : Xavier JOUBERT ",27,"q"
string_nxt_line	dc.b	13,10,0
	even

; -------------	Chargement du WAD

	TEXT

	IFEQ	DEBUG
	move.l	#BoucleTitlePic,BouclePrincipale
	move.l	#ControleTitlePic,ControleVbl
	ELSE
	move.l	#BoucleChargerNiveau1,BouclePrincipale
	move.l	#ControleNone,ControleVbl
	ENDC

;	move.l	#BoucleInitDemo,BouclePrincipale
;	move.l	#ControleNone,ControleVbl

;	move.l	#BoucleInterScreen,BouclePrincipale
;	move.l	#ControleInterScreen,ControleVbl
;	move	#2,InterSemaphore

	bsr	charger_wad	
	tst	d0
	bmi	error0
	tst	game_type
	beq	error0

	clr.l	texture_cmalloc
	clr.l	level_malloc
	clr.l	demo_malloc
	clr	display_browser
;	clr	ScreenKeep
	move	#1,game_skill

; -------------	Scanne la ligne de commande pour "-wart" : Doom 1 / Heretic

	TEXT

	move	_argc,d1
	subq	#2,d1
	bmi.s	mwart_stop
	lea	(4,[_argv.l]),a0	; char *argv[]
mwart_bcl
	move.l	(a0)+,d0
	beq.s	mwart_stop
	strcmp	d0,#mwart_name
	tst	d0
	bne.s	mwart_nxt
	move.l	(a0)+,a1
	move.b	(a1),game_level+1	; Episode
	move.l	(a0)+,a1
	move.b	(a1),game_level+3	; Level
	move	#-1,pwad_levelfound
	subq	#2,d1
mwart_nxt
	dbra	d1,mwart_bcl
mwart_stop

	DATA
mwart_name	dc.b	"-wart",0
	even

; -------------	Scanne la ligne de commande pour "-browser" : Texture viewer

	TEXT

	move	_argc,d1
	subq	#2,d1
	bmi.s	mbrowser_stop
	lea	(4,[_argv.l]),a0	; char *argv[]
mbrowser_bcl
	move.l	(a0)+,d0
	beq.s	mbrowser_stop
	strcmp	d0,#mbrowser_name
	tst	d0
	bne.s	mbrowser_nxt
	move	#-1,display_browser
mbrowser_nxt	dbra	d1,mbrowser_bcl
mbrowser_stop

	DATA
mbrowser_name	dc.b	"-browser",0
	even

; -------------	Scanne la ligne de commande pour "-warp" : Doom 2/Hexen

	TEXT

	move	_argc,d1
	subq	#2,d1
	bmi.s	mwarp_stop
	lea	(4,[_argv.l]),a0	; char *argv[]
mwarp_bcl
	move.l	(a0)+,d0
	beq.s	mwarp_stop
	strcmp	d0,#mwarp_name
	tst	d0
	bne.s	mwarp_nxt
	move.l	(a0)+,a1
	move.b	(a1)+,game_level+3	; Dizaine
	move.b	(a1),game_level+4	; Unit
	move	#-1,pwad_levelfound
	subq	#1,d1
mwarp_nxt
	dbra	d1,mwarp_bcl
mwarp_stop

	DATA
mwarp_name	dc.b	"-warp",0
	even

; -------------	Scanne la ligne de commande pour "-skill" : niveau de difficult

	TEXT

	move	_argc,d1
	subq	#2,d1
	bmi.s	mskill_stop
	lea	(4,[_argv.l]),a0	; char *argv[]
mskill_bcl
	move.l	(a0)+,d0
	beq.s	mskill_stop
	strcmp	d0,#mskill_name
	tst	d0
	bne.s	mskill_nxt
	move.l	(a0)+,a1
	moveq	#0,d2
	move.b	(a1)+,d2
	sub	#"0",d2
	move	d2,game_skill
	subq	#1,d1
mskill_nxt
	dbra	d1,mskill_bcl
mskill_stop

	DATA
loading_skill	dc.b	"SETTING SKILL LEVEL "
skill_char	ds.w	1
	dc.b	0
mskill_name	dc.b	"-skill",0
	even

; -------------	Si PWAD/Nouveau niveau c'est parti

	TEXT

	tst	pwad_levelfound
	beq.s	.NoNewLevel
	move.l	#BoucleChargerNiveau0,BouclePrincipale
	move.l	#ControleNone,ControleVbl
.NoNewLevel

; -------------	Quelques recherches

	lea	playpal,a6
	move.l	dir_start,a1
	move.l	dir_end,a2
	moveq	#4-1,d0
.boucle	move.l	a6,a0
	bsr	cherche_adresse
	move.l	a0,d1
	moveq	#0,d2
	tst.l	d1
	beq.s	.bouclezero
	movem.l	(a0),d1-d2
.bouclezero	movem.l	d1-d2,(a6)
	addq	#8,a6
	dbra	d0,.boucle

	lea	fnames_start,a6
	move.l	dir_start,a1
	move.l	dir_end,a2
	moveq	#5-1,d0
.boucle1	move.l	a6,a0
	bsr	cherche_adresse
	move.l	a0,(a6)
	addq	#8,a6
	dbra	d0,.boucle1

	DATA
	
fnames_start	dc.b	"F_START",0	; Adresse dans directory
fnames_end	dc.b	"F_END",0,0,0
snames_start	dc.b	"S_START",0
snames_end	dc.b	"S_END",0,0,0
pnames_name	dc.b	"PNAMES",0,0

playpal	dc.b	"PLAYPAL",0	; Adresse virtuelle + longueur
colormap	dc.b	"COLORMAP"
texture1_name	dc.b	"TEXTURE1"
texture2_name	dc.b	"TEXTURE2"
	even

; -------------	Inits pour les textures

	TEXT
	
	bsr	TexturesInitPNAMES
	tst	d0
	bne	error01
	
	bsr	TexturesInitTEXTURES
	tst	d0
	bne	error02	

; -------------	Calcule les palettes magiques
;	34 Palettes de 256 couleurs sur 2 mots TC

	XazMxalloc	#4*34*256,#XAZ_PREFTTRAM
	move.l	d0,palette
	cmp.l	#XAZ_ERR_MAX,d0
	bhs	error1
	move.l	d0,a2

	move.l	playpal,a0
	move.l	colormap,a1

	moveq	#34-1,d0
init_palette
	move	#255,d1
init_pal
	moveq	#0,d2
	move.b	(a1)+,d2
	mulu	#3,d2
	lea	(a0,d2.l),a3

	move.b	(a3)+,d2
	lsr.b	#3,d2
	and	#31,d2
	lsl	#6,d2
	
	move.b	(a3)+,d3
	lsr.b	#2,d3
	and	#63,d3
	or	d3,d2
	lsl	#5,d2

	move.b	(a3),d3
	lsr.b	#3,d3
	and	#31,d3
	or	d3,d2

	move	d2,(a2)+
	move	d2,(a2)+
	dbra	d1,init_pal

	dbra	d0,init_palette	

	BSS
	
palette	ds.l	1	; Palettes colormappes

; -------------	Initialiser la liste des objets

	TEXT

	CCONWS	#TextSprites

	cmp	#3,game_type
	beq.s	HereticInitSprites
DoomInitSprites
	lea	DoomObjects0000,a6
	move	#17*10,d0
	bra.s	InitSprites_done
HereticInitSprites
	lea	HereticObj0000,a6
	move	#15*10,d0
InitSprites_done
	bsr	InitSprites

	DATA
TextSprites	dc.b	"Building sprites list",13,10,0

; -------------	Chargements

	TEXT

	bsr	InitCadre
	bsr	InitWeapons
	jsr	([InitStbarRout])
	jsr	([InitMenuRout])
	jsr	([InitTitlePic])
	jsr	([InitTextFont])
	jsr	([InitInterRout])
	
	; Donnes communes  DOOM et HERETIC

	BSS

StbarSemaphore	ds.w	1	; Rafraichir la barre de status ?
StbarHeight	ds.w	1	; Hauteur de la barre de status

StatusBarRout	ds.l	1	; Affichage de la barre de status
InitStbarRout	ds.l	1	; Inits de la barre de status
InitMenuRout	ds.l	1	; Inits des menus
SrchObjAdrRout	ds.l	1	; Recherche d'un objet par son numro
GraviteRout	ds.l	1	; Teste comment l'objet est soumis  la gravit
WeaponsList	ds.l	1	; Liste des armes

Sante	ds.w	1	; (0-200 %)
Armure	ds.w	1	; (0-200 %)
Couleur	ds.w	1	; Couleur du joueur
Clefs	ds.w	1	; Clefs disponibles
Armes	ds.w	1	; Armes disponibles

MenuActif	ds.w	1	; Menu actif
MenuTable	ds.l	1	; Table des menus
MenuFonte	ds.l	1	; Adresse de la fonte des menus

CurseurGauche	ds.l	1	; Adresse pour curseur
CurseurMil1	ds.l	1
CurseurMil2	ds.l	1
CurseurDroit	ds.l	1
CurseurSprite	ds.l	1

Selector1	ds.l	1	; Slecteur de menu
Selector2	ds.l	1

MouseSense	ds.w	1	; Sensibilit souris
ScreenSize	ds.w	1	; Taille cran
SfxVolume	ds.w	1	; Volume des bruitages
MusVolume	ds.w	1	; Volume des musiques

QuitGame	ds.w	1	; Quitter le jeu ?

NameGame	ds.b	8*8	; Nom des sauvegardes

FieldLeft	ds.l	1	; Champs ditables
FieldCenter	ds.l	1
FieldRight	ds.l	1

InitTextFont	ds.l	1
TextFonte	ds.l	1	; Adresse fonte
TextMax	ds.w	1	; Nb de caractres maxi de la fonte

ScreenDispRout	ds.l	1	; Rout d'affichage 320x200
TitleNb	ds.w	1	; Nb d'crans de titre
TitlePics	ds.l	1	; Ecrans de titre
HelpNb	ds.w	1	; Nb d'crans d'aide
HelpPics	ds.l	1	; Ecran d'aide
InitTitlePic	ds.l	1

InitInterRout	ds.l	1	; Ecran intermdiaire

BouclePrincipale	ds.l	1	; Boucle principale du jeu
ControleVbl		ds.l	1	; Controle  la VBL

game_type	ds.w	1	; 1 DOOM I, 2 DOOM II, 3 HERETIC
game_skill	ds.w	1	; Niveau de difficult

	DATA

loading_level	dc.b	"LOADING LEVEL "
game_level	ds.b	8	; Nom du niveau
	dc.b	0
	even

; -------------	Tables de cosinus/sinus

	TEXT

	CCONWS	#text_tables

	XazMxalloc	#16384*5,#XAZ_PREFTTRAM
	move.l	d0,table_alloc
	cmp.l	#XAZ_ERR_MAX,d0
	bhs	error2
	move.l	#32768,d1
	move.l	#16384,d2
	move.l	d0,a0
	lea	(a0,d1.l),a0
	move.l	a0,sinus
	lea	(a0,d2.l),a0
	move.l	a0,cosinus
	
	lea	table4k,a0
	move.l	d0,a1
	lea	(a1,d2.l),a1
	move.l	a1,a2
	lea	(a2,d1.l),a3
	move.l	a3,a4
	lea	(a4,d1.l),a5

	move	#nb_angles/4-2,d0
bcl_table4k	movem.l	(a0),d1-d2

	move.l	d1,(a4)+
	move.l	d2,-(a3)
	
	neg.l	d1
	move.l	d1,(a2)+
	
	neg.l	d2
	move.l	d2,-(a1)
	move.l	d2,-(a5)

	addq	#4,a0
	dbra	d0,bcl_table4k
	
	neg.l	d2
	move.l	d2,(a4)+
	move.l	d2,(a2)+
	clr.l	-(a1)
	clr.l	-(a3)	
	clr.l	-(a5)
	
	DATA
text_tables	dc.b	"Doing maths",13,10,0
	even

table4k	incbin	cos4k.bin	
	
	BSS
table_alloc	ds.l	1
cosinus	ds.l	1
sinus	ds.l	1

; -------------	Init mode video

	TEXT

	bsr	VideoSetScreens
	tst	d0
	bne	error3

; -------------	Initialisation DSP

	TEXT
	
	DSP_LOCK
	tst	d0
	bne	dsp_inuse
	DSP_REQUESTUNIQUEABILITY
	DSP_EXECPROG	#dsp_prog,#(end_dspprog-dsp_prog)/3,d0
	
	DATA

dsp_prog	INCBIN	doom.p56
end_dspprog
	EVEN
	
	BSS

super_pile	ds.l	1

; -------------	Initialisations du moteur 3D

	TEXT

	bsr	Musique_Clear	; Init pour audio

	SUPER	#0
	move.l	d0,super_pile	; En superviseur pour DSP

	IFEQ	DEBUG
	bsr	Interrupts_init
	ENDC

	move	#screenx,resx
	move	#screeny,resy
	clr	ecr_ligne1

	move	#1<<7,map_zoom1
	move	#8,ScreenSize
	move	#128,MouseSense
	move	#128,SfxVolume
	move	#128,MusVolume
	clr	maponscreen

	move	#2,TitleSemaphore

	clr	vbl_sync
	clr	gamma_correct
	clr	noclippingmode
	clr	display_sprites
	clr	display_menu
	clr	display_weapon
	clr	textured_floors
	clr	textured_walls
	clr	tombraidermode
	move	#-1,display_msg

	clr	QuitGame

	move.l	sys_hz_35,TitleTime
	clr	TitleNum
	
	bsr	InitMessages
	
	clr	DemoNum

	lea	ResolutionStat,a0
	move	StbarHeight,d0
	sub	d0,2(a0)

	clr	DoFunctions
	move.l	game_timer,anim_vbl

	; Browser de textures ?

	tst	display_browser
	beq.s	no_dispbrowser
	move.l	#ControleTextures,ControleVbl
	move.l	#BoucleTextures0,BouclePrincipale
no_dispbrowser
	BSS

reszoom	ds.w	1	
resx	ds.w	1
resy	ds.w	1

ecr_ligne	ds.w	1	; Ligne de vue
ecr_ligne1	ds.w	1

noclippingmode	ds.w	1
tombraidermode	ds.w	1
maponscreen	ds.w	1
gamma_correct	ds.w	1	
display_sprites	ds.w	1
display_weapon	ds.w	1
textured_walls	ds.w	1
textured_floors	ds.w	1

RenderWallRout		ds.l	1
RenderWallTRout		ds.l	1
RenderFloorRout		ds.l	1
RenderCeilingRout	ds.l	1
RenderSpriteRout	ds.l	1
RenderSkyRout		ds.l	1

; ------------------------------
;	Boucle principale
; ------------------------------

	TEXT

	IFEQ	DEBUG
attente	tst	vbl_sync
	beq.s	attente
	ENDC

	move.l	ecran1,a0
	not	ecr_flag
	beq.s	notecran1
	move.l	ecran2,a0
notecran1	move.l	a0,affiche1

	move	#1,petit_point
	move.l	sys_hz_35,game_timer

; -------------	Mise  jour des variables les _1 sont MAJ  chaque vbl

	move	map_zoom1,map_zoom

	BSS
map_zoom1	ds.w	1
game_timer	ds.l	1	; Frquence = 35Hz

; -------------	Changement type d'affichage ?

	TEXT

	tst.b	K_TAB+clavier	; Tab - Affichage de la carte ?
	beq.s	no_tab
	clr.b	K_TAB+clavier
	not	maponscreen
	beq.s	no_tab
	move	#2,CadreSemaphore
	move	#2,StbarSemaphore
no_tab

; -------------	Changement taille ecran ?

	tst	ScreenLock
	bne	ssize_none
	move	ScreenSize,d0

	tst.b	K_PLUS+clavier
	beq.s	ssize_nom
	clr.b	K_PLUS+clavier
	move	#2,CadreSemaphore
	move	#2,StbarSemaphore
	addq	#1,d0
	cmp	#9,d0
	bmi.s	ssize_nop
	moveq	#8,d0
	bra.s	ssize_nop
ssize_nom
	tst.b	K_MINUS+clavier
	beq.s	ssize_nop
	clr.b	K_MINUS+clavier
	move	#2,CadreSemaphore
	move	#2,StbarSemaphore
	subq	#1,d0
	bpl.s	ssize_nop
	moveq	#0,d0
ssize_nop
	move	d0,ScreenSize
ssize_none

; -------------	Touches de fonction

	bsr	TestFunctions

; -------------	Gamma correction

	bsr	GammaCorrection

; -------------	Changement d'arme

	bsr	ChangeWeapons

; -------------	Collision

	TEXT

	tst.b	K_HELP+clavier
	beq.s	no_help
	clr.b	K_HELP+clavier
	lea	text_clip,a0
	not	noclippingmode
	beq.s	no_help1
	lea	text_noclip,a0
no_help1	bsr	AjoutMessage
no_help
	DATA
text_clip	dc.b	"NO CLIPPING MODE OFF",0
text_noclip	dc.b	"NO CLIPPING MODE ON",0
	even

; -------------	Changement d'observateur

	TEXT

;	move.l	num_objects,d0
;	subq.l	#1,d0
;	move	num_obj_obs,d1
;
;	tst.b	K_PLEFT+clavier	; (
;	beq.s	no_up
;	clr.b	K_PLEFT+clavier
;	subq.w	#1,d1
;	bpl.s	no_up
;	move	d0,d1
;no_up	
;	tst.b	K_PRIGHT+clavier ; )
;	beq.s	no_down
;	clr.b	K_PRIGHT+clavier
;	addq.w	#1,d1
;	cmp	d0,d1
;	ble.s	no_down
;	clr	d1
;no_down
;	tst.b	K_SLASH+clavier	; /
;	beq.s	no_slash
;	clr.b	K_SLASH+clavier
;	clr	d1
;no_slash
;	move	d1,num_obj_obs

; -------------	Boucle principale

	jsr	([BouclePrincipale])

; -------------	Affichage des messages

	tst	display_msg
	beq.s	no_disp_msg
	jsr	([DisplayMessages])
no_disp_msg

; -------------	Affichage d'un menu

	tst	display_menu
	beq.s	nodisplaymenu
	bsr	DisplayMenu
nodisplaymenu

; -------------	Affiche le temps

	move	petit_point,d0
	move.l	affiche1,a0
	lea	(screenx-32)*2(a0),a0
	bsr	affiche_nombre

;	move.l	obj_observateur,a1

;	move	OBJET_X(a1),d0
;	move.l	affiche1,a0
;	bsr	affiche_nombre_hexa

;	move	OBJET_Y(a1),d0
;	move.l	affiche1,a0
;	lea	16*5(a0),a0
;	bsr	affiche_nombre_hexa

;	move	LinedefActivate,d0
;	move.l	affiche1,a0
;	bsr	affiche_nombre_hexa

;	move	LinedefActSide,d0
;	move.l	affiche1,a0
;	lea	16*5(a0),a0
;	bsr	affiche_nombre_hexa

;	move	ActivateNb,d0
;	move.l	affiche1,a0
;	lea	16*10(a0),a0
;	bsr	affiche_nombre_hexa

; ------------------------------
;	On permute
; ------------------------------

	IFEQ	DEBUG

	bsr	VideoShowScreen
	clr	vbl_sync

	tst	QuitGame
	beq	attente
	ENDC

	bsr	Musique_Stop
	bsr	DechargerNiveau

	IFEQ	DEBUG
	bsr	Interrupts_restaure
	ENDC
	
	SUPER	super_pile	; Repasse en user

	DSP_UNLOCK
dsp_inuse

	BSS

ecr_flag	ds.w	1
affiche	ds.l	1	; Pour la fenetre 3d
affiche1	ds.l	1	; Pour l'ecran
petit_point	ds.w	1	; Nb de vbls

; ---------------------------------------------
;	Fin
; ---------------------------------------------

	TEXT

	bsr	VideoRestoreScreen
	bsr	VideoFreeScreens
error3	XazMfree	table_alloc
error2	XazMfree	palette
error1	XazMfree	texture_malloc
error02	XazMfree	pnames_malloc
error01	XazMfree	dir_malloc
error0	XazOff
fatal_error	PTERM0		

; ---------------------------------------------
;	Routines diverses
; ---------------------------------------------

	; Interruptions
	
	include	inter\inter.s
	include	inter\35hz.s
	include	inter\clavier.s
	include	inter\video.s
	include	inter\music.s

	; Routines diverses

	include	main\affiche.s	; Affichage nombre dcimal et hexa
	include	main\wadload.s	; Chargement des WADs
	include	main\chername.s	; Recherche d'un nom dans le directory du WAD
	include	main\video.s	; Inits mode vido et crans

	include	main\print.s	; Affichage d'un lump  l'cran
	include	main\cadre.s	; Affichage du cadre si pas plein cran
	include	main\niveau.s	; Initialisation d'un niveau
	include	main\carte.s	; Affichage de la carte
	include	main\menu.s	; Gestion d'un menu
	include	main\gamma.s	; Gamma correction
	include	main\messages.s	; Gestion des messages
	include	main\armes.s	; Gestion des armes
	include	main\function.s	; Touches de fonction

	include	main\col_wall.s	; Test de collision avec les murs
	include	main\activate.s	; Activation (interrupteurs, portes)
	include	main\act_line.s	; Toutes les routines d'activation possibles
	include	main\act_sect.s	; Activations en cours pour les SECTORs

	include	controle\objet.s ; Controle d'un objet
	include	controle\menus.s ; Controle d'un menu
	include	controle\titlepic.s ; Controle d'un ecran titre
	include	controle\demo.s	; Controle d'une dmo
	include	controle\textures.s ; Controle du browser de textures
	include	controle\inter.s

	include	boucles\jeu.s	; Boucle principale du jeu
	include	boucles\titlepic.s ; Boucle principale pour ecran
	include	boucles\niveau.s ; Boucle pour chargement d'un niveau
	include	boucles\demo.s	; Chargement d'une dmo
	include	boucles\textures.s ; Browser de textures murales
	include	boucles\inter.s

	include	objets\objets.s	; Gestion des objets
	include	objets\mem_obj.s ; Gestion mmoire des objets
	include	objets\fixed.s	; Objet fixe
	include	objets\animed.s	; Gestion d'un objet anim (plusieurs sprites)
	include	objets\turnarou.s ; Pour un objet qui prsente plusieurs facettes
	include	objets\pingpong.s ; Anim en ping pong

	include	doom\objets.s	; Objets de DOOM
	include	doom\armes.s	; Armes de DOOM
	include	doom\status.s	; Barre de status de DOOM
	include	doom\menus.s	; Menus de DOOM
	include	doom\music.s	; Musiques de DOOM
	include	doom\titlepic.s
	include	doom\textfont.s
	include	doom\niveaux1.s
	include	doom\niveaux2.s
	include	doom\actions.s
	include	doom\inter.s

	include	heretic\objets.s ; Idem pour HERETIC
	include	heretic\armes.s
	include	heretic\status.s
	include	heretic\menus.s
	include	heretic\music.s
	include	heretic\titlepic.s
	include	heretic\textfont.s
	include	heretic\niveaux.s
	include	heretic\actions.s
	include	heretic\inter.s

	include	textures\textures.s ; Chargement de TEXTURE1-2
	include	textures\pnames.s   ; Chargement des PNAMES
	include	textures\cache.s    ; Cache des textures
	include	textures\anim.s	    ; Animation des textures
	include	textures\switch.s   ; Liste des interrupteurs
	
	; Construction de la scne

	include	build\build.s	; Construction de la scne en mmoire
	include	render\render.s	; Rendu de la scne

	; Rendu de la scne en 1x1

	include	rendr1x1\sprite.s
	include	rendr1x1\sky.s
	include	rendr1x1\ceilflat.s
	include	rendr1x1\sol_flat.s
	include	rendr1x1\mur_flat.s
	include	rendr1x1\murtflat.s
	include	rendr1x1\ceiltext.s
	include	rendr1x1\sol_text.s
	include	rendr1x1\mur_text.s
	include	rendr1x1\murttext.s

	; Rendu de la scne en 2x1

	include	rendr2x1\sprite.s
	include	rendr2x1\sky.s
	include	rendr2x1\ceilflat.s
	include	rendr2x1\sol_flat.s
	include	rendr2x1\mur_flat.s
	include	rendr2x1\murtflat.s
	include	rendr2x1\ceiltext.s
	include	rendr2x1\sol_text.s
	include	rendr2x1\mur_text.s
	include	rendr2x1\murttext.s
