; -------------	Compter le nombre et la taille des textures du niveau
;	Prendre en compte les textures animes

	TEXT
TexturesBuildCache
;	lea	building_cache,a0
;	bsr	AjoutMessage

;	CCONWS	#building_cache

	; Mettre  zro les donnes des textures
	
	tst.l	texture_cmalloc
	beq.s	.OkNoCacheTex
	bsr	free_cachetextures
.OkNoCacheTex
	move.l	texture_malloc,a0
	move.l	(a0)+,d0
	subq	#1,d0
.ClearTmalloc_bcl
	move.l	(a0)+,a1
	clr.l	8(a1)
	dbra	d0,.ClearTmalloc_bcl

	; C'est parti

	clr	texture_n256
	clr	texture_n128
	clr	texture_n64
	tst	CacheForBrowser
	bne	ct_countbrowser

	; Ne compter que les textures du niveau

;	bsr	init_animations
;	bsr	init_switchs

	move.l	adr_sidedefs,a1
	move.l	num_sidedefs,d1
	subq	#1,d1
	addq	#4,a1
ct_count
	move.l	a1,a0
	bsr	ctc_texture
	lea	8(a1),a1
	
	move.l	a1,a0
	bsr	ctc_texture
	lea	8(a1),a1
	
	move.l	a1,a0
	bsr	ctc_texture
	
	lea	8+2+4(a1),a1
	dbra	d1,ct_count
	bra	ct_countstop

	; Compter pour le browser

ct_countbrowser
	move.l	texture_malloc,a0
	move.l	(a0)+,d0
	subq	#1,d0
ct_cb_bcl
	move.l	(a0)+,a1
	move	12(a1),d1	; taille x
ct_cb_x256?
	cmp	#129,d1
	bmi.s	ct_cb_x128?
	addq.w	#1,texture_n256
	bra.s	ct_cb_next
ct_cb_x128?
	cmp	#65,d1
	bmi.s	ct_cb_x64?
	addq.w	#1,texture_n128
	bra.s	ct_cb_next
ct_cb_x64?
	addq.w	#1,texture_n64	
ct_cb_next
	dbra	d0,ct_cb_bcl

	; Fin du compte

ct_countstop

	DATA
building_cache	dc.b	"BUILDING TEXTURES CACHE",13,10,0
	even

	BSS
CacheForBrowser	ds.w	1

; -------------	Mettre sur des multiples de 2 (x128) ou 4 (x64)

	TEXT

	move	texture_n128,d0
	and	#1,d0
	beq.s	ct_ok128
	addq.w	#1,texture_n128
ct_ok128
	move	texture_n64,d0
	and	#3,d0
	beq.s	ct_ok64
	or	#3,texture_n64
	addq.w	#1,texture_n64
ct_ok64

; -------------	Calcule la taille du cache

	SupXazMxalloc	#-1,#XAZ_PREFTTRAM
	move.l	d0,d7
	lsr.l	#1,d7	; Moiti de la RAM libre

	moveq	#1,d6

recalcul_taillecache	

	move	texture_n256,d3	; Nb de blocs utiliss
	move	texture_n128,d4
	lsr	#1,d4
	move	texture_n64,d5
	lsr	#2,d5

	move	texture_n256,d0
	mulu	#256*128+2,d0
	move	texture_n128,d1
	mulu	#256*128+4,d1
	move	texture_n64,d2
	mulu	#256*128+8,d2
	
	add.l	d2,d0
	add.l	d1,d0	; Taille mimimale du cache

	cmp.l	d0,d7	; si le cache n'est pas trop grand : ok
	bpl.s	tcache_ok

	cmp	d6,d3
	bne.s	ctex_min
	cmp	d6,d4
	bne.s	ctex_min
	cmp	d6,d5
	beq	erreur_texturesbuildcache
ctex_min

	; Trouver le nb de blocs le plus lev
	
	cmp	d3,d4
	bpl.s	d4max
	cmp	d3,d5
	bpl.s	d5max
d3max	subq.w	#1,d3	; Au moins un bloc
	bne.s	d3_nzero
	moveq	#1,d3
d3_nzero	move	d3,texture_n256
	bra.s	recalcul_taillecache
	
d4max	cmp	d4,d5
	bpl.s	d5max
	subq.w	#1,d4
	bne.s	d4_nzero
	moveq	#1,d4
d4_nzero	add	d4,d4
	move	d4,texture_n128
	bra.s	recalcul_taillecache

d5max	subq.w	#1,d5
	bne.s	d5_nzero
	moveq	#1,d5
d5_nzero	add	d5,d5
	add	d5,d5
	move	d5,texture_n64
	bra	recalcul_taillecache
tcache_ok

; -------------	On fabrique le cache pour les textures

	move.l	([texture_malloc]),d1	; Nb de textures
	add.l	d1,d1
	add.l	d1,d0

	SupXazMxalloc	d0,#XAZ_PREFTTRAM
	move.l	d0,texture_cmalloc
	beq	erreur_texturesbuildcache
	add.l	d1,d0
	move.l	d0,a0

	moveq	#0,d1
	move	texture_n256,d1
	move.l	a0,texture_ct256
	lea	(a0,d1.w*2),a0
	move.l	a0,texture_ca256
	moveq	#8+7,d0
	lsl.l	d0,d1
	add.l	d1,a0

	moveq	#0,d1
	move	texture_n128,d1
	move.l	a0,texture_ct128
	lea	(a0,d1.w*4),a0
	move.l	a0,texture_ca128
	moveq	#7+7,d0
	lsl.l	d0,d1
	add.l	d1,a0

	moveq	#0,d1
	move	texture_n64,d1
	move.l	a0,texture_ct64
	lea	(a0,d1.w*8),a0
	move.l	a0,texture_ca64
	
	; Init tables

	move.l	texture_ct256,a0
	move	texture_n256,d0
	subq	#1,d0
chtex_initc256	move	#-1,(a0)+
	dbra	d0,chtex_initc256

	move.l	texture_ct128,a0
	move	texture_n128,d0
	lsr	#1,d0
	subq	#1,d0
chtex_initc128	move.l	#-1,(a0)+
	dbra	d0,chtex_initc128

	move.l	texture_ct64,a0
	move	texture_n64,d0
	lsr	#2,d0
	subq	#1,d0
chtex_initc64	move.l	#-1,(a0)+
	move.l	#-1,(a0)+
	dbra	d0,chtex_initc64

	BSS

texture_cmalloc	ds.l	1	; adresse du bloc

texture_n256	ds.w	1
texture_ct256	ds.l	1	; table du cache (numero de la texture dans TEXTUREn)
texture_ca256	ds.l	1	; le cache
texture_n128	ds.w	1
texture_ct128	ds.l	1	; table du cache (numero de la texture dans TEXTUREn)
texture_ca128	ds.l	1	; le cache
texture_n64	ds.w	1
texture_ct64	ds.l	1	; table du cache (numero de la texture dans TEXTUREn)
texture_ca64	ds.l	1	; le cache

; -------------	Calcule les lignes et les colonnes

	TEXT

	clr.l	d5
	clr.l	d6
	clr.l	d7

	move	texture_n256,d2
	move	texture_n128,d3
	lsr	#1,d3
	move	texture_n64,d4
	lsr	#2,d4

	move.l	texture_malloc,a0
	move.l	(a0)+,d0
	subq	#1,d0
chtex_calc_bcl
	move.l	(a0)+,a1	; Adresse donnes d'une texture
	tst	8(a1)	; Texture du niveau ?
	beq.s	chtex_calc_next
	clr.l	8(a1)

	move	12(a1),d1	; taille x

chtex_cl256?	cmp	#129,d1
	bmi.s	chtex_cl128?
	move.l	d5,16(a1)

	moveq	#0,d1
	swap	d5
	move	d5,d1
	addq	#1,d1
	divu	d2,d1
	swap	d1
	move	d1,d5
	swap	d5
	bra.s	chtex_calc_next
chtex_cl128?
	cmp	#65,d1
	bmi.s	chtex_cl64?
	move.l	d6,16(a1)
	move	d6,d1
	addq	#1,d1
	and	#1,d1
	move	d1,d6
	bne.s	chtex_calc_next

	moveq	#0,d1
	swap	d6
	move	d6,d1
	addq	#1,d1
	divu	d3,d1
	swap	d1
	move	d1,d6
	swap	d6
	bra.s	chtex_calc_next
chtex_cl64?
	move.l	d7,16(a1)
	move	d7,d1
	addq	#1,d1
	and	#3,d1
	move	d1,d7
	bne.s	chtex_calc_next

	moveq	#0,d1
	swap	d7
	move	d7,d1
	addq	#1,d1
	divu	d4,d1
	swap	d1
	move	d1,d7
	swap	d7
chtex_calc_next
	dbra	d0,chtex_calc_bcl

; -------------	Table pour animation des textures

	move.l	texture_cmalloc,a0
	move.l	([texture_malloc]),d0
	clr	d1
	subq	#1,d0
chtex_tabanim	move	d1,(a0)+
	addq	#1,d1
	dbra	d0,chtex_tabanim

; -------------	Fin init du cache

	moveq	#0,d0
	rts
erreur_texturesbuildcache
	moveq	#-1,d0
	rts

; -----------------------------------------------------
;	Cache pour les textures
; -----------------------------------------------------
; d0	  numro de la texture dans texture_malloc
; texture_malloc  TEXTUREx
; texture_cachenb nb de lignes de chaque cache
;
; -> a0	adresse des donnes de la texture

	TEXT
cherche_texture
	tst	d0
	bpl.s	ch_tex_num_fin
	lea	0.w,a0
	rts
ch_tex_num_fin
	move	([texture_cmalloc],d0.w*2),d0	; Pour animation
	move.l	(4,[texture_malloc],d0.w*4),a0

; -------------	On teste si la texture est dans le cache
;	d0 numero de la texture
;	a0 adresse des donnes de la texture

	tst.l	8(a0)
	beq.s	chtex_pasdanscache
	lea	8(a0),a0
	rts
	
	BSS
tcache_flag	ds.w	1	; 0 opaque, -1 transparent
tcache_adr	ds.l	1
tcache_tx	ds.w	1
tcache_ty	ds.w	1

tcache_ox	ds.w	1
tcache_oy	ds.w	1

; -------------	Texture pas dans le cache : on la charge

	TEXT
chtex_pasdanscache
;	addq.w	#1,nb_misscache

	movem.l	d1-d7/a1-a6,-(sp)
	move.l	a0,a2

	move	12(a2),d1	; taille x
	movem	16(a2),d2-d3	; Ligne,colonne du cache

chtex_x256?	cmp	#129,d1
	bmi.s	chtex_x128?
	move.l	texture_ct256,a5 ; Table des numeros
	move.l	texture_ca256,a6 ; Buffers
	lea	(a5,d2.w*2),a5
	moveq	#8+7,d4
	lsl.l	d4,d2
	add.l	d2,a6
	bra.s	chtex_finx
chtex_x128?
	cmp	#65,d1
	bmi.s	chtex_x64?
	move.l	texture_ct128,a5
	move.l	texture_ca128,a6
	lea	(a5,d2.w*4),a5
	lea	(a5,d3.w*2),a5
	moveq	#8+7,d4
	lsl.l	d4,d2
	lsl.l	#7,d3
	add.l	d3,d2
	add.l	d2,a6
	bra.s	chtex_finx
chtex_x64?
	move.l	texture_ct64,a5
	move.l	texture_ca64,a6
	lea	(a5,d2.w*8),a5
	lea	(a5,d3.w*2),a5
	moveq	#8+7,d4
	lsl.l	d4,d2
	lsl.l	#6,d3
	add.l	d3,d2
	add.l	d2,a6
chtex_finx

; -------------	Si bloc pas libre il faut le liberer
;	d0 numero de la texture
;	a5 adresse du numero de la texture
;	a6 adresse de la texture

	move	(a5),d2
	bmi.s	chtex_bloclibre
	move.l	(4,[texture_malloc],d2.w*4),a0	; ancienne texture
	clr.l	8(a0)	; hop bloc libre
chtex_bloclibre

; -------------	Vider le buffer si texture transparente

	move.l	#CachePatch_Opaque,Cache_RenderCol
	tst	tcache_flag
	beq.s	chtex_notrans
	move.l	#CachePatch_Trans,Cache_RenderCol

	movem.l	d1-d2/a0/a3,-(sp)

	move.l	a6,a0
	lea	8+4(a2),a1
;	move	2(a1),d1
;	subq	#1,d1
	move	#127,d1
chtex_trans_y	move.l	a0,a3
	move	(a1),d2
	lsr	#2,d2
	subq	#1,d2
chtex_trans_x	clr.l	(a3)+
	dbra	d2,chtex_trans_x
	lea	256(a0),a0
	dbra	d1,chtex_trans_y

	movem.l	(sp)+,d1-d2/a0/a3
chtex_notrans

; -------------	On a un bloc libre yapluka remplir

	lea	8(a2),a2	; nom[8]

	move	d0,(a5)	; Met le numero de la texture
	move.l	a6,(a2)+	; Et l'adresse
	move.l	a6,tcache_adr
	move	(a2)+,tcache_tx
	move	(a2)+,tcache_ty
	addq	#4,a2
	move	(a2)+,d0	; nb de patchs
	subq	#1,d0
chtex_bcl_pat
	move	(a2)+,d1	; offset x
	move	(a2)+,tcache_oy	; offset y
	addq.l	#2,a2
	move.l	(a2)+,a0	; adr virtuelle du patch
	cmp.l	#0,a0
	beq.s	chtex_nxt_pat
	bsr.s	cache_patch
chtex_nxt_pat
	dbra	d0,chtex_bcl_pat
	lea	tcache_adr,a0
	movem.l	(sp)+,d1-d7/a1-a6
	rts

; -------------	Trace un patch (params ci dessus)
;	d0 = boucle appel
;	a0 = adresse virtuelle patch
;	a2 = adresse texture
;	a6 = tcache_adr

cache_patch	move.l	a0,a5
	
	INVERSE_MOT2	a0,d7	; Taille x du patch
	addq.l	#2+2+2,a0	; ty , ox , oy
	subq.l	#1,d7
cache_patch_x
	tst	d1
	bmi.s	next_patch_x
	cmp	tcache_tx,d1
	bpl.s	next_patch_x

	move.l	a0,a4
	INVERSE_LONG2	a4,d6
	lea	(a5,d6.l),a1	; pointeur + adr depart
	
cache_nxpost	moveq	#0,d2
	move.b	(a1)+,d2
	cmp.b	#255,d2
	beq.s	next_patch_x
	
	add	tcache_oy,d2
	move	d2,d3
	lsl	#8,d2
	move.b	d1,d2
	lea	(a6,d2.w),a4

	moveq.l	#0,d2
	move.b	(a1)+,d2
	subq.l	#1,d2
	addq.l	#1,a1
	jsr	([Cache_RenderCol])
	addq.l	#1,a1
	bra.s	cache_nxpost
next_patch_x
	addq.l	#4,a0
	addq	#1,d1
	dbra	d7,cache_patch_x
fin_cache_patch	
	rts

; -------------	Tracer une colonne opaque
;	a1 Source
;	a4 Destination
;	d3 Offset y
;	d2 Boucle

CachePatch_Opaque
	tst	d3
	bmi.s	CachePatch_NoOpaque
	cmp	tcache_ty,d3
	bpl.s	CachePatch_NoOpaque
	move.b	(a1),(a4)
CachePatch_NoOpaque
	addq.l	#1,a1	; on saute un octet
	lea	256(a4),a4	; ligne suivante
	addq.w	#1,d3	; idem pour compter
	dbra	d2,CachePatch_Opaque
	rts

; -------------	Tracer une colonne transparente
;	a1 Source
;	a4 Destination
;	d3 Offset y
;	d2 Boucle

CachePatch_Trans
	tst	d3
	bmi.s	CachePatch_NoTrans
	cmp	tcache_ty,d3
	bpl.s	CachePatch_NoTrans
	move.b	(a1),d5
	bne.s	CachePatch_NoTrans1
	moveq	#1,d5
CachePatch_NoTrans1
	move.b	d5,(a4)
CachePatch_NoTrans
	addq.l	#1,a1	; on saute un octet
	lea	256(a4),a4	; ligne suivante
	addq.w	#1,d3	; idem pour compter
	dbra	d2,CachePatch_Trans
	rts

	BSS
Cache_RenderCol	ds.l	1

; ------------------------------
;	Cherche taille texture
; ------------------------------
;	a0	Nom de la texture

	TEXT
ctc_texture
	movem.l	d0-d5/a0-a1,-(sp)

	bsr	cherche_texnum
	tst	d0
	bmi.s	ctc_count_fin
	moveq	#0,d4
	move	d0,d6
	move	anim_wall_max,d1
	beq.s	ctc_one

; -------------	Texture dans une animation

	subq	#1,d1
	lea	anim_wall_nb,a1
ctc_testanim_bcl
	movem	(a1)+,d2-d3	; d2 Numro 1st texture
	add	d2,d3	; d3 Nb last texture

	; Si d2<=d0<=d3 alors compter les textures d2  d3

	moveq	#1-1,d4	; Nb de textures  traiter
	move	d0,d6

	cmp	d2,d6
	blt.s	ctc_one
	cmp	d3,d6
	bgt.s	ctc_one
	move	d2,d6
	move	d3,d4
	sub	d6,d4
;	bra.s	ctc_one
ctc_one
	bsr	ctc_validetexture
	addq	#1,d6
	dbra	d4,ctc_one

ctc_count_next	dbra	d1,ctc_testanim_bcl

; -------------	Texture interrupteur ?
;	d0 Nb texture

	lea	ListeSwitchs,a1
	move	SwitchsNb,d1
	subq	#1,d1
ctc_switch_bcl
	cmp	(a1),d0
	beq.s	ctc_switch_yes
	cmp	4(a1),d0
	bne.s	ctc_switch_next
ctc_switch_yes
	move	d0,d6
	bsr	ctc_validetexture
	move	4(a1),d6
	bsr	ctc_validetexture
ctc_switch_next
	addq	#8,a1
	dbra	d1,ctc_switch_bcl

; -------------	Fin comptage texture

ctc_count_fin	movem.l	(sp)+,d0-d5/a0-a1
	rts

; -------------	Mettre -1 et compter la texture
;	d6	Numro de la texture
;	utilise d5,a0

ctc_validetexture
	move.l	(4,[texture_malloc],d6.w*4),a0
	tst	8(a0)	; texture dj compte ?
	bne.s	ctc_vt_end
	
	move	#-1,8(a0)
	move	12(a0),d5	; x

ctc_x256?	cmp	#129,d5
	bmi.s	ctc_x128?
	addq.w	#1,texture_n256
	rts

ctc_x128?	cmp	#65,d5
	bmi.s	ctc_x64?
	addq.w	#1,texture_n128
	rts

ctc_x64?	addq.w	#1,texture_n64
ctc_vt_end	rts

; ------------------------------
;	Librer le cache de textures
; ------------------------------

	TEXT
free_cachetextures
	tst.l	texture_cmalloc
	beq.s	.nocachetex
	SupXazMfree	texture_cmalloc
	clr.l	texture_cmalloc
.nocachetex	rts
