; ------------------------------------------------
;	Init pour les donnes des textures	
; ------------------------------------------------

	TEXT
TexturesInitTEXTURES
	lea	texture1_name,a0
	tst.l	(a0)
	beq	erreur_charger_textures
	move.l	(a0),texture1_adr
	move.l	4(a0),texture_length	; longueur de TEXTURE1

	lea	texture2_name,a0
	tst.l	(a0)
	beq.s	no_texture2
	move.l	(a0),texture2_adr
	move.l	4(a0),d0
	add.l	d0,texture_length	; + long. de TEXTURE2
	subq.l	#4,texture_length
no_texture2
	XazMxalloc	texture_length,#XAZ_PREFTTRAM
	move.l	d0,texture_malloc
	cmp.l	#XAZ_ERR_MAX,d0
	bhs	erreur_charger_textures

	move.l	texture1_adr,a0
	INVERSE_LONG2	a0,d0
	move.l	texture2_adr,a0
	cmp.l	#0,a0
	beq.s	no_texture2_1
	INVERSE_LONG2	a0,d1
	add.l	d1,d0
no_texture2_1
	move.l	d0,texture_nb	; nb de textures
	move.l	d0,([texture_malloc.l])

	BSS

texture_malloc	ds.l	1	; Adr relle de TEXTURE1[+TEXTURE2]
texture_length	ds.l	1	; Longueur de TEXTURE1[+TEXTURE2]
texture_nb	ds.l	1	; Nb de textures dans TEXTURE1[+TEXTURE2]

texture1_adr	ds.l	1	; Adr virtuelles
texture2_adr	ds.l	1

; -------------	On copie texture1_adr et texture2_adr dans texture_malloc au format motorola

	TEXT

	CCONWS	#reading_texture1

	move.l	texture_nb,d0
	lea	(4.l,[texture_malloc.l]),a1
	lea	(a1,d0.l*4),a5
	move.l	texture1_adr,a0
	bsr.s	make_textures

	tst.l	texture2_adr
	beq.s	chargetex_notxt2
	movem.l	d0-d7/a0-a6,-(sp)
	CCONWS	#reading_texture2
	movem.l	(sp)+,d0-d7/a0-a6
	move.l	texture2_adr,a0
	bsr.s	make_textures
chargetex_notxt2

	DATA
reading_texture1
	dc.b	"Reading TEXTURE1",13,10,0
reading_texture2
	dc.b	"Reading TEXTURE2",13,10,0
	even

; -------------	Initialisation termine

	TEXT

	bsr	init_animations
	bsr	init_switchs

	moveq	#0,d0
	rts

erreur_charger_textures
	moveq	#-1,d0
	rts	

; -------------	Une tite routine
;	a0	textures_adr
;	a5	Nouvelle adresse

	TEXT

make_textures
	move.l	a0,maketex_adr

	INVERSE_LONG2	a0,d0
	subq	#1,d0
copie_texture
	move.l	a5,(a1)+ ; Nlle adr texture
	move.l	a5,a3

	INVERSE_LONG2	a0,d1	; Adresse des donnes de la texture

	lea	([maketex_adr],d1.l),a2

	; Convertir le nom a2->a3

;	move.l	(a2)+,(a3)+	; nom
;	move.l	(a2)+,(a3)+

	clr.l	(a3)
	clr.l	4(a3)
	move.l	a2,a4
	move.l	a3,a5
	moveq	#7,d1
MakeTex_bcl
	move.b	(a4)+,d2
	beq.s	MakeTex_bcl_stop
	cmp.b	#"a",d2
	bmi.s	MakeTex_bcl_next
	cmp.b	#"z"+1,d2
	bpl.s	MakeTex_bcl_next
	add.b	#"A"-"a",d2
MakeTex_bcl_next
	move.b	d2,(a5)+
	dbra	d1,MakeTex_bcl
MakeTex_bcl_stop
	addq	#8,a2
	addq	#8,a3

	; Suite

	addq	#4,a2	; 0.l
	clr.l	(a3)+	; -> Adresse de la texture

	INVERSE_MOT2	a2,d1
	moveq	#1,d6
coptex_valx2	cmp	d6,d1
	ble.s	coptex_stopx2
	add	d6,d6
	bra.s	coptex_valx2
coptex_stopx2	move	d6,(a3)+	; taille x (multiple d'un puiss. de 2 )

	INVERSE_MOT2	a2,d1
	move	d1,(a3)+	; taille y
	
	addq	#4,a2	; 0.w, 0.w
	clr.l	(a3)+	; -> Ligne, colonne dans le cache

	INVERSE_MOT2	a2,d1
	move	d1,(a3)+	; nb de patchs
	subq	#1,d1
copie_texture_patch
	INVERSE_LONG2	a2,d2
	swap	d2
	move.l	d2,(a3)+	; offsets x et y
	INVERSE_MOT2	a2,d2
	move	d2,(a3)+	; numero patch

	movem.l	a0-a2,-(sp)

	lea	(4.l,[pnames_malloc],d2.w*8),a0	; nom du patch
	move.l	dir_start,a1
	move.l	dir_end,a2
	bsr	cherche_adresse
	lea	0.w,a4
	cmp.l	#0,a0
	beq.s	chtex_notzero
	move.l	(a0),a4
chtex_notzero
	movem.l	(sp)+,a0-a2

	addq	#4,a2	; Adresse du patch
	move.l	a4,(a3)+
	dbra	d1,copie_texture_patch

	move.l	a3,a5
	dbra	d0,copie_texture
	rts

	BSS
	
maketex_adr	ds.l	1

; ------------------------------
;	Cherche le numero d'une texture
; ------------------------------
;	a0	Nom de la texture
;	d0	Numro de la texture
;	d1	Numro de la texture pour switch on

	TEXT
cherche_texnum
	movem.l	d2-d3/a0-a2,-(sp)

; -------------	met le nom en majuscule

	lea	ch_tex_name,a1
	clr.l	(a1)
	clr.l	4(a1)
	
	moveq	#7,d0
ch_tex_bcl1	move.b	(a0)+,d1
	beq.s	ch_tex_endcase
	cmp.b	#"a",d1
	bmi.s	ch_tex_next
	cmp.b	#"z"+1,d1
	bpl.s	ch_tex_next
	add.b	#"A"-"a",d1
ch_tex_next
	move.b	d1,(a1)+
	dbra	d0,ch_tex_bcl1
	
	BSS
	
ch_tex_name	ds.b	8

; -------------	Trouver le numero de la texture dans TEXTUREx

	TEXT
ch_tex_endcase
	lea	ch_tex_name,a0
	move.l	texture_malloc,a1
	move.l	(a1)+,d1
	subq.l	#1,d1
	moveq	#0,d0	; numero de la texture
ch_tex_bcl	
	move.l	(a1)+,a2	; offset
	movem.l	(a2),d2-d3

	cmp.l	(a0),d2
	bne.s	ch_tex_bcl_next
	cmp.l	4(a0),d3
	beq.s	ch_tex_bcl_stop
ch_tex_bcl_next
	addq	#1,d0
	dbra	d1,ch_tex_bcl
	moveq	#-1,d0
ch_tex_bcl_stop

; -------------	Si c'est un switch on cherche la texture correspondante

	move	d0,d1
	bmi.s	ch_tex_swi_found
	
	lea	ListeSwitchs,a1
	move	SwitchsNb,d2
	subq	#1,d2
ch_tex_swi_bcl
	cmp	(a1),d0
	beq.s	ch_tex_swi_yes1
	cmp	4(a1),d0
	bne.s	ch_tex_swi_next
ch_tex_swi_yes2
	move	(a1),d1
	bra.s	ch_tex_swi_found
ch_tex_swi_yes1
	move	4(a1),d1
	bra.s	ch_tex_swi_found

ch_tex_swi_next	addq	#8,a1
	dbra	d2,ch_tex_swi_bcl

; -------------	Texture trouve

ch_tex_swi_found
	movem.l	(sp)+,d2-d3/a0-a2
	rts
